Description: <short summary of the patch>
 TODO: Put a short summary on the line above and replace this paragraph
 with a longer explanation of this change. Complete the meta-information
 with other relevant fields (see below for details). To make it easier, the
 information below has been extracted from the changelog. Adjust it or drop
 it.
 .
 djvulibre (3.5.27.1-8) unstable; urgency=medium
 .
   * track upstream updates
   * bump policy, no changes required
   * use dh10 defaults in debian/rules
   * remove now-autogenerated debian/control -dbg stanza
   * secure repo url
Author: Barak A. Pearlmutter <bap@debian.org>

---
The information above should follow the Patch Tagging Guidelines, please
checkout http://dep.debian.net/deps/dep3/ to learn about the format. Here
are templates for supplementary fields that you might want to add:

Origin: <vendor|upstream|other>, <url of original patch>
Bug: <url in upstream bugtracker>
Bug-Debian: https://bugs.debian.org/<bugnumber>
Bug-Ubuntu: https://launchpad.net/bugs/<bugnumber>
Forwarded: <no|not-needed|url proving that it has been forwarded>
Reviewed-By: <name and email of someone who approved the patch>
Last-Update: 2017-10-09

--- djvulibre-3.5.27.1.orig/COPYING
+++ djvulibre-3.5.27.1/COPYING
@@ -1,12 +1,12 @@
-		    GNU GENERAL PUBLIC LICENSE
-		       Version 2, June 1991
+                    GNU GENERAL PUBLIC LICENSE
+                       Version 2, June 1991
 
- Copyright (C) 1989, 1991 Free Software Foundation, Inc.
-     59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ Copyright (C) 1989, 1991 Free Software Foundation, Inc.,
+ 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
  Everyone is permitted to copy and distribute verbatim copies
  of this license document, but changing it is not allowed.
 
-			    Preamble
+                            Preamble
 
   The licenses for most software are designed to take away your
 freedom to share and change it.  By contrast, the GNU General Public
@@ -15,7 +15,7 @@ software--to make sure the software is f
 General Public License applies to most of the Free Software
 Foundation's software and to any other program whose authors commit to
 using it.  (Some other Free Software Foundation software is covered by
-the GNU Library General Public License instead.)  You can apply it to
+the GNU Lesser General Public License instead.)  You can apply it to
 your programs, too.
 
   When we speak of free software, we are referring to freedom, not
@@ -55,8 +55,8 @@ patent must be licensed for everyone's f
 
   The precise terms and conditions for copying, distribution and
 modification follow.
-
-		    GNU GENERAL PUBLIC LICENSE
+
+                    GNU GENERAL PUBLIC LICENSE
    TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
 
   0. This License applies to any program or other work which contains
@@ -110,7 +110,7 @@ above, provided that you also meet all o
     License.  (Exception: if the Program itself is interactive but
     does not normally print such an announcement, your work based on
     the Program is not required to print an announcement.)
-
+
 These requirements apply to the modified work as a whole.  If
 identifiable sections of that work are not derived from the Program,
 and can be reasonably considered independent and separate works in
@@ -168,7 +168,7 @@ access to copy from a designated place,
 access to copy the source code from the same place counts as
 distribution of the source code, even though third parties are not
 compelled to copy the source along with the object code.
-
+
   4. You may not copy, modify, sublicense, or distribute the Program
 except as expressly provided under this License.  Any attempt
 otherwise to copy, modify, sublicense or distribute the Program is
@@ -225,7 +225,7 @@ impose that choice.
 
 This section is intended to make thoroughly clear what is believed to
 be a consequence of the rest of this License.
-
+
   8. If the distribution and/or use of the Program is restricted in
 certain countries either by patents or by copyrighted interfaces, the
 original copyright holder who places the Program under this License
@@ -255,7 +255,7 @@ make exceptions for this.  Our decision
 of preserving the free status of all derivatives of our free software and
 of promoting the sharing and reuse of software generally.
 
-			    NO WARRANTY
+                            NO WARRANTY
 
   11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY
 FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW.  EXCEPT WHEN
@@ -277,9 +277,9 @@ YOU OR THIRD PARTIES OR A FAILURE OF THE
 PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE
 POSSIBILITY OF SUCH DAMAGES.
 
-		     END OF TERMS AND CONDITIONS
-
-	    How to Apply These Terms to Your New Programs
+                     END OF TERMS AND CONDITIONS
+
+            How to Apply These Terms to Your New Programs
 
   If you develop a new program, and you want it to be of the greatest
 possible use to the public, the best way to achieve this is to make it
@@ -291,7 +291,7 @@ convey the exclusion of warranty; and ea
 the "copyright" line and a pointer to where the full notice is found.
 
     <one line to give the program's name and a brief idea of what it does.>
-    Copyright (C) 19yy  <name of author>
+    Copyright (C) <year>  <name of author>
 
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
@@ -303,17 +303,16 @@ the "copyright" line and a pointer to wh
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
 
-    You should have received a copy of the GNU General Public License
-    along with this program; if not, write to the Free Software
-    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
+    You should have received a copy of the GNU General Public License along
+    with this program; if not, write to the Free Software Foundation, Inc.,
+    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 
 Also add information on how to contact you by electronic and paper mail.
 
 If the program is interactive, make it output a short notice like this
 when it starts in an interactive mode:
 
-    Gnomovision version 69, Copyright (C) 19yy name of author
+    Gnomovision version 69, Copyright (C) year name of author
     Gnomovision comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
     This is free software, and you are welcome to redistribute it
     under certain conditions; type `show c' for details.
@@ -336,5 +335,5 @@ necessary.  Here is a sample; alter the
 This General Public License does not permit incorporating your program into
 proprietary programs.  If your program is a subroutine library, you may
 consider it more useful to permit linking proprietary applications with the
-library.  If this is what you want to do, use the GNU Library General
+library.  If this is what you want to do, use the GNU Lesser General
 Public License instead of this License.
--- djvulibre-3.5.27.1.orig/NEWS
+++ djvulibre-3.5.27.1/NEWS
@@ -3,6 +3,12 @@ NEW IN VERSION 3.5.27
 - simplified configuration scripts
 - deadlock fixes
 - miniexp under win32 uses tlsalloc instead of _thread vars (pb under xp)
+- djvudigital can extract text and metadata using pdftotext.
+- duplicate page titles are accepted
+- bug fixes: overflow in bitmap/pixmap/iw44image sizes
+- big fixes: handling INCL chunks in djvumake
+- bug fixes: better support for large files (2gb) 
+
 
 NEW IN VERSION 3.5.26
 ------------------------
--- djvulibre-3.5.27.1.orig/config/acinclude.m4
+++ djvulibre-3.5.27.1/config/acinclude.m4
@@ -16,8 +16,7 @@ dnl MERCHANTABILITY or FITNESS FOR A PAR
 dnl GNU General Public License for more details.
 dnl
 dnl You should have received a copy of the GNU General Public License
-dnl along with this program; if not, write to the Free Software
-dnl Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA02111 USA
+dnl along with this program.  If not, see <http://www.gnu.org/licenses/>.
 dnl
 
 dnl -------------------------------------------------------
--- djvulibre-3.5.27.1.orig/config/pkg.m4
+++ djvulibre-3.5.27.1/config/pkg.m4
@@ -14,8 +14,7 @@
 # General Public License for more details.
 #
 # You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #
 # As a special exception to the GNU General Public License, if you
 # distribute this file as part of a program that contains a
--- djvulibre-3.5.27.1.orig/configure.ac
+++ djvulibre-3.5.27.1/configure.ac
@@ -41,7 +41,7 @@ AC_CONFIG_SRCDIR(libdjvu/ddjvuapi.cpp)
 AC_CONFIG_HEADER(config.h:config/config.h.in)
 AC_CANONICAL_HOST
 
-AM_INIT_AUTOMAKE([1.6 subdir-objects dist-bzip2 dist-xz])
+AM_INIT_AUTOMAKE([1.6 subdir-objects dist-bzip2 dist-xz -Wall])
 m4_ifdef([AM_SILENT_RULES], [AM_SILENT_RULES([yes])])
 m4_ifdef([AM_PROG_AR], [AM_PROG_AR])
 
--- djvulibre-3.5.27.1.orig/desktopfiles/Makefile.am
+++ djvulibre-3.5.27.1/desktopfiles/Makefile.am
@@ -61,7 +61,7 @@ else
 endif
 
 svg_process =\
-cat $< | gzip >$@
+cat $< | gzip -n >$@
 
 svg_verbose = $(svg_verbose_@AM_V@)
 svg_verbose_ = $(svg_verbose_@AM_DEFAULT_V@)
--- djvulibre-3.5.27.1.orig/doc/djvuchanges.txt
+++ djvulibre-3.5.27.1/doc/djvuchanges.txt
@@ -39,6 +39,15 @@ To maximize compatibility with earlier v
 values different from {1,6,2,5} should be ignored
 and interpreted as 1 : rightside up orientation.
 
+1.4- ORDERING OF THE DJBZ AND SJBZ CHUNK
+
+Although the specification does not make it clear, when a FORM:DJVU chunk
+contains a bitonal image represented by a Sjbz chunk that uses a shape
+dictionary represented by a Djbz chunk, the Djbz chunk must appear before the
+Sjbz chunk that references it.  This also holds when the chunks is accessed
+indirectly via INCL chunks. For instance, an INCL chunk that refers to a
+shared Djbz shape dictionary must be placed before the corresponding Sjbz
+chunk.
 
 
 2- ESCAPE SEQUENCES IN ANNOTATION CHUNK STRINGS.
@@ -130,7 +139,7 @@ DjVuLibre has introduced metadata annota
 Metadata entries for each page are represent by key/value pairs
 located in a metadata directive in the annotation chunk.
 Metadata entries for the document are represented similarly
-using the methods described in the next section.
+using the methods described in the section 4.3.
 
 The metadata directive has the form
 
--- djvulibre-3.5.27.1.orig/doc/minilisp/minilisp.cpp
+++ djvulibre-3.5.27.1/doc/minilisp/minilisp.cpp
@@ -675,10 +675,12 @@ DEFUN("/",div,1,9999) {
   while (i<argc && miniexp_doublep(argv[i]) && miniexp_to_double(argv[i]))
     s /= miniexp_to_double(argv[i++]);
   if (i < argc)
-    if (miniexp_doublep(argv[i]))
-      error("/: division by zero", argv[i]);
-    else
-      error("/: number expected", argv[i]);
+    {
+      if (miniexp_doublep(argv[i]))
+        error("/: division by zero", argv[i]);
+      else
+        error("/: number expected", argv[i]);
+    }
   return miniexp_double(s);
 }
 
@@ -690,14 +692,25 @@ static bool
 equal(miniexp_t a, miniexp_t b)
 {
   if (a == b)
-    return true;
+    {
+      return true;
+    }
   else if (miniexp_consp(a) && miniexp_consp(b))
-    return equal(miniexp_car(a),miniexp_car(b))
-      &&   equal(miniexp_cdr(a),miniexp_cdr(b));
-  else if (miniexp_stringp(a) && miniexp_stringp(b))
-    return !strcmp(miniexp_to_str(a), miniexp_to_str(b));
+    {
+      return equal(miniexp_car(a),miniexp_car(b))
+        && equal(miniexp_cdr(a),miniexp_cdr(b));
+    }
   else if (miniexp_doublep(a) && miniexp_doublep(b))
-    return miniexp_to_double(a) == miniexp_to_double(b);
+    {
+      return miniexp_to_double(a) == miniexp_to_double(b);
+    }
+  else if (miniexp_stringp(a) && miniexp_stringp(b)) 
+    {
+      const char *sa, *sb;
+      int la = miniexp_to_lstr(a, &sa);
+      int lb = miniexp_to_lstr(b, &sb);
+      return (la == lb) && ! memcmp(sa, sb, la);
+    } 
   return false;
 }
 
@@ -716,17 +729,17 @@ compare(miniexp_t a, miniexp_t b)
     {
       double na = miniexp_to_double(a);
       double nb = miniexp_to_double(b);
-      if (na < nb)
-	return -1;
-      else if (na > nb)
-	return 1;
-      return 0;
+      return (na < nb) ? -1 : (na > nb) ? +1 : 0;
     }
   else if (miniexp_stringp(a) && miniexp_stringp(b))
     {
-      const char *sa = miniexp_to_str(a);
-      const char *sb = miniexp_to_str(b);
-      return strcmp(sa, sb);
+      const char *sa, *sb;
+      int la = miniexp_to_lstr(a, &sa);
+      int lb = miniexp_to_lstr(b, &sb);
+      int r = memcmp(sa, sb, (la < lb) ? la : lb);
+      if (r == 0) 
+        return (la < lb) ? -1 : (la > lb) ? +1 : 0;
+      return r;
     }
   else
     error("compare: cannot rank these arguments");
@@ -763,15 +776,14 @@ DEFUN("ceil",ceil,1,0) {
 DEFUN("strlen",strlen,1,1) {
   if (! miniexp_stringp(argv[0]))
     error("strlen: string expected", argv[0]);
-  const char *s = miniexp_to_str(argv[0]);
-  return miniexp_number(strlen(s));
+  return miniexp_number(miniexp_to_lstr(argv[0], 0));
 }
 
 DEFUN("substr",substr,2,1) {
   if (! miniexp_stringp(argv[0]))
     error("substr: string expected", argv[0]);
-  const char *s = miniexp_to_str(argv[0]);
-  int l = strlen(s);
+  const char *s;
+  int l = miniexp_to_lstr(argv[0], &s);
   if (! miniexp_numberp(argv[1]))
     error("substr: integer number expected", argv[1]);
   int f = miniexp_to_double(argv[1]);
@@ -785,7 +797,7 @@ DEFUN("substr",substr,2,1) {
       f = miniexp_to_double(argv[2]);
       l = (f > l) ? l : (f < 0) ? 0 : f;
     }
-  return miniexp_substring(s,l);
+  return miniexp_lstring(l,s);
 }
 
 DEFUN("concat",concat,0,9999) {
--- djvulibre-3.5.27.1.orig/libdjvu/BSEncodeByteStream.cpp
+++ djvulibre-3.5.27.1/libdjvu/BSEncodeByteStream.cpp
@@ -844,10 +844,12 @@ BSByteStream::Encode::encode()
       BitContext *cx = ctx;
       b = (mtfno==0);
       zp.encoder(b, cx[ctxid]);
-      if (b) goto rotate; cx+=CTXIDS;
+      if (b) goto rotate;
+      cx+=CTXIDS;
       b = (mtfno==1);
       zp.encoder(b, cx[ctxid]);
-      if (b) goto rotate; cx+=CTXIDS;
+      if (b) goto rotate;
+      cx+=CTXIDS;
       b = (mtfno<4);
       zp.encoder(b, cx[0]);
       if (b) { encode_binary(zp,cx+1,1,mtfno-2); goto rotate; } 
--- djvulibre-3.5.27.1.orig/libdjvu/DjVmDir.cpp
+++ djvulibre-3.5.27.1/libdjvu/DjVmDir.cpp
@@ -223,7 +223,6 @@ DjVmDir::decode(const GP<ByteStream> &gs
    page2file.resize(-1);
    name2file.empty();
    id2file.empty();
-   title2file.empty();
 
    int ver=str.read8();
    bool bundled=(ver & 0x80)!=0;
@@ -375,18 +374,6 @@ DjVmDir::decode(const GP<ByteStream> &gs
 	          G_THROW( ERR_MSG("DjVmDir.dupl_id") "\t" + file->id);
 	       id2file[file->id]=file;
       }
-
-         // Generate title2file map
-      for(pos=files_list;pos;++pos)
-      {
-	       GP<File> file=files_list[pos];
-	       if (file->title.length())
-	       {
-	          if (title2file.contains(file->title))
-	             G_THROW( ERR_MSG("DjVmDir.dupl_title") "\t" + file->title);
-	          title2file[file->title]=file;
-	       }
-      }
    }
 }
 
@@ -556,11 +543,19 @@ DjVmDir::id_to_file(const GUTF8String &i
 }
 
 GP<DjVmDir::File>
-DjVmDir::title_to_file(const GUTF8String &title) const
+DjVmDir::title_to_file(const GUTF8String &title, GPosition spos) const
 {
-   GCriticalSectionLock lock((GCriticalSection *) &class_lock);
-   GPosition pos;
-   return (title2file.contains(title, pos))?title2file[pos]:(GP<DjVmDir::File>(0));
+  if (! title)
+    return 0;
+  GCriticalSectionLock lock((GCriticalSection *) &class_lock);
+  if (! spos)
+    for (GPosition pos = spos; pos; ++pos)
+      if (files_list[pos]->is_page() && files_list[pos]->title == title)
+        return files_list[pos];
+  for (GPosition pos = files_list; pos; ++pos)
+    if (files_list[pos]->is_page() && files_list[pos]->title == title)
+      return files_list[pos];
+  return 0;
 }
 
 GP<DjVmDir::File>
@@ -661,14 +656,7 @@ DjVmDir::insert_file(const GP<File> & fi
      G_THROW( ERR_MSG("DjVmDir.dupl_name2") "\t" + file->name);
    name2file[file->name]=file;
    id2file[file->id]=file;
-   if (file->title.length())
-     {
-       if (title2file.contains(file->title))  
-         // duplicate titles may become ok some day
-         G_THROW( ERR_MSG("DjVmDir.dupl_title2") "\t" + file->title);
-       title2file[file->title]=file;
-     }
-
+   
       // Make sure that there is no more than one file with shared annotations
    if (file->is_shared_anno())
    {
@@ -727,7 +715,6 @@ DjVmDir::delete_file(const GUTF8String &
       {
          name2file.del(f->name);
          id2file.del(f->id);
-         title2file.del(f->title);
          if (f->is_page())
          {
             for(int page=0;page<page2file.size();page++)
@@ -788,9 +775,7 @@ DjVmDir::set_file_title(const GUTF8Strin
    if (!id2file.contains(id, pos))
       G_THROW( ERR_MSG("DjVmDir.no_info") "\t" + GUTF8String(id));
    GP<File> file=id2file[pos];
-   title2file.del(file->title);
    file->title=title;
-   title2file[title]=file;
 }
 
 GPList<DjVmDir::File>
--- djvulibre-3.5.27.1.orig/libdjvu/DjVmDir.h
+++ djvulibre-3.5.27.1/libdjvu/DjVmDir.h
@@ -181,7 +181,8 @@ public:
       /** Translates file IDs to file records. */
    GP<File> id_to_file(const GUTF8String &id) const;
       /** Translates file shortcuts to file records. */
-   GP<File> title_to_file(const GUTF8String &title) const;
+   GP<File> title_to_file(const GUTF8String &title, GPosition spos) const;
+   GP<File> title_to_file(const GUTF8String &title) const; 
       /** Access file record by position. */
    GP<File> pos_to_file(int fileno, int *ppageno=0) const;
       /** Returns position of the file in the directory. */
@@ -216,7 +217,6 @@ private:
    GPArray<File> page2file;
    GPMap<GUTF8String, File> name2file;
    GPMap<GUTF8String, File> id2file;
-   GPMap<GUTF8String, File> title2file;
 private: //dummy stuff
    static void decode(ByteStream *);
    static void encode(ByteStream *);
@@ -440,6 +440,13 @@ DjVmDir::is_indirect(void) const
            files_list[files_list]->offset==0 );
 }
 
+inline GP<DjVmDir::File> 
+DjVmDir::title_to_file(const GUTF8String &title) const
+{
+  GPosition pos;
+  return title_to_file(title, pos);
+}
+
 
 
 // ----- THE END
--- djvulibre-3.5.27.1.orig/libdjvu/DjVuDocument.cpp
+++ djvulibre-3.5.27.1/libdjvu/DjVuDocument.cpp
@@ -805,11 +805,9 @@ DjVuDocument::id_to_url(const GUTF8Strin
 	    {
 	      GP<DjVmDir::File> file=djvm_dir->id_to_file(id);
 	      if (!file)
-              {
                 file=djvm_dir->name_to_file(id);
-	        if (!file)
-                  file=djvm_dir->title_to_file(id);
-              }
+	      if (!file)
+                file=djvm_dir->title_to_file(id);
 	      if (file)
 	        return GURL::UTF8(file->get_load_name(),init_url);
 	    }
@@ -819,11 +817,9 @@ DjVuDocument::id_to_url(const GUTF8Strin
 	    {
 	       GP<DjVmDir::File> file=djvm_dir->id_to_file(id);
 	       if (!file)
-               {
                  file=djvm_dir->name_to_file(id);
-	         if (!file)
-                   file=djvm_dir->title_to_file(id);
-               }
+	      if (!file)
+                file=djvm_dir->title_to_file(id);
 	       if (file)
 	         return GURL::UTF8(file->get_load_name(),init_url.base());
 	    }
@@ -838,7 +834,12 @@ DjVuDocument::id_to_url(const GUTF8Strin
 	    break;
 	 case OLD_INDEXED:
 	 case SINGLE_PAGE:
-	    return GURL::UTF8(id,init_url.base());
+	    {
+	       GURL url = GURL::UTF8(id,init_url.base());
+	       if (url.fname() == "-")
+	          G_THROW("Illegal include chunk (corrupted file?)");
+	       return url;
+	    }
 	    break;
       }
    return GURL();
--- djvulibre-3.5.27.1.orig/libdjvu/DjVuDocument.h
+++ djvulibre-3.5.27.1/libdjvu/DjVuDocument.h
@@ -524,7 +524,6 @@ public:
 		   \begin{enumerate}
 		      \item File ID from the \Ref{DjVmDir}
 		      \item File name from the \Ref{DjVmDir}
-		      \item File title from the \Ref{DjVmDir}
 		   \end{enumerate}
 		   Then for #BUNDLED# document the URL is obtained by
 		   appending the #name# of the found file to the document's
--- djvulibre-3.5.27.1.orig/libdjvu/DjVuDumpHelper.cpp
+++ djvulibre-3.5.27.1/libdjvu/DjVuDumpHelper.cpp
@@ -336,12 +336,12 @@ display_chunks(ByteStream & out_str, IFF
                                 size, djvminfo, counters[id]);
         break;
       }
-      // Default display of composite chunk
-      out_str.format( "\n");
-      if (iff.composite())
-        display_chunks(out_str, iff, head2, djvminfo);
-      // Terminate
-      iff.close_chunk();
+    // Default display of composite chunk
+    out_str.format( "\n");
+    if (iff.composite())
+      display_chunks(out_str, iff, head2, djvminfo);
+    // Terminate
+    iff.close_chunk();
   }
 }
 
--- djvulibre-3.5.27.1.orig/libdjvu/DjVuGlobal.h
+++ djvulibre-3.5.27.1/libdjvu/DjVuGlobal.h
@@ -70,11 +70,13 @@
 # include <new> // try standard c++ anyway!
 #endif
 
-#ifdef _WIN32
-# ifdef DJVUAPI_EXPORT
-#  define DJVUAPI __declspec(dllexport)
-# else
-#  define DJVUAPI __declspec(dllimport)
+#ifndef DJVUAPI
+# ifdef _WIN32
+#  ifdef DJVUAPI_EXPORT
+#   define DJVUAPI __declspec(dllexport)
+#  else
+#   define DJVUAPI __declspec(dllimport)
+#  endif
 # endif
 #endif
 #ifndef DJVUAPI
--- djvulibre-3.5.27.1.orig/libdjvu/DjVuMessageLite.h
+++ djvulibre-3.5.27.1/libdjvu/DjVuMessageLite.h
@@ -89,8 +89,8 @@ class ByteStream;
     separator ::= newline |
                   newline | separator
     
-    single_message ::= message_ID |
-                       message_ID parameters
+    single_message ::= CTRLC message_ID |
+                       CTRLC message_ID parameters
     
     parameters ::= tab string |
                    tab string parameters
--- djvulibre-3.5.27.1.orig/libdjvu/DjVuPort.cpp
+++ djvulibre-3.5.27.1/libdjvu/DjVuPort.cpp
@@ -148,7 +148,7 @@ DjVuPort::operator new (size_t sz)
       DjVuPortCorpse * corpse;
       for(corpse=corpse_head;corpse;corpse=corpse->next)
         if (test_addr==corpse->port) break;
-        if (!corpse)
+      if (!corpse)
         {
           addr=test_addr;
           addr_num--;
--- djvulibre-3.5.27.1.orig/libdjvu/GContainer.h
+++ djvulibre-3.5.27.1/libdjvu/GContainer.h
@@ -848,7 +848,7 @@ GListImpl<TI>::newnode(const TI &elt)
 {
   LNode  *n = (LNode *) operator new (sizeof(LNode ));
 #if GCONTAINER_ZERO_FILL
-  memset(n, 0, sizeof(LNode ));
+  memset((void*)n, 0, sizeof(LNode ));
 #endif
   new ((void*)&(n->val)) TI(elt);
   return (Node*) n;
--- djvulibre-3.5.27.1.orig/libdjvu/GOS.cpp
+++ djvulibre-3.5.27.1/libdjvu/GOS.cpp
@@ -154,13 +154,6 @@ strerror(int errno)
 #endif
 
 
-static const char slash='/';
-static const char percent='%';
-static const char backslash='\\';
-static const char colon=':';
-static const char dot='.';
-static const char nillchar=0;
-
 
 // -----------------------------------------
 // Functions for dealing with filenames
@@ -193,18 +186,18 @@ GOS::basename(const GUTF8String &gfname,
   const char *fname=gfname;
 #if defined(_WIN32) || defined(OS2)
   // Special cases
-  if (fname[1] == colon)
+  if (fname[1] == ':')
   {
     if(!fname[2])
     {
       return gfname;
     }
-    if (!fname[3] && (fname[2]== slash || fname[2]== backslash))
+    if (!fname[3] && (fname[2]== '/' || fname[2]== '\\'))
     {
       char string_buffer[4];
       string_buffer[0] = fname[0];
-      string_buffer[1] = colon;
-      string_buffer[2] = backslash; 
+      string_buffer[1] = ':';
+      string_buffer[2] = '\\';
       string_buffer[3] = 0; 
       return string_buffer;
     }
@@ -219,7 +212,7 @@ GOS::basename(const GUTF8String &gfname,
   // Process suffix
   if (suffix)
   {
-    if (suffix[0]== dot )
+    if (suffix[0]== '.' )
       suffix ++;
     if (suffix[0])
     {
@@ -229,7 +222,7 @@ GOS::basename(const GUTF8String &gfname,
       if (s > fname + sl)
       {
         s = s - (sl + 1);
-        if(*s == dot && (GUTF8String(s+1).downcase() == gsuffix.downcase()))
+        if(*s == '.' && (GUTF8String(s+1).downcase() == gsuffix.downcase()))
         {
           retval.setat((int)((size_t)s-(size_t)fname),0);
         }
@@ -335,7 +328,7 @@ GOS::cwd(const GUTF8String &dirname)
   char drv[2];
   if (dirname.length() && _chdir(dirname.getUTF82Native())==-1)//MBCS cvt
     G_THROW(errmsg());
-  drv[0]= dot ; drv[1]=0;
+  drv[0]= '.' ; drv[1]=0;
   char *string_buffer;
   GPBuffer<char> gstring_buffer(string_buffer,MAXPATHLEN+1);
   char *result = getcwd(string_buffer,MAXPATHLEN);
--- djvulibre-3.5.27.1.orig/libdjvu/GString.cpp
+++ djvulibre-3.5.27.1/libdjvu/GString.cpp
@@ -273,7 +273,9 @@ public:
   ~ChangeLocale();
 private:
   GUTF8String locale;
+#if DO_CHANGELOCALE
   int category;
+#endif
 };
 
 class GStringRep::Native : public GStringRep
@@ -452,7 +454,9 @@ GStringRep::Native::ncopy(
 }
 
 GStringRep::ChangeLocale::ChangeLocale(const int xcategory, const char xlocale[] )
+#if DO_CHANGELOCALE
   : category(xcategory)
+#endif
 {
 #if DO_CHANGELOCALE
   // This is disabled under UNIX because 
--- djvulibre-3.5.27.1.orig/libdjvu/GURL.cpp
+++ djvulibre-3.5.27.1/libdjvu/GURL.cpp
@@ -170,7 +170,6 @@ namespace DJVU {
 
 static const char djvuopts[]="DJVUOPTS";
 static const char localhost[]="file://localhost/";
-static const char backslash='\\';  
 static const char colon=':';
 static const char dot='.';
 static const char filespecslashes[] = "file://";
@@ -179,13 +178,14 @@ static const char slash='/';
 static const char percent='%';
 static const char localhostspec1[] = "//localhost/";
 static const char localhostspec2[] = "///";
-static const char nillchar=0;
 #if defined(UNIX)
   static const char tilde='~';
   static const char root[] = "/";
 #elif defined(_WIN32) || defined(OS2)
   static const char root[] = "\\";
+  static const char backslash='\\';  
 #elif defined(macintosh)
+  static const char nillchar=0;
   static char const * const root = &nillchar; 
 #else
 #error "Define something here for your operating system"
--- djvulibre-3.5.27.1.orig/libdjvu/IW44EncodeCodec.cpp
+++ djvulibre-3.5.27.1/libdjvu/IW44EncodeCodec.cpp
@@ -125,7 +125,7 @@ static const float iw_norm[16] = {
 };
 
 static const int iw_shift  = 6;
-static const int iw_round  = (1<<(iw_shift-1));
+// static const int iw_round  = (1<<(iw_shift-1));
 
 static const struct { int start; int size; }  
 bandbuckets[] = 
--- djvulibre-3.5.27.1.orig/libdjvu/IW44Image.cpp
+++ djvulibre-3.5.27.1/libdjvu/IW44Image.cpp
@@ -125,15 +125,6 @@ static const int iw_quant[16] = {
   0x040000, 0x040000, 0x080000
 };
 
-static const float iw_norm[16] = {
-  2.627989e+03F,
-  1.832893e+02F, 1.832959e+02F, 5.114690e+01F,
-  4.583344e+01F, 4.583462e+01F, 1.279225e+01F,
-  1.149671e+01F, 1.149712e+01F, 3.218888e+00F,
-  2.999281e+00F, 2.999476e+00F, 8.733161e-01F,
-  1.074451e+00F, 1.074511e+00F, 4.289318e-01F
-};
-
 static const int iw_border = 3;
 static const int iw_shift  = 6;
 static const int iw_round  = (1<<(iw_shift-1));
@@ -604,7 +595,7 @@ IW44Image::Map::Map(int w, int h)
 {
   bw = (w+0x20-1) & ~0x1f;
   bh = (h+0x20-1) & ~0x1f;
-  nb = (bw * bh) / (32 * 32);
+  nb = (unsigned int)(bw*bh) / (32 * 32);
   blocks = new IW44Image::Block[nb];
   top = IWALLOCSIZE;
 }
--- djvulibre-3.5.27.1.orig/libdjvu/ddjvuapi.cpp
+++ djvulibre-3.5.27.1/libdjvu/ddjvuapi.cpp
@@ -1578,6 +1578,12 @@ ddjvu_page_create(ddjvu_document_t *docu
         p->img = doc->get_page(GNativeString(pageid), false, job);
       else
         p->img = doc->get_page(pageno, false, job);
+      // synthetize msgs for pages found in the cache
+      ddjvu_status_t status = p->status();
+      if (status == DDJVU_JOB_OK)
+        p->notify_redisplay(p->img);
+      if (status >= DDJVU_JOB_OK)
+        p->notify_file_flags_changed(p->img->get_djvu_file(), 0, 0);
     }
   G_CATCH(ex)
     {
--- djvulibre-3.5.27.1.orig/libdjvu/ddjvuapi.h
+++ djvulibre-3.5.27.1/libdjvu/ddjvuapi.h
@@ -111,6 +111,9 @@ extern "C" {
 
    Version   Change
    -----------------------------
+     24    Added:
+              miniexp_lstring()
+              miniexp_to_lstr()
      23    Added:
               miniexp_mutate()
      22    Changed
--- djvulibre-3.5.27.1.orig/libdjvu/miniexp.cpp
+++ djvulibre-3.5.27.1/libdjvu/miniexp.cpp
@@ -3,8 +3,8 @@
 // MiniExp - Library for handling lisp expressions
 // Copyright (c) 2005  Leon Bottou
 //
-// This software is subject to, and may be distributed under, the
-// GNU General Public License, either version 2 of the license
+// This software is subject to, and may be distributed under, the GNU
+// Lesser General Public License, either Version 2.1 of the license,
 // or (at your option) any later version. The license should have
 // accompanied the software or you may obtain a copy of the license
 // from the Free Software Foundation at http://www.fsf.org .
@@ -319,6 +319,7 @@ gctls_t::~gctls_t()
 END_ANONYMOUS_NAMESPACE
 
 #if USE_PTHREADS
+
 // Manage thread specific data with pthreads
 static pthread_key_t gctls_key;
 static pthread_once_t gctls_once;
@@ -353,6 +354,7 @@ static gctls_t *gctls() {
 # endif
 
 #elif USE_WINTHREADS 
+
 // Manage thread specific data with win32
 #if defined(_MSC_VER) && defined(USE_MSVC_TLS)
 // -- Pre-vista os sometimes crashes on this.
@@ -382,17 +384,24 @@ static void NTAPI gctls_cb(PVOID, DWORD
     {CSLOCK(r);TlsFree(tlsIndex);tlsIndex=TLS_OUT_OF_INDEXES;}
 }
 # endif
-// -- Very black magic to clean tls variables.
-# ifdef _M_IX86
-#  pragma comment (linker, "/INCLUDE:_tlscb")
+// -- Very black magic to clean the TLS variables
+# if !defined(_MSC_VER)
+#  warning "This only works with MSVC. Memory leak otherwise"
+# elif !defined(MINILISPAPI_EXPORT)
+#  pragma message("This only works for a DLL. Memory leak otherwise")
 # else
-#  pragma comment (linker, "/INCLUDE:tlscb")
-# endif
-# pragma const_seg(".CRT$XLB")
+#  ifdef _M_IX86
+#   pragma comment (linker, "/INCLUDE:_tlscb")
+#  else
+#   pragma comment (linker, "/INCLUDE:tlscb")
+#  endif
+#  pragma const_seg(".CRT$XLB")
 extern "C" PIMAGE_TLS_CALLBACK tlscb = gctls_cb;
-# pragma const_seg()
+#  pragma const_seg()
+# endif
 
 #else
+
 // No threads
 static gctls_t *gctls() {
   static gctls_t g;
@@ -899,6 +908,18 @@ miniobj_t::pname() const
   return res;
 }
 
+bool
+miniobj_t::stringp(const char* &, size_t &) const
+{
+  return false;
+}
+
+bool
+miniobj_t::doublep(double&) const
+{
+  return false;
+}
+
 miniexp_t 
 miniexp_object(miniobj_t *obj)
 {
@@ -939,12 +960,13 @@ class ministring_t : public miniobj_t
   MINIOBJ_DECLARE(ministring_t,miniobj_t,"string");
 public:
   ~ministring_t();
-  ministring_t(const char *s);
-  ministring_t(char *s, bool steal);
+  ministring_t(size_t len, const char *s);
+  ministring_t(size_t len, char *s, bool steal);
   operator const char*() const { return s; }
-  virtual char *pname() const;
+  virtual bool stringp(const char* &s, size_t &l) const;
 private:
   char *s;
+  size_t l;
 private:
   ministring_t(const ministring_t &);
   ministring_t& operator=(const ministring_t &);
@@ -957,18 +979,29 @@ ministring_t::~ministring_t()
   delete [] s;
 }
 
-ministring_t::ministring_t(const char *str) 
-  : s(new char[strlen(str)+1])
+ministring_t::ministring_t(size_t len, const char *str)
+  : s(0), l(len)
 {
-  strcpy(s,str);
+  s = new char[l+1];
+  memcpy(s, str, l);
+  s[l] = 0;
 }
 
-ministring_t::ministring_t(char *str, bool steal) 
-  : s(str)
+ministring_t::ministring_t(size_t len, char *str, bool steal)
+  : s(str), l(len)
 {
   ASSERT(steal);
 }
 
+bool
+ministring_t::stringp(const char* &rs, size_t &rl) const
+{
+  rs = s;
+  rl = l;
+  return true;
+}
+
+
 END_ANONYMOUS_NAMESPACE
 
 static bool
@@ -985,13 +1018,15 @@ char_quoted(int c, int flags)
 }
 
 static bool
-char_utf8(int &c, const char* &s)
+char_utf8(int &c, const char* &s, size_t &len)
 {
   if (c < 0xc0)
     return (c < 0x80);
   if (c >= 0xf8)
     return false;
   int n = (c < 0xe0) ? 1 : (c < 0xf0) ? 2 : 3;
+  if ((size_t)n > len)
+    return false;
   int x = c & (0x3f >> n);
   for (int i=0; i<n; i++)
     if ((s[i] & 0xc0) == 0x80)
@@ -1005,6 +1040,7 @@ char_utf8(int &c, const char* &s)
     return false;
   if (x >= 0xd800 && x <= 0xdfff)
     return false;
+  len -= n;
   s += n;
   c = x;
   return true;
@@ -1019,13 +1055,14 @@ char_out(int c, char* &d, int &n)
 }
 
 static int
-print_c_string(const char *s, char *d, int flags = 0)
+print_c_string(const char *s, char *d, int flags, size_t len)
 {
   int c;
   int n = 0;
   char_out('\"', d, n);
-  while ((c = (unsigned char)(*s++)))
+  while (len-- > 0) 
     {
+      c = (unsigned char)(*s++);
       if (char_quoted(c, flags))
         {
           char buffer[10];
@@ -1038,7 +1075,7 @@ print_c_string(const char *s, char *d, i
               buffer[0] = tr1[i];
           if (buffer[0] == 0 && c >= 0x80 
               && (flags & (miniexp_io_u4escape | miniexp_io_u6escape))
-              && char_utf8(c, s) )
+              && char_utf8(c, s, len) )
             {
               if (c <= 0xffff && (flags & miniexp_io_u4escape))
                 sprintf(buffer,"u%04X", c);
@@ -1049,6 +1086,9 @@ print_c_string(const char *s, char *d, i
                         0xd800+(((c-0x10000)>>10)&0x3ff), 
                         0xdc00+(c&0x3ff));
             }
+          if (buffer[0] == 0 && c == 0)
+            if (*s < '0' || *s > '7')
+              buffer[0] = '0';
           if (buffer[0] == 0)
             sprintf(buffer, "%03o", c);
           for (int i=0; buffer[i]; i++)
@@ -1062,68 +1102,74 @@ print_c_string(const char *s, char *d, i
   return n;
 }
 
-char *
-ministring_t::pname() const
-{
-  int n = print_c_string(s, 0);
-  char *d = new char[n];
-  if (d) print_c_string(s, d);
-  return d;
-}
-
 int 
 miniexp_stringp(miniexp_t p)
 {
-  return miniexp_isa(p, ministring_t::classname) ? 1 : 0;
+  const char *s; size_t l;
+  if (miniexp_objectp(p) && miniexp_to_obj(p)->stringp(s,l))
+    return 1;
+  return 0;
 }
 
 const char *
 miniexp_to_str(miniexp_t p)
 {
-  miniobj_t *obj = miniexp_to_obj(p);
-  if (miniexp_stringp(p))
-    return (const char*) * (ministring_t*) obj;
-  return 0;
+  const char *s = 0;
+  miniexp_to_lstr(p, &s);
+  return s;
 }
 
-miniexp_t 
+size_t
+miniexp_to_lstr(miniexp_t p, const char **sp)
+{
+  const char *s = 0;
+  size_t l = 0;
+  if (miniexp_objectp(p))
+    miniexp_to_obj(p)->stringp(s,l);
+  if (sp)
+    *sp = s;
+  return l;
+}
+
+miniexp_t
 miniexp_string(const char *s)
 {
-  ministring_t *obj = new ministring_t(s);
-  return miniexp_object(obj);
+  return miniexp_lstring(strlen(s), s);
 }
 
 miniexp_t 
-miniexp_substring(const char *s, int n)
+miniexp_lstring(size_t len, const char *s)
 {
-  int l = strlen(s);
-  n = (n < l) ? n : l;
-  char *b = new char[n+1];
-  strncpy(b, s, n);
-  b[n] = 0;
-  ministring_t *obj = new ministring_t(b, true);
+  ministring_t *obj = new ministring_t(len,s);
   return miniexp_object(obj);
 }
 
 miniexp_t 
+miniexp_substring(const char *s, int len)
+{
+  size_t l = strlen(s);
+  size_t n = (size_t)len;
+  return miniexp_lstring((l < n) ? l : n, s);
+}
+
+miniexp_t 
 miniexp_concat(miniexp_t p)
 {
   miniexp_t l = p;
   const char *s;
-  int n = 0;
+  size_t n = 0;
   if (miniexp_length(l) < 0)
     return miniexp_nil;
   for (p=l; miniexp_consp(p); p=cdr(p))
-    if ((s = miniexp_to_str(car(p))))
-      n += strlen(s);
+    n += miniexp_to_lstr(car(p), 0);
   char *b = new char[n+1];
   char *d = b;
   for (p=l; miniexp_consp(p); p=cdr(p))
-    if ((s = miniexp_to_str(car(p)))) {
-      strcpy(d, s);
-      d += strlen(d);
+    if ((n = miniexp_to_lstr(car(p), &s))) {
+      memcpy(d, s, n);
+      d += n;
     }
-  ministring_t *obj = new ministring_t(b, true);
+  ministring_t *obj = new ministring_t(d-b, b, true);
   return miniexp_object(obj);
 }
 
@@ -1142,6 +1188,7 @@ public:
   minifloat_t(double x) : val(x) {}
   operator double() const { return val; }
   virtual char *pname() const;
+  virtual bool doublep(double &d) const { d=val; return true; }
 private:
   double val;
 };
@@ -1164,14 +1211,25 @@ miniexp_floatnum(double x)
   return miniexp_object(obj);
 }
 
+int
+miniexp_doublep(miniexp_t p)
+{
+  double v = 0.0;
+  if (miniexp_numberp(p) ||
+      (miniexp_objectp(p) && miniexp_to_obj(p)->doublep(v)) )
+    return 1;
+  return 0;
+}
+
 double 
 miniexp_to_double(miniexp_t p)
 {
+  double v = 0.0;
   if (miniexp_numberp(p))
-    return (double) miniexp_to_int(p);
-  else if (miniexp_floatnump(p))
-    return (double) * (minifloat_t*) miniexp_to_obj(p);
-  return 0.0;
+    v = (double) miniexp_to_int(p);
+  else if (miniexp_objectp(p))
+    miniexp_to_obj(p)->doublep(v);
+  return v;
 }
 
 miniexp_t 
@@ -1418,11 +1476,12 @@ printer_t::print(miniexp_t p)
     }
   else if (miniexp_stringp(p))
     {
-      const char *s = miniexp_to_str(p);
-      int n = print_c_string(s, 0, flags);
+      const char *s;
+      size_t len = miniexp_to_lstr(p, &s);
+      int n = print_c_string(s, 0, flags, len);
       char *d = new char[n];
       if (d) 
-        print_c_string(s, d, flags);
+        print_c_string(s, d, flags, len);
       mlput(d);
       delete [] d;
     }
@@ -1644,7 +1703,7 @@ miniexp_pname(miniexp_t p, int width)
 /* ---- INPUT */
 
 static void
-grow(char* &s, int &l, int &m)
+grow(char* &s, size_t &l, size_t &m)
 {
   int nm = ((m<256)?256:m) + ((m>32000)?32000:m);
   char *ns = new char[nm+1];
@@ -1655,7 +1714,7 @@ grow(char* &s, int &l, int &m)
 }
 
 static void
-append(int c, char* &s, int &l, int &m)
+append(int c, char* &s, size_t &l, size_t &m)
 {
   if (l >= m)
     grow(s, l, m);
@@ -1664,7 +1723,7 @@ append(int c, char* &s, int &l, int &m)
 }
 
 static void
-append_utf8(int x, char *&s, int &l, int &m)
+append_utf8(int x, char *&s, size_t &l, size_t &m)
 {
   if (x >= 0 && x <= 0x10ffff)
     { 
@@ -1745,8 +1804,8 @@ read_c_string(miniexp_io_t *io, int &c)
 {
   miniexp_t r;
   char *s = 0;
-  int l = 0;
-  int m = 0;
+  size_t l = 0;
+  size_t m = 0;
   ASSERT(c == '\"');
   c = io->fgetc(io);
   for(;;)
@@ -1819,8 +1878,8 @@ read_c_string(miniexp_io_t *io, int &c)
               io->ungetc(io, c);
               c = d;
             }
-          static const char *tr1 = "tnrbfva";
-          static const char *tr2 = "\t\n\r\b\f\013\007";
+          static const char *tr1 = "tnrbfvae?";
+          static const char *tr2 = "\t\n\r\b\f\013\007\033?";
           for (int i=0; tr1[i]; i++)
             if (c == tr1[i])
               c = tr2[i];
@@ -1829,7 +1888,7 @@ read_c_string(miniexp_io_t *io, int &c)
       c = io->fgetc(io);
     }
   c = io->fgetc(io);
-  r = miniexp_string(s ? s : "");
+  r = miniexp_lstring(l, s);
   delete [] s;
   return r;
 }
@@ -1839,8 +1898,8 @@ read_quoted_symbol(miniexp_io_t *io, int
 {
   miniexp_t r;
   char *s = 0;
-  int l = 0;
-  int m = 0;
+  size_t l = 0;
+  size_t m = 0;
   ASSERT(c == '|');
   for(;;)
     {
@@ -1862,8 +1921,8 @@ read_symbol_or_number(miniexp_io_t *io,
 {
   miniexp_t r;
   char *s = 0;
-  int l = 0;
-  int m = 0;
+  size_t l = 0;
+  size_t m = 0;
   for(;;)
     {
       if (c==EOF || c=='(' || c==')' || c=='|' || c=='\"'  
--- djvulibre-3.5.27.1.orig/libdjvu/miniexp.h
+++ djvulibre-3.5.27.1/libdjvu/miniexp.h
@@ -3,8 +3,8 @@
 // MiniExp - Library for handling lisp expressions
 // Copyright (c) 2005  Leon Bottou
 //
-// This software is subject to, and may be distributed under, the
-// GNU General Public License, either Version 2 of the license,
+// This software is subject to, and may be distributed under, the GNU
+// Lesser General Public License, either Version 2.1 of the license,
 // or (at your option) any later version. The license should have
 // accompanied the software or you may obtain a copy of the license
 // from the Free Software Foundation at http://www.fsf.org .
@@ -269,16 +269,28 @@ MINILISPAPI int miniexp_stringp(miniexp_
 
 MINILISPAPI const char *miniexp_to_str(miniexp_t p);
 
+/* miniexp_to_lstr ---- 
+   Returns the length of the string represented by the expression.
+   Optionally returns the c string into *sp.  
+   Return 0 and makes *sp null if the expression is not a string. */
+
+MINILISPAPI size_t miniexp_to_lstr(miniexp_t p, const char **sp);
+
 /* miniexp_string --
-   Constructs a string expression by copying string s. */
+   Constructs a string expression by copying zero terminated string s. */
 
 MINILISPAPI miniexp_t miniexp_string(const char *s);
 
+/* miniexp_lstring --
+   Constructs a string expression by copying len bytes from s. */
+
+MINILISPAPI miniexp_t miniexp_lstring(size_t len, const char *s);
+
 /* miniexp_substring --
-   Constructs a string expression by copying 
-   at most n character from string s. */
+   Constructs a string expression by copying at most len bytes 
+   from zero terminated string s. */
 
-MINILISPAPI miniexp_t miniexp_substring(const char *s, int n);
+MINILISPAPI miniexp_t miniexp_substring(const char *s, int len);
 
 /* miniexp_concat --
    Concat all the string expressions in list <l>. */
@@ -304,13 +316,11 @@ MINILISPAPI miniexp_t miniexp_floatnum(d
    Tests if an expression can be converted
    to a double precision number. */
 
-static inline int miniexp_doublep(miniexp_t p) {
-  return miniexp_numberp(p) || miniexp_floatnump(p);
-}
+MINILISPAPI int miniexp_doublep(miniexp_t p);
 
 /* miniexp_to_double --
    Returns a double precision number corresponding to 
-   a lisp expression (a number or a floatnum.) */
+   a lisp expression. */
 
 MINILISPAPI double miniexp_to_double(miniexp_t p);
 
@@ -721,6 +731,11 @@ miniobj_t {
   /* pname: returns a printable name for this object.
      The caller must deallocate the result with delete[]. */
   virtual char *pname() const;
+  /* stringp, doublep: tells whether this object should be
+     interpreted/printed as a generic string (for miniexp_strinp) 
+     or a double (for miniexp_doublep). */
+  virtual bool stringp(const char* &s, size_t &l) const;
+  virtual bool doublep(double &d) const;
   /* mark: calls action() on all member miniexps of the object,
      for garbage collecting purposes. */
   virtual void mark(minilisp_mark_t *action);
--- djvulibre-3.5.27.1.orig/tools/any2djvu
+++ djvulibre-3.5.27.1/tools/any2djvu
@@ -28,7 +28,7 @@ function disclaimer()
 # TO DO:
 #  - error handling
 
-rurl="http://any2djvu.djvuzone.org"
+rurl="http://any2djvu.djvu.org"
 rcgi="any2djvu.php"
 res=400
 ocr=1
@@ -83,7 +83,7 @@ function usage()
     echo "Examples:"
     echo "  cd ~bap/public_html/foo"
     echo " # uploads from web-accessible directory"
-    echo "  any2djvu http://www.bcl.hamilton.ie/~barak/papers mesh-preprint.ps.gz"
+    echo "  any2djvu http://barak.pearlmutter.net/papers mesh-preprint.ps.gz"
     echo "  any2djvu http://www.inference.phy.cam.ac.uk/mackay *.ps.gz bar.pdf"
     echo " # uploads from current directory"
     echo "  any2djvu b*.pdf"
--- djvulibre-3.5.27.1.orig/tools/any2djvu.1
+++ djvulibre-3.5.27.1/tools/any2djvu.1
@@ -14,7 +14,7 @@ Invoke with \-h switch for usage informa
 Non-empty value of DJVU_ONLINE_ACK acknowledges transmission of the
 documents to the server (so that no warning dialog is displayed).
 .SH EXAMPLES
-any2djvu http://www.bcl.hamilton.ie/~barak/papers mesh-preprint.ps.gz
+any2djvu http://barak.pearlmutter.net/papers mesh-preprint.ps.gz
 .PP
 any2djvu localfile.pdf
 .SH AUTHORS
--- djvulibre-3.5.27.1.orig/tools/csepdjvu.1
+++ djvulibre-3.5.27.1/tools/csepdjvu.1
@@ -188,22 +188,21 @@ Pixels are ordered in left to right, top
 
 .SS Comments in separated files
 
-Each page is followed by an arbitrary number of comment lines 
-starting with character "#" and terminated by a linefeed character. 
-Comment lines whose first word starts with a capital letter have 
-special meanings. The following constructs are currently defined:
+Each page is followed by an arbitrary number of comment lines starting with
+character "#" and terminated by a linefeed character.  Certain comment lines
+have special meanings. In the following constructs, all the strings are UTF-8
+encoded and represent in the style of Postscript strings, that is, surrounded
+with parenthesis and using C-style escape sequences introduced by a backslash.
 .IP "*" 3
 .BI "# T " px ":" py " " dx ":" dy " " w "x" h "+" x "+" y " (" string ")"
 .br
-This constructs indicates that the piece of text
+Such a comment line indicates that the piece of text
 .I string
 must be associated with an area of size
 .IR w "x" h
 at position 
 .IR x "," y
 relative to the lower left corner of the page.
-The string is UTF-8 encoded. Special characters
-can be escaped as in PostScript using the backslash character.
 Integers
 .IR px ", and " py
 represent the position of the current point on the text baseline
@@ -218,7 +217,7 @@ corresponding pages.
 .IP "*" 3
 .BI "# L " w "x" h "+" x "+" y " (" url ")"
 .br
-This construct indicates that an hyperlink to url
+Such a comment line indicates that an hyperlink to url
 .I url
 should be associated with area of size
 .IR w "x" h
@@ -231,7 +230,7 @@ containing the specified hyperlinks.
 .IP "*" 3
 .BI "# B " count " (" string ") (#" pageno ")"
 .br
-This constructs provides outline information for the document.
+Such a comment line provides outline information for the document.
 An outline entry entitled
 .I string
 is associated with page
@@ -244,7 +243,12 @@ When such comments are present in the fi
 .BR csepdjvu 
 produces an navigation chunk with 
 the specified outline.
-
+.IP "*" 3
+.BI "# P (" string ")"
+.br
+Such a comment line provides a title
+.I string
+for the current page.
 .SH CREDITS
 
 This program was initially written by L\('eon Bottou
--- djvulibre-3.5.27.1.orig/tools/csepdjvu.cpp
+++ djvulibre-3.5.27.1/tools/csepdjvu.cpp
@@ -1121,6 +1121,7 @@ public:
   bool parse_comment_line(BufferByteStream &bs);
   void make_chunks(IFFByteStream &iff);
   GP<DjVmNav> get_djvm_nav();
+  GUTF8String get_pagetitle();
 protected:
   int w;
   int h;
@@ -1143,6 +1144,7 @@ protected:
   };
   GPList<LnkMark> links;
   GP<DjVmNav> nav;
+  GUTF8String pagetitle;
 protected:
   bool allspace(const TxtMark *mark);
   void textmark(GP<TxtMark> mark);
@@ -1255,6 +1257,15 @@ Comments::parse_comment_line(BufferByteS
         nav->append(b);
       return true;
     }
+  // Page title comment
+  if (c == 'P')
+    {
+      if (pagetitle.length())
+        G_THROW("csepdjvu: corrupted file (multiple page title comments)");
+      if (! (bs.skip(" \t") && bs.read_ps_string(pagetitle) ))
+	G_THROW("csepdjvu: corrupted file (syntax error in title comment)");
+      return true;
+    }
   // Unrecognized
   bs.unget(c);
   return false;
@@ -1487,6 +1498,12 @@ Comments::get_djvm_nav()
   return 0;
 }
 
+GUTF8String
+Comments::get_pagetitle()
+{
+  return pagetitle;
+}
+
 
 // --------------------------------------------------
 // MAIN COMPRESSION ROUTINE
@@ -1500,6 +1517,7 @@ void
 csepdjvu_page(BufferByteStream &bs, 
               GP<ByteStream> obs, 
               GP<DjVmNav> &nav,
+	      GUTF8String &pagetitle,
               const csepdjvuopts &opts)
 {
   // Read rle data from separation file
@@ -1671,7 +1689,8 @@ csepdjvu_page(BufferByteStream &bs,
   // -- terminate main composite chunk
   coms.make_chunks(iff);
   iff.close_chunk();
-  // -- store outline
+  // -- returns page title and outline
+  pagetitle = coms.get_pagetitle();
   if (! nav) 
     nav = coms.get_djvm_nav();
 }  
@@ -1765,6 +1784,7 @@ main(int argc, const char **argv)
     {
       GP<DjVmDoc> gdoc=DjVmDoc::create();
       GP<DjVmNav> gnav;
+      GUTF8String pagetitle;
       DjVmDoc &doc=*gdoc;
       GURL outputurl;
       GP<ByteStream> goutputpage=ByteStream::create();
@@ -1821,7 +1841,7 @@ main(int argc, const char **argv)
                 // Compress page 
                 goutputpage=ByteStream::create();
                 ByteStream &outputpage=*goutputpage;
-                csepdjvu_page(ibs, goutputpage, gnav, opts);
+                csepdjvu_page(ibs, goutputpage, gnav, pagetitle, opts);
                 if (opts.verbose) {
                   DjVuPrintErrorUTF8("csepdjvu: %d bytes for page %d",
                                      outputpage.size(), pageno);
@@ -1834,12 +1854,12 @@ main(int argc, const char **argv)
                 // Insert page into document
                 outputpage.seek(0);
                 doc.insert_file(outputpage, DjVmDir::File::PAGE, 
-                                pagename, pagename);
+                                pagename, pagename, pagetitle);
               } while (check_for_another_page(ibs, opts));
             }
         } 
       // Save file
-      if (pageno == 1 && ! gnav) 
+      if (pageno == 1 && ! gnav && ! pagetitle) 
         {
           ByteStream &outputpage=*goutputpage;
           // Save as a single page 
--- djvulibre-3.5.27.1.orig/tools/ddjvu.cpp
+++ djvulibre-3.5.27.1/tools/ddjvu.cpp
@@ -691,7 +691,7 @@ closefile(int pageno)
       args[1] = "-o";
       args[2] = filename;
       if (tiff2pdf(tiff, fout, 3, args) != EXIT_SUCCESS)
-        die(i18n("Error occured while creating PDF file."));
+        die(i18n("Error occurred while creating PDF file."));
       TIFFClose(tiff);
       tiff = 0;
 #ifndef _WIN32
--- djvulibre-3.5.27.1.orig/tools/djvudigital
+++ djvulibre-3.5.27.1/tools/djvudigital
@@ -54,7 +54,18 @@
 #C- +------------------------------------------------------------------
 #C--------------------------------------------------------------------
 
-# Step 1 -- utilities
+
+# Step 1a -- temporary directory
+
+tempdir=`mktemp -d --tmpdir djXXXXXX 2>/dev/null` || tempdir=''
+while [ ! -d "$tempdir" -o ! -r "$tempdir" ] ; do
+    tempdir="/tmp/dj"`awk 'BEGIN{srand();printf("%d",rand()*100000)}'`
+    mkdir "$tempdir" || tempdir=''
+done
+trap 'rm -rf 2>/dev/null "$tempdir"' EXIT INT HUP QUIT
+
+
+# Step 1b -- utilities
 
 usage()
 {
@@ -97,8 +108,7 @@ checkps2utf8()
         if ( "$gsdjvu" 2>&1 -dNODISPLAY -c '(ps2utf8.ps) runlibfile quit' | \
               grep -q WRITESYSTEMDICT )
         then
-            djvutext="/tmp/dj$$.ps"
-            trap "rm 2>/dev/null $djvutext" 0
+            djvutext="$tempdir/djvutext.ps"
             cat > $djvutext <<\EOF
 (ps2utf8.ps) runlibfile currentglobal /setglobal load true setglobal 
 .ps2utf8 begin /onpage { } bind def /onfont { pop pop pop } bind def
@@ -111,7 +121,7 @@ EOF
 }
 
 
-# Step 1 -- locate gsdjvu executable
+# Step 2a -- locate gsdjvu executable
 
 gsdjvu=
 for gs in ${GSDJVU} `pathexpand gs` `pathexpand gsdjvu`
@@ -135,8 +145,7 @@ EOF
     exit 10
 fi
 
-
-# Step 2 -- locate csepdjvu executable
+# Step 2b -- locate csepdjvu executable
 
 csepdjvu=
 for cs in ${CSEPDJVU} `pathexpand csepdjvu` `pathexpand msepdjvu`
@@ -159,6 +168,30 @@ EOF
     exit 10
 fi
 
+# Step 2c -- locate djvused executable
+
+djvused=
+for ds in ${DJVUSED} `pathexpand djvused`
+do
+    if [ -z "$djvused" ] && ( "$ds" 2>&1 | grep -q -i djvulibre )
+    then
+        djvused="$ds"
+    fi
+done
+
+# Step 2d -- locate pdftotext executable
+
+pdftotext=
+for pt in ${PDFTOTEXT} `pathexpand pdftotext`
+do
+  if [ -z "$pdftotext" ] && \
+     ( "$pt" -bbox foo.pdf 2>&1 | grep -q foo.pdf )
+     ( "$pt" -v 2>&1 | grep -q Poppler )
+  then
+      pdftotext="$pt"
+  fi
+done
+
 
 # Step 3 -- process arguments
 
@@ -171,11 +204,14 @@ gsprinted="-dPrinted"
 gsepsf="-dEPSCrop"
 gsverbosity=
 csepverbosity='-v'
+dsedverbosity=
 djvutext=
 infile=
 outfile=
 run=
 sepfile=
+popplertext=0
+popplermeta=0
 
 for n
 do
@@ -194,6 +230,8 @@ do
       --check)
           echo 1>&2 "Using: $gsdjvu"
           echo 1>&2 "  and: $csepdjvu"
+          test -n "$pdftotext" && echo 1>&2 "  and: $pdftotext"
+          test -n "$djvused" && echo 1>&2 "  and: $djvused"
           exit 0
           ;;
       --dpi=[0-9]*)
@@ -202,9 +240,10 @@ do
       --verbose|--v)
           gsverbosity=''
           csepverbosity='-vv'
+          dsedverbosity='-v'
           ;;
       --dryrun)
-          run=echo
+          run="echo +"
           ;;
       --sepfile)
           sepfile=yes
@@ -254,6 +293,16 @@ do
           fi
           csepargs="$csepargs -t"
           ;;
+      --poppler=*)
+          for arg in `getargs $n` ; do
+            case "$arg" in 
+              text) popplertext=1 ;;
+              meta) popplermeta=1 ;;
+                 *) echo 1>&2 "djvudigital: unrecognized option --poppler=$arg"
+                    usage ;; 
+            esac
+          done
+          ;;
       --pdf=screen)
           gsprinted="-dPrinted=false"
           ;;
@@ -285,6 +334,7 @@ do
           csepargs="$csepargs `getargs $n`"
           ;;
       -*)
+          echo 1>&2 "djvudigital: unrecognized option $n"
           usage
           ;;
       *)
@@ -339,7 +389,7 @@ if [ "$sepfile" = "yes" ]
 then
   backend="$outfile"
 else
-  backend="|$csepdjvu -d "'"'"$dpi"'"'
+  backend="| "'"'"$csepdjvu"'"'" -d $dpi"
   backend="$backend $csepverbosity $csepargs - "'"'"$outfile"'"'
 fi
 
@@ -348,26 +398,268 @@ case "$infile" in
     *.gz|*.GZ)
         if test -z "$run" ; then
           gzip -d -c "$infile" | \
-          $gsdjvu "-r$dpi" $gsverbosity $gsprinted $gsepsf \
+          "$gsdjvu" "-r$dpi" $gsverbosity $gsprinted $gsepsf \
             "-sOutputFile=$backend" $gsarg0 $gsarg1 $gsarg2 -_ -c quit
         else
-          echo -n gzip -d -c '"'"$infile"'"' '|' ""
-          echo -n $gsdjvu "-r$dpi" $gsverbosity $gsprinted $gsepsf ""
-          echo -n "-sOutputFile=""'""$backend""'" ""
-          echo -n $gsarg0 $gsarg1 $gsarg2 -_ -c quit
-          echo
+          $run gzip -d -c '"'"$infile"'"' '|' "" \
+             "$gsdjvu" "-r$dpi" $gsverbosity $gsprinted $gsepsf "" \
+             "-sOutputFile=""'""$backend""'" "" \
+             $gsarg0 $gsarg1 $gsarg2 -_ -c quit
         fi
         ;;
     *)
         if test -z "$run" ; then
-          $gsdjvu "-r$dpi" $gsverbosity $gsprinted $gsepsf \
+          "$gsdjvu" "-r$dpi" $gsverbosity $gsprinted $gsepsf \
             "-sOutputFile=$backend" $gsarg0 $gsarg1 $gsarg2 \
             -f "$infile" -c quit
         else
-          echo -n $gsdjvu "-r$dpi" $gsverbosity $gsprinted $gsepsf ""
-          echo -n "-sOutputFile=""'""$backend""'" ""
-          echo -n $gsarg0 $gsarg1 $gsarg2 -f '"'"$infile"'"' -c quit
-          echo
+          $run "$gsdjvu" "-r$dpi" $gsverbosity $gsprinted $gsepsf "" \
+             "-sOutputFile=""'""$backend""'" "" \
+             $gsarg0 $gsarg1 $gsarg2 -f '"'"$infile"'"' -c quit
         fi
         ;;
 esac
+
+
+# Step 6 -- Postprocess djvu file with metadata/text found by poppler
+
+if ( file "$infile" | grep -q -i pdf ) \
+    && test "$popplertext$popplermeta" != "00"
+then
+
+    # check for djvused
+    if [ -z "$djvused" ]
+    then
+        cat 1>&2 <<\EOF
+djvudigital: cannot locate djvused executable.
++--------------------------------------------------------------------+
+| DjVuDigital was not able to locate the djvulibre tool "djvused".   |
+| This tool is needed to use the --poppler=(text,data) options.      |
+| Please make sure that the djvulibre tools are properly installed.  |
++--------------------------------------------------------------------+
+EOF
+        exit 10
+    fi
+
+    # check for pdftotext
+    if [ -z "$pdftotext" ] 
+    then
+        cat 1>&2 <<\EOF
+djvudigital: cannot locate pdftotext executable.
++--------------------------------------------------------------------+
+| DjVuDigital was not able to locate the poppler tool "pdftotext".   |
+| This tool is needed to use the --poppler=(text,data) options.      |
+| Please make sure that the poppler tools are properly installed.    |
++--------------------------------------------------------------------+
+EOF
+        exit 10
+    fi
+
+    # xml parser for awk :-)
+    xml2dsed="$tempdir/xml2dsed.awk"
+    cat > "$xml2dsed" <<\EOF
+
+# initializations
+
+function _esc_init() {
+    _ctrl = ""
+    for (i=1; i<32; i++) { _ctrl = _ctrl sprintf("%c",i) }
+    _esc = "[\"\\&" _ctrl "]"
+    _ctrl = "[" _ctrl "]"
+}
+
+function _ord_init() {
+    for (i=0; i<256; i++) {
+	_ord[sprintf("%c",i)]=i
+    }
+}
+
+function _amp_init() {
+    _amp["&amp;"] = "&"
+    _amp["&lt;"] = "<"
+    _amp["&gt;"] = ">"
+    _amp["&apos;"] = "'"
+    _amp["&quot;"] = "\\\""
+}
+
+BEGIN {
+    _esc_init()
+    _ord_init()
+    _amp_init()
+    delete meta
+    pheight=0
+    pwidth=0
+    location=""
+    context=""
+    content=""
+    pageno=0
+    dpi = 300 # use awk -f xml2dsed.awk dpi=xxx to override
+    dometa=1  # use awk -f xml2dsed.awk dometa=0 to override
+    dotext=1  # use awk -f xml2dsed.awk dotext=0 to override
+    RS=">"    # xml parsing wants record delimiter set to ">"
+}
+
+# return character code
+
+function ord(str) {
+    return _ord[substr(str,1,1)]
+}
+
+# print properly escaped c string
+
+function pstr(str,tmp) {
+    printf("\"")
+    while (str) {
+	tmp = match(str,_esc) # char classes do not always work
+	if (tmp == 0) {
+	    printf("%s",str)
+	    str = ""
+	} else if (tmp > 1) {
+	    printf("%s",substr(str,1,tmp-1))
+	    str = substr(str,tmp)
+	} else {
+	    tmp = match(str,"^&[a-z]*;")
+	    if (tmp != 1) { tmp = "" }
+	    if (tmp) { tmp = _amp[substr(str,RSTART,RLENGTH)] }
+	    if (tmp) {
+		printf("%s",tmp)
+		str = substr(str,RLENGTH+1)
+	    } else {
+		printf("\\%03o", ord(str))
+		str = substr(str,2)
+	    }
+	}
+    }
+    printf("\"")
+}
+
+# sax-like callbacks
+
+function charData(str) {
+    if (context == "title") {
+	meta["Title"] = str
+    } else if (context == "word") {
+	gsub(_ctrl," ",str)      # kill control characters
+	gsub("\302\240"," ",str) # nbsp in utf-8
+	gsub(/  */," ",str)      # simplify spaces
+	gsub(/^ /,"",str)        # simplify spaces
+	gsub(/ $/,"",str)        # simplify spaces
+	if (match(str,/[^ ]/)) { content = str } else { content = "" }
+    }
+}
+
+function startElement(tag,attrs) {
+    if (tag=="head" && ! context && dometa) {
+	context = "head"
+    } else if (tag=="title" && context=="head") {
+	context = "title"
+    } else if (tag=="meta" && attrs["name"] && attrs["content"] ) {
+	meta[attrs["name"]] = attrs["content"]
+    } else if (tag=="body" && ! context && dotext) {
+	context = "body"
+    } else if (tag=="page" && context == "body") {
+	pageno = pageno + 1
+	pwidth = attrs["width"] * dpi / 72
+	pheight = attrs["height"] * dpi / 72
+	context = "page"
+	printf("select %d\n", pageno)
+	printf("set-txt\n")
+	printf("(page %d %d %d %d\n", 0, 0, pwidth, pheight)
+    } else if (tag=="word" && context == "page") {
+	if (attrs["xMin"] && attrs["xMax"] && attrs["yMin"] && attrs["yMax"]) {
+	    context = "word"
+	    location = sprintf("%d %d %d %d",
+			       attrs["xMin"] * dpi / 72,
+			       pheight - attrs["yMin"] * dpi / 72,
+			       attrs["xMax"] * dpi / 72,
+			       pheight - attrs["yMax"] * dpi / 72 )
+	}
+    }
+}
+
+function endElement(tag) {
+    if (tag == "title" && context == "title") {
+	context = "head"
+    } else if (tag == "head" && context == "head" && length(meta)>0) {
+	context = ""
+	printf("create-shared-ant\n")
+	printf("set-meta\n")
+	for (i in meta) {
+	    printf("%s\t",i)
+	    pstr(meta[i])
+	    printf("\n")
+	}
+	printf(".\n")
+    } else if (tag == "page" && context == "page") {
+	context = "body"
+	printf(")\n.\n")
+    } else if (tag == "word" && context == "word" && content) {
+	context = "page"
+	printf("  (word %s ", location)
+	pstr(content)
+	printf(")\n")
+	content = ""
+    }
+}
+
+# xml parser (for pdftotext!)
+{
+    str = $0
+    match(str,/^[ \n\r\t\f]*/)
+    if (RSTART == 1 && RLENGTH > 0) {
+	str = substr(str,RLENGTH+1)
+    }
+    if (! match(str,/</)) {
+	charData(str)
+    } else {
+	if (RSTART > 1) {
+	    arg = substr(str,1,RSTART-1)
+	    str = substr(str,RSTART)
+	    charData(arg)
+	}
+	match(str, "^</?[a-zA-Z][a-zA-Z0-9_]*")
+	if (RSTART == 1) {
+	    tag = substr(str,2,RLENGTH-1)
+	    arg = substr(str,RLENGTH+1)
+	    # parse attrs
+	    delete attrs
+	    if (match(arg,"/$")) { arg = substr(arg,1,RSTART-1) }
+	    while (arg && match(arg,/[a-zA-Z][a-zA-Z0-9_]*=/)) {
+		attr = substr(arg,RSTART,RLENGTH-1)
+		arg = substr(arg,RSTART+RLENGTH)
+		if (match(arg,/^[ \n\r\f\t]*"/) && match(arg,/"[^"]*"/)) {
+		    attrs[attr] = substr(arg,RSTART+1,RLENGTH-2)
+		    arg = substr(arg,RSTART+RLENGTH)
+		} else if (match(arg,/^[^ \n\r\g\t]*/)) {
+		    attrs[attr] = substr(arg,RSTART,RLENGTH)
+		    arg = substr(arg,RSTART+RLENGTH)
+		}
+	    }
+	    # callbacks
+	    if (match(tag,"^/")) {
+		endElement(substr(tag,2))
+	    } else {
+		startElement(tag,attrs)
+		if (match(str,"/$")) { endElement(tag) }
+	    }
+	} 
+    }	    
+}
+EOF
+
+    # prepare djvused script
+    dsedscript="$tempdir/dsed"
+    if test -z "$run" 
+    then
+        "$pdftotext" -bbox "$infile" "-" \
+            | awk -f $xml2dsed dpi=$dpi dometa=$popplermeta dotext=$popplertext \
+            > "$dsedscript"
+    else
+        $run "$pdftotext" -bbox "$infile" "-" \
+            \| awk -f $xml2dsed dpi=$dpi dometa=$popplermeta dotext=$popplertext \
+            \> "$dsedscript"
+    fi
+    
+    # execute dsed script
+    $run "$djvused" $dsedverbosity -f "$dsedscript" -s "$outfile"
+fi
--- djvulibre-3.5.27.1.orig/tools/djvudigital.1
+++ djvulibre-3.5.27.1/tools/djvudigital.1
@@ -158,6 +158,38 @@ Insert extra arguments on the command li
 program
 .BR csepdjvu " or " msepdjvu "."
 .TP
+.BI "--poppler=" "keywords"
+This option causes
+.B djvudigital
+to extract additional information from PDF files using the tool
+.B pdftotext
+that comes bundled with the Poppler library.
+Selected information is then added to the djvu file
+as a postprocessing step. This option is ignored
+when the input file is not a PDF file.
+Argument
+.I keywords
+is a comma separated list of keywords.
+When this list contains keyword
+.BR meta ,
+the metadata extracted by 
+.B pdftotext
+is inserted into the djvu file.
+When this list contains keyword
+.BR text ,
+the textual information extracted by
+.B pdftotext
+is inserted into the djvu file,
+possibly replacing the information
+gathered using the options
+.BR --words
+or
+.BR --lines .
+This is useful for instance when a scanned
+PDF file contains a hidden text layer that
+is not recognized by Ghostscript and therefore
+not passed to the djvudigital backend.
+.TP
 .BI "--sepfile"
 Produces a separated data file instead of a DjVu file. Program
 .BR csepdjvu 
@@ -227,6 +259,32 @@ by the environment variable
 and continues with command line executables named
 .BR msepdjvu " and " csepdjvu "."
 
+.SH OTHER PROGRAMS
+
+The option
+.BI "--poppler=" "keywords"
+relies on the tool
+.B pdftotext
+that comes with the Poppler library
+and the tool
+.B djvused
+that comes with djvulibre.
+Only recent versions of 
+.B pdftotext
+that accept the option
+.B -bbox
+are supported.
+Both tools are searched by first trying
+the files specified by the environment variables
+.B PDFTOTEXT
+and 
+.BR DJVUSED ,
+and then trying executables named 
+.B pdftotext
+or 
+.B djvused 
+found along the shell executable path.
+
 .SH CREDITS
 
 The first version of this converter was written 
--- djvulibre-3.5.27.1.orig/tools/djvuextract.cpp
+++ djvulibre-3.5.27.1/tools/djvuextract.cpp
@@ -208,6 +208,7 @@ main(int argc, char **argv)
   GArray<GUTF8String> dargv(0,argc-1);
   for(int i=0;i<argc;++i)
     dargv[i]=GNativeString(argv[i]);
+  int retcode = 0;
   G_TRY
     {
       int i;
@@ -217,7 +218,7 @@ main(int argc, char **argv)
       for(i=1;i<argc;i++)
 	 if (!dargv[i].cmp("-page=", 6))
            {
-              page_num = dargv[i].substr(6,dargv[i].length()).toInt() - 1; // atoi(6+(const char *)dargv[i]) - 1;
+	     page_num = dargv[i].substr(6,dargv[i].length()).toInt() - 1;
              for(int j=i;j<argc-1;j++) 
                dargv[j]=dargv[j+1];
              argc--;
@@ -253,6 +254,7 @@ main(int argc, char **argv)
           if (mbs.size() == 0)
             {
               DjVuPrintErrorUTF8("  %s --> not found!\n", (const char *)dargv[i]);
+	      retcode = 64;
             }
           else
             {
@@ -271,5 +273,5 @@ main(int argc, char **argv)
       exit(1);
     }
   G_ENDCATCH;
-  return 0;
+  return retcode;
 }
--- djvulibre-3.5.27.1.orig/tools/djvumake.cpp
+++ djvulibre-3.5.27.1/tools/djvumake.cpp
@@ -356,6 +356,8 @@ analyze_jb2_chunk(const GURL &url)
 void
 analyze_incl_chunk(const GURL &url)
 {
+  if (! url.is_file())
+    return;
   GP<ByteStream> gbs = ByteStream::create(url,"rb");
   char buffer[24];
   memset(buffer, 0, sizeof(buffer));
@@ -955,7 +957,7 @@ main(int argc, char **argv)
             }
           else if (!dargv[i].cmp("INCL=",5))
             {
-              create_incl_chunk(iff, "INCL", GURL::Filename::UTF8(5+(const char *)dargv[i]).fname());
+              create_incl_chunk(iff, "INCL", (const char *)GUTF8String(dargv[i].substr(5,-1)));
               flag_contains_incl = 1;
             }
           else if (!dargv[i].cmp("PPM=",4))
--- djvulibre-3.5.27.1.orig/tools/djvused.cpp
+++ djvulibre-3.5.27.1/tools/djvused.cpp
@@ -66,6 +66,7 @@
 #include "GString.h"
 #include "DjVuDocEditor.h"
 #include "DjVuDumpHelper.h"
+#include "DjVuMessageLite.h"
 #include "BSByteStream.h"
 #include "DjVuText.h"
 #include "DjVuAnno.h"
@@ -2021,11 +2022,11 @@ command_set_thumbnails(ParsingByteStream
 {
   GUTF8String sizestr = pbs.get_token();
   if (! sizestr)
-    sizestr = "128";
+    sizestr = "192";
   if (! sizestr.is_int() )
     verror("expecting integer argument");
   int size = atoi(sizestr);
-  if (size<32 || size >256) 
+  if (size < 32 || size > 512) 
     verror("size should be between 32 and 256 (e.g. 128)");
   g().doc->generate_thumbnails(size, callback_thumbnails, NULL);
   modified = true;
@@ -2315,7 +2316,8 @@ execute()
       G_CATCH(ex)
         {
           vprint("Error (%s): %s",
-                 (const char*)ToNative(token), ex.get_cause());
+                 (const char*)ToNative(token), 
+                 (const char *)DjVuMessageLite::LookUpUTF8(ex.get_cause()));
           if (! verbose)
             G_RETHROW;
         }
--- djvulibre-3.5.27.1.orig/tools/jb2cmp/classify.cpp
+++ djvulibre-3.5.27.1/tools/jb2cmp/classify.cpp
@@ -15,8 +15,7 @@
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
  *
  * 
  * minidjvu is derived from DjVuLibre (http://djvu.sourceforge.net)
--- djvulibre-3.5.27.1.orig/tools/jb2cmp/classify.h
+++ djvulibre-3.5.27.1/tools/jb2cmp/classify.h
@@ -15,8 +15,7 @@
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
  *
  * 
  * minidjvu is derived from DjVuLibre (http://djvu.sourceforge.net)
--- djvulibre-3.5.27.1.orig/tools/jb2cmp/cuts.cpp
+++ djvulibre-3.5.27.1/tools/jb2cmp/cuts.cpp
@@ -15,8 +15,7 @@
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
  *
  * 
  * minidjvu is derived from DjVuLibre (http://djvu.sourceforge.net)
--- djvulibre-3.5.27.1.orig/tools/jb2cmp/frames.cpp
+++ djvulibre-3.5.27.1/tools/jb2cmp/frames.cpp
@@ -15,8 +15,7 @@
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
  *
  * 
  * minidjvu is derived from DjVuLibre (http://djvu.sourceforge.net)
--- djvulibre-3.5.27.1.orig/tools/jb2cmp/minidjvu.h
+++ djvulibre-3.5.27.1/tools/jb2cmp/minidjvu.h
@@ -15,8 +15,7 @@
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
  *
  * 
  * minidjvu is derived from DjVuLibre (http://djvu.sourceforge.net)
--- djvulibre-3.5.27.1.orig/tools/jb2cmp/patterns.cpp
+++ djvulibre-3.5.27.1/tools/jb2cmp/patterns.cpp
@@ -15,8 +15,7 @@
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
  *
  * 
  * minidjvu is derived from DjVuLibre (http://djvu.sourceforge.net)
--- djvulibre-3.5.27.1.orig/tools/jb2cmp/patterns.h
+++ djvulibre-3.5.27.1/tools/jb2cmp/patterns.h
@@ -15,8 +15,7 @@
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
  *
  * 
  * minidjvu is derived from DjVuLibre (http://djvu.sourceforge.net)
--- /dev/null
+++ djvulibre-3.5.27.1/tools/tiff2pdf.c.LIBTIFF
@@ -0,0 +1,5477 @@
+/* $Id: tiff2pdf.c,v 1.37.2.7 2009-01-01 00:10:43 bfriesen Exp $
+ *
+ * tiff2pdf - converts a TIFF image to a PDF document
+ *
+ * Copyright (c) 2003 Ross Finlayson
+ *
+ * Permission to use, copy, modify, distribute, and sell this software and 
+ * its documentation for any purpose is hereby granted without fee, provided
+ * that (i) the above copyright notices and this permission notice appear in
+ * all copies of the software and related documentation, and (ii) the name of
+ * Ross Finlayson may not be used in any advertising or
+ * publicity relating to the software without the specific, prior written
+ * permission of Ross Finlayson.
+ * 
+ * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
+ * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
+ * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
+ * 
+ * IN NO EVENT SHALL ROSS FINLAYSON BE LIABLE FOR
+ * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
+ * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
+ * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
+ * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
+ * OF THIS SOFTWARE.
+ */
+
+#include "tif_config.h"
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <ctype.h>
+#include <time.h>
+
+#if HAVE_UNISTD_H
+# include <unistd.h>
+#endif
+
+#ifdef HAVE_FCNTL_H
+# include <fcntl.h>
+#endif
+
+#ifdef HAVE_IO_H
+# include <io.h>
+#endif
+
+#include "tiffiop.h"
+#include "tiffio.h"
+
+#ifndef HAVE_GETOPT
+extern int getopt(int, char**, char*);
+#endif
+
+#define TIFF2PDF_MODULE "tiff2pdf"
+
+#define PS_UNIT_SIZE	72.0F
+
+/* This type is of PDF color spaces. */
+typedef enum {
+	T2P_CS_BILEVEL = 0x01,	/* Bilevel, black and white */
+	T2P_CS_GRAY = 0x02,	/* Single channel */
+	T2P_CS_RGB = 0x04,	/* Three channel tristimulus RGB */
+	T2P_CS_CMYK = 0x08,	/* Four channel CMYK print inkset */
+	T2P_CS_LAB = 0x10,	/* Three channel L*a*b* color space */
+	T2P_CS_PALETTE = 0x1000,/* One of the above with a color map */
+	T2P_CS_CALGRAY = 0x20,	/* Calibrated single channel */
+	T2P_CS_CALRGB = 0x40,	/* Calibrated three channel tristimulus RGB */
+	T2P_CS_ICCBASED = 0x80	/* ICC profile color specification */
+} t2p_cs_t;
+
+/* This type is of PDF compression types.  */
+typedef enum{
+	T2P_COMPRESS_NONE=0x00
+#ifdef CCITT_SUPPORT
+	, T2P_COMPRESS_G4=0x01
+#endif
+#if defined(JPEG_SUPPORT) || defined(OJPEG_SUPPORT)
+	, T2P_COMPRESS_JPEG=0x02
+#endif
+#ifdef ZIP_SUPPORT
+	, T2P_COMPRESS_ZIP=0x04
+#endif
+} t2p_compress_t;
+
+/* This type is whether TIFF image data can be used in PDF without transcoding. */
+typedef enum{
+	T2P_TRANSCODE_RAW=0x01, /* The raw data from the input can be used without recompressing */
+	T2P_TRANSCODE_ENCODE=0x02 /* The data from the input is perhaps unencoded and reencoded */
+} t2p_transcode_t;
+
+/* This type is of information about the data samples of the input image. */
+typedef enum{
+	T2P_SAMPLE_NOTHING=0x0000, /* The unencoded samples are normal for the output colorspace */
+	T2P_SAMPLE_ABGR_TO_RGB=0x0001, /* The unencoded samples are the result of ReadRGBAImage */
+	T2P_SAMPLE_RGBA_TO_RGB=0x0002, /* The unencoded samples are contiguous RGBA */
+	T2P_SAMPLE_RGBAA_TO_RGB=0x0004, /* The unencoded samples are RGBA with premultiplied alpha */
+	T2P_SAMPLE_YCBCR_TO_RGB=0x0008, 
+	T2P_SAMPLE_YCBCR_TO_LAB=0x0010, 
+	T2P_SAMPLE_REALIZE_PALETTE=0x0020, /* The unencoded samples are indexes into the color map */
+	T2P_SAMPLE_SIGNED_TO_UNSIGNED=0x0040, /* The unencoded samples are signed instead of unsignd */
+	T2P_SAMPLE_LAB_SIGNED_TO_UNSIGNED=0x0040, /* The L*a*b* samples have a* and b* signed */
+	T2P_SAMPLE_PLANAR_SEPARATE_TO_CONTIG=0x0100 /* The unencoded samples are separate instead of contiguous */
+} t2p_sample_t;
+
+/* This type is of error status of the T2P struct. */
+typedef enum{
+	T2P_ERR_OK = 0, /* This is the value of t2p->t2p_error when there is no error */
+	T2P_ERR_ERROR = 1 /* This is the value of t2p->t2p_error when there was an error */
+} t2p_err_t;
+
+/* This struct defines a logical page of a TIFF. */
+typedef struct {
+	tdir_t page_directory;
+	uint32 page_number;
+	ttile_t page_tilecount;
+	uint32 page_extra;
+} T2P_PAGE;
+
+/* This struct defines a PDF rectangle's coordinates. */
+typedef struct {
+	float x1;
+	float y1;
+	float x2;
+	float y2;
+	float mat[9];
+} T2P_BOX;
+
+/* This struct defines a tile of a PDF.  */
+typedef struct {
+	T2P_BOX tile_box;
+} T2P_TILE;
+
+/* This struct defines information about the tiles on a PDF page. */
+typedef struct {
+	ttile_t tiles_tilecount;
+	uint32 tiles_tilewidth;
+	uint32 tiles_tilelength;
+	uint32 tiles_tilecountx;
+	uint32 tiles_tilecounty;
+	uint32 tiles_edgetilewidth;
+	uint32 tiles_edgetilelength;
+	T2P_TILE* tiles_tiles;
+} T2P_TILES;
+
+/* This struct is the context of a function to generate PDF from a TIFF. */
+typedef struct {
+	t2p_err_t t2p_error;
+	T2P_PAGE* tiff_pages;
+	T2P_TILES* tiff_tiles;
+	tdir_t tiff_pagecount;
+	uint16 tiff_compression;
+	uint16 tiff_photometric;
+	uint16 tiff_fillorder;
+	uint16 tiff_bitspersample;
+	uint16 tiff_samplesperpixel;
+	uint16 tiff_planar;
+	uint32 tiff_width;
+	uint32 tiff_length;
+	float tiff_xres;
+	float tiff_yres;
+	uint16 tiff_orientation;
+	toff_t tiff_dataoffset;
+	tsize_t tiff_datasize;
+	uint16 tiff_resunit;
+	uint16 pdf_centimeters;
+	uint16 pdf_overrideres;
+	uint16 pdf_overridepagesize;
+	float pdf_defaultxres;
+	float pdf_defaultyres;
+	float pdf_xres;
+	float pdf_yres;
+	float pdf_defaultpagewidth;
+	float pdf_defaultpagelength;
+	float pdf_pagewidth;
+	float pdf_pagelength;
+	float pdf_imagewidth;
+	float pdf_imagelength;
+	T2P_BOX pdf_mediabox;
+	T2P_BOX pdf_imagebox;
+	uint16 pdf_majorversion;
+	uint16 pdf_minorversion;
+	uint32 pdf_catalog;
+	uint32 pdf_pages;
+	uint32 pdf_info;
+	uint32 pdf_palettecs;
+	uint16 pdf_fitwindow;
+	uint32 pdf_startxref;
+	unsigned char* pdf_fileid;
+	unsigned char* pdf_datetime;
+	unsigned char* pdf_creator;
+	unsigned char* pdf_author;
+	unsigned char* pdf_title;
+	unsigned char* pdf_subject;
+	unsigned char* pdf_keywords;
+	t2p_cs_t pdf_colorspace;
+	uint16 pdf_colorspace_invert;
+	uint16 pdf_switchdecode;
+	uint16 pdf_palettesize;
+	unsigned char* pdf_palette;
+	int pdf_labrange[4];
+	t2p_compress_t pdf_defaultcompression;
+	uint16 pdf_defaultcompressionquality;
+	t2p_compress_t pdf_compression;
+	uint16 pdf_compressionquality;
+	uint16 pdf_nopassthrough;
+	t2p_transcode_t pdf_transcode;
+	t2p_sample_t pdf_sample;
+	uint32* pdf_xrefoffsets;
+	uint32 pdf_xrefcount;
+	tdir_t pdf_page;
+#ifdef OJPEG_SUPPORT
+	tdata_t pdf_ojpegdata;
+	uint32 pdf_ojpegdatalength;
+	uint32 pdf_ojpegiflength;
+#endif
+	float tiff_whitechromaticities[2];
+	float tiff_primarychromaticities[6];
+	float tiff_referenceblackwhite[2];
+	float* tiff_transferfunction[3];
+	int pdf_image_interpolate;	/* 0 (default) : do not interpolate,
+					   1 : interpolate */
+	uint16 tiff_transferfunctioncount;
+	uint32 pdf_icccs;
+	uint32 tiff_iccprofilelength;
+	tdata_t tiff_iccprofile;
+
+	/* fields for custom read/write procedures */
+	FILE *outputfile;
+	int outputdisable;
+	tsize_t outputwritten;
+} T2P;
+
+/* These functions are called by main. */
+
+void tiff2pdf_usage(void);
+int tiff2pdf_match_paper_size(float*, float*, char*);
+
+/* These functions are used to generate a PDF from a TIFF. */ 
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+T2P* t2p_init(void);
+void t2p_validate(T2P*);
+tsize_t t2p_write_pdf(T2P*, TIFF*, TIFF*);
+void t2p_free(T2P*);
+
+#ifdef __cplusplus
+}
+#endif
+
+void t2p_read_tiff_init(T2P*, TIFF*);
+int t2p_cmp_t2p_page(const void*, const void*);
+void t2p_read_tiff_data(T2P*, TIFF*);
+void t2p_read_tiff_size(T2P*, TIFF*);
+void t2p_read_tiff_size_tile(T2P*, TIFF*, ttile_t);
+int t2p_tile_is_right_edge(T2P_TILES, ttile_t);
+int t2p_tile_is_bottom_edge(T2P_TILES, ttile_t);
+int t2p_tile_is_edge(T2P_TILES, ttile_t);
+int t2p_tile_is_corner_edge(T2P_TILES, ttile_t);
+tsize_t t2p_readwrite_pdf_image(T2P*, TIFF*, TIFF*);
+tsize_t t2p_readwrite_pdf_image_tile(T2P*, TIFF*, TIFF*, ttile_t);
+#ifdef OJPEG_SUPPORT
+int t2p_process_ojpeg_tables(T2P*, TIFF*);
+#endif
+#ifdef JPEG_SUPPORT
+int t2p_process_jpeg_strip(unsigned char*, tsize_t*, unsigned char*, tsize_t*, tstrip_t, uint32);
+#endif
+void t2p_tile_collapse_left(tdata_t, tsize_t, uint32, uint32, uint32);
+void t2p_write_advance_directory(T2P*, TIFF*);
+tsize_t t2p_sample_planar_separate_to_contig(T2P*, unsigned char*, unsigned char*, tsize_t);
+tsize_t t2p_sample_realize_palette(T2P*, unsigned char*);
+tsize_t t2p_sample_abgr_to_rgb(tdata_t, uint32);
+tsize_t t2p_sample_rgba_to_rgb(tdata_t, uint32);
+tsize_t t2p_sample_rgbaa_to_rgb(tdata_t, uint32);
+tsize_t t2p_sample_lab_signed_to_unsigned(tdata_t, uint32);
+tsize_t t2p_write_pdf_header(T2P*, TIFF*);
+tsize_t t2p_write_pdf_obj_start(uint32, TIFF*);
+tsize_t t2p_write_pdf_obj_end(TIFF*);
+tsize_t t2p_write_pdf_name(unsigned char*, TIFF*);
+tsize_t t2p_write_pdf_string(unsigned char*, TIFF*);
+tsize_t t2p_write_pdf_stream(tdata_t, tsize_t, TIFF*);
+tsize_t t2p_write_pdf_stream_start(TIFF*);
+tsize_t t2p_write_pdf_stream_end(TIFF*);
+tsize_t t2p_write_pdf_stream_dict(tsize_t, uint32, TIFF*);
+tsize_t t2p_write_pdf_stream_dict_start(TIFF*);
+tsize_t t2p_write_pdf_stream_dict_end(TIFF*);
+tsize_t t2p_write_pdf_stream_length(tsize_t, TIFF*);
+tsize_t t2p_write_pdf_catalog(T2P*, TIFF*);
+tsize_t t2p_write_pdf_info(T2P*, TIFF*, TIFF*);
+void t2p_pdf_currenttime(T2P*);
+void t2p_pdf_tifftime(T2P*, TIFF*);
+tsize_t t2p_write_pdf_pages(T2P*, TIFF*);
+tsize_t t2p_write_pdf_page(uint32, T2P*, TIFF*);
+void t2p_compose_pdf_page(T2P*);
+void t2p_compose_pdf_page_orient(T2P_BOX*, uint16);
+void t2p_compose_pdf_page_orient_flip(T2P_BOX*, uint16);
+tsize_t t2p_write_pdf_page_content(T2P*, TIFF*);
+tsize_t t2p_write_pdf_xobject_stream_dict(ttile_t, T2P*, TIFF*);
+tsize_t t2p_write_pdf_xobject_cs(T2P*, TIFF*);
+tsize_t t2p_write_pdf_transfer(T2P*, TIFF*);
+tsize_t t2p_write_pdf_transfer_dict(T2P*, TIFF*, uint16);
+tsize_t t2p_write_pdf_transfer_stream(T2P*, TIFF*, uint16);
+tsize_t t2p_write_pdf_xobject_calcs(T2P*, TIFF*);
+tsize_t t2p_write_pdf_xobject_icccs(T2P*, TIFF*);
+tsize_t t2p_write_pdf_xobject_icccs_dict(T2P*, TIFF*);
+tsize_t t2p_write_pdf_xobject_icccs_stream(T2P*, TIFF*);
+tsize_t t2p_write_pdf_xobject_cs_stream(T2P*, TIFF*);
+tsize_t t2p_write_pdf_xobject_decode(T2P*, TIFF*);
+tsize_t t2p_write_pdf_xobject_stream_filter(ttile_t, T2P*, TIFF*);
+tsize_t t2p_write_pdf_xreftable(T2P*, TIFF*);
+tsize_t t2p_write_pdf_trailer(T2P*, TIFF*);
+
+static void
+t2p_disable(TIFF *tif)
+{
+	T2P *t2p = (T2P*) TIFFClientdata(tif);
+	t2p->outputdisable = 1;
+}
+
+static void
+t2p_enable(TIFF *tif)
+{
+	T2P *t2p = (T2P*) TIFFClientdata(tif);
+	t2p->outputdisable = 0;
+}
+
+/*
+ * Procs for TIFFClientOpen
+ */
+
+static tsize_t 
+t2pReadFile(TIFF *tif, tdata_t data, tsize_t size)
+{
+	thandle_t client = TIFFClientdata(tif);
+	TIFFReadWriteProc proc =  TIFFGetReadProc(tif);
+	if (proc)
+		return proc(client, data, size);
+	return -1;
+}
+
+static tsize_t 
+t2pWriteFile(TIFF *tif, tdata_t data, tsize_t size)
+{
+	thandle_t client = TIFFClientdata(tif);
+	TIFFReadWriteProc proc =  TIFFGetWriteProc(tif);
+	if (proc)
+		return proc(client, data, size);
+	return -1;
+}
+
+static toff_t
+t2pSeekFile(TIFF *tif, toff_t offset, int whence)
+{
+	thandle_t client = TIFFClientdata(tif);
+	TIFFSeekProc proc =  TIFFGetSeekProc(tif);
+	if (proc)
+		return proc(client, offset, whence);
+	return -1;
+}
+
+static tsize_t 
+t2p_readproc(thandle_t handle, tdata_t data, tsize_t size) 
+{
+	(void) handle, (void) data, (void) size;
+	return -1;
+}
+
+static tsize_t 
+t2p_writeproc(thandle_t handle, tdata_t data, tsize_t size) 
+{
+	T2P *t2p = (T2P*) handle;
+	if (t2p->outputdisable <= 0 && t2p->outputfile) {
+		tsize_t written = fwrite(data, 1, size, t2p->outputfile);
+		t2p->outputwritten += written;
+		return written;
+	}
+	return size; 
+}
+
+static toff_t 
+t2p_seekproc(thandle_t handle, toff_t offset, int whence) 
+{ 
+	T2P *t2p = (T2P*) handle;
+	if (t2p->outputdisable <= 0 && t2p->outputfile)
+		return fseek(t2p->outputfile, offset, whence);
+	return offset;
+}
+
+static int 
+t2p_closeproc(thandle_t handle)
+{ 
+	(void) handle;
+	return 0; 
+}
+
+static toff_t 
+t2p_sizeproc(thandle_t handle) 
+{
+	(void) handle;
+	return -1;
+}
+
+static int 
+t2p_mapproc(thandle_t handle, tdata_t *data, toff_t *offset) 
+{ 
+	(void) handle, (void) data, (void) offset;
+	return -1; 
+}
+
+static void 
+t2p_unmapproc(thandle_t handle, tdata_t data, toff_t offset)
+{ 
+	(void) handle, (void) data, (void) offset;
+}
+
+static uint64
+checkAdd64(uint64 summand1, uint64 summand2, T2P* t2p)
+{
+	uint64 bytes = summand1 + summand2;
+
+	if (bytes - summand1 != summand2) {
+		TIFFError(TIFF2PDF_MODULE, "Integer overflow");
+		t2p->t2p_error = T2P_ERR_ERROR;
+		bytes = 0;
+	}
+
+	return bytes;
+}
+
+static uint64
+checkMultiply64(uint64 first, uint64 second, T2P* t2p)
+{
+	uint64 bytes = first * second;
+
+	if (second && bytes / second != first) {
+		TIFFError(TIFF2PDF_MODULE, "Integer overflow");
+		t2p->t2p_error = T2P_ERR_ERROR;
+		bytes = 0;
+	}
+
+	return bytes;
+}
+
+/*
+
+  This is the main function.
+
+  The program converts one TIFF file to one PDF file, including multiple page 
+  TIFF files, tiled TIFF files, black and white. grayscale, and color TIFF 
+  files that contain data of TIFF photometric interpretations of bilevel, 
+  grayscale, RGB, YCbCr, CMYK separation, and ICC L*a*b* as supported by 
+  libtiff and PDF.
+
+  If you have multiple TIFF files to convert into one PDF file then use tiffcp 
+  or other program to concatenate the files into a multiple page TIFF file.  
+  If the input TIFF file is of huge dimensions (greater than 10000 pixels height
+  or width) convert the input image to a tiled TIFF if it is not already.
+
+  The standard output is standard output.  Set the output file name with the 
+  "-o output.pdf" option.
+
+  All black and white files are compressed into a single strip CCITT G4 Fax 
+  compressed PDF, unless tiled, where tiled black and white images are 
+  compressed into tiled CCITT G4 Fax compressed PDF, libtiff CCITT support 
+  is assumed.
+
+  Color and grayscale data can be compressed using either JPEG compression, 
+  ITU-T T.81, or Zip/Deflate LZ77 compression, per PNG 1.2 and RFC 1951.  Set 
+  the compression type using the -j or -z options.  JPEG compression support 
+  requires that libtiff be configured with JPEG support, and Zip/Deflate 
+  compression support requires that libtiff is configured with Zip support, 
+  in tiffconf.h.  Use only one or the other of -j and -z.  The -q option 
+  sets the image compression quality, that is 1-100 with libjpeg JPEG 
+  compression and one of 1, 10, 11, 12, 13, 14, or 15 for PNG group compression 
+  predictor methods, add 100, 200, ..., 900 to set zlib compression quality 1-9.
+  PNG Group differencing predictor methods are not currently implemented.
+
+  If the input TIFF contains single strip CCITT G4 Fax compressed information, 
+  then that is written to the PDF file without transcoding, unless the options 
+  of no compression and no passthrough are set, -d and -n.
+
+  If the input TIFF contains JPEG or single strip Zip/Deflate compressed 
+  information, and they are configured, then that is written to the PDF file 
+  without transcoding, unless the options of no compression and no passthrough 
+  are set.
+
+  The default page size upon which the TIFF image is placed is determined by 
+  the resolution and extent of the image data.  Default values for the TIFF 
+  image resolution can be set using the -x and -y options.  The page size can 
+  be set using the -p option for paper size, or -w and -l for paper width and 
+  length, then each page of the TIFF image is centered on its page.  The 
+  distance unit for default resolution and page width and length can be set 
+  by the -u option, the default unit is inch.
+
+  Various items of the output document information can be set with the -e, -c, 
+  -a, -t, -s, and -k tags.  Setting the argument of the option to "" for these 
+  tags causes the relevant document information field to be not written.  Some 
+  of the document information values otherwise get their information from the 
+  input TIFF image, the software, author, document name, and image description.
+
+  The output PDF file conforms to the PDF 1.1 specification or PDF 1.2 if using 
+  Zip/Deflate compression.  
+  
+  The Portable Document Format (PDF) specification is copyrighted by Adobe 
+  Systems, Incorporated.  Todos derechos reservados.
+
+  Here is a listing of the usage example and the options to the tiff2pdf 
+  program that is part of the libtiff distribution.  Options followed by 
+  a colon have a required argument.
+  
+    usage:  tiff2pdf [options] input.tif
+
+    options:
+    -o: output to file name
+
+    -j: compress with JPEG (requires libjpeg configured with libtiff)
+    -z: compress with Zip/Deflate (requires zlib configured with libtiff)
+    -q: compression quality
+    -n: no compressed data passthrough
+    -d: do not compress (decompress)
+    -i: invert colors
+    -u: set distance unit, 'i' for inch, 'm' for centimeter
+    -x: set x resolution default
+    -y: set y resolution default
+    -w: width in units
+    -l: length in units
+    -r: 'd' for resolution default, 'o' for resolution override
+    -p: paper size, eg "letter", "legal", "a4"
+    -f: set pdf "fit window" user preference
+    -b:	set PDF "Interpolate" user preference
+    -e: date, overrides image or current date/time default, YYYYMMDDHHMMSS
+    -c: creator, overrides image software default
+    -a: author, overrides image artist default
+    -t: title, overrides image document name default
+    -s: subject, overrides image image description default
+    -k: keywords
+
+    -h: usage
+
+    examples:
+
+        tiff2pdf -o output.pdf input.tiff
+
+    The above example would generate the file output.pdf from input.tiff.
+
+        tiff2pdf input.tiff
+
+    The above example would generate PDF output from input.tiff and write it 
+    to standard output.
+
+        tiff2pdf -j -p letter -o output.pdf input.tiff
+
+    The above example would generate the file output.pdf from input.tiff, 
+    putting the image pages on a letter sized page, compressing the output 
+    with JPEG.
+
+	Please report bugs through:
+	 
+	http://bugzilla.remotesensing.org/buglist.cgi?product=libtiff
+
+    See also libtiff.3t, tiffcp.
+  */
+
+int main(int argc, char** argv){
+
+	extern char *optarg;
+	extern int optind;
+	const char *outfilename = NULL;
+        T2P *t2p = NULL;
+	TIFF *input = NULL, *output = NULL;
+	tsize_t written = 0;
+	int c;
+
+	t2p = t2p_init();
+
+	if (t2p == NULL){
+		TIFFError(TIFF2PDF_MODULE, "Can't initialize context");
+		goto fail;
+	}
+
+	while (argv &&
+	       (c = getopt(argc, argv,
+			   "o:q:u:x:y:w:l:r:p:e:c:a:t:s:k:jzndifbh")) != -1){
+		switch (c) {
+			case 'o':
+				outfilename = optarg;
+				break;
+#ifdef JPEG_SUPPORT
+			case 'j':  
+				t2p->pdf_defaultcompression=T2P_COMPRESS_JPEG;
+				break;
+#endif
+#ifndef JPEG_SUPPORT
+			case 'j':  
+				TIFFWarning(
+					TIFF2PDF_MODULE, 
+					"JPEG support in libtiff required for JPEG compression, ignoring option");
+				break;
+#endif
+#ifdef ZIP_SUPPORT
+			case 'z':  
+				t2p->pdf_defaultcompression=T2P_COMPRESS_ZIP;
+				break;
+#endif
+#ifndef ZIP_SUPPORT
+			case 'z':  
+				TIFFWarning(
+					TIFF2PDF_MODULE, 
+					"Zip support in libtiff required for Zip compression, ignoring option");
+				break;
+#endif
+			case 'q': 
+				t2p->pdf_defaultcompressionquality=atoi(optarg);
+				break;
+			case 'n': 
+				t2p->pdf_nopassthrough=1;
+				break;
+			case 'd': 
+				t2p->pdf_defaultcompression=T2P_COMPRESS_NONE;
+				break;
+			case 'u': 
+				if(optarg[0]=='m'){
+					t2p->pdf_centimeters=1;
+				}
+				break;
+			case 'x': 
+				t2p->pdf_defaultxres = 
+					(float)atof(optarg) / (t2p->pdf_centimeters?2.54F:1.0F);
+				break;
+			case 'y': 
+				t2p->pdf_defaultyres = 
+					(float)atof(optarg) / (t2p->pdf_centimeters?2.54F:1.0F);
+				break;
+			case 'w': 
+				t2p->pdf_overridepagesize=1;
+				t2p->pdf_defaultpagewidth = 
+					((float)atof(optarg) * PS_UNIT_SIZE) / (t2p->pdf_centimeters?2.54F:1.0F);
+				break;
+			case 'l': 
+				t2p->pdf_overridepagesize=1;
+				t2p->pdf_defaultpagelength = 
+					((float)atof(optarg) * PS_UNIT_SIZE) / (t2p->pdf_centimeters?2.54F:1.0F);
+				break;
+			case 'r': 
+				if(optarg[0]=='o'){
+					t2p->pdf_overrideres=1;
+				}
+				break;
+			case 'p': 
+				if(tiff2pdf_match_paper_size(
+					&(t2p->pdf_defaultpagewidth), 
+					&(t2p->pdf_defaultpagelength), 
+					optarg)){
+					t2p->pdf_overridepagesize=1;
+				} else {
+					TIFFWarning(TIFF2PDF_MODULE, 
+					"Unknown paper size %s, ignoring option",
+						optarg);
+				}
+				break;
+			case 'i':
+				t2p->pdf_colorspace_invert=1;
+				break;
+			case 'f': 
+				t2p->pdf_fitwindow=1;
+				break;
+			case 'e':
+				t2p->pdf_datetime =
+					(unsigned char*)_TIFFmalloc(17);
+				if(t2p->pdf_datetime==NULL){
+					TIFFError(TIFF2PDF_MODULE, 
+				"Can't allocate %u bytes of memory for main", 
+						17); 
+					goto fail;
+				}
+				if(strlen(optarg)==0){
+					t2p->pdf_datetime[0] = 0;
+				} else {
+					if(strlen(optarg)>14){optarg[14]=0;}
+					t2p->pdf_datetime[0] = 'D';
+					t2p->pdf_datetime[1] = ':';
+					strcpy((char *)t2p->pdf_datetime + 2,
+					       optarg);
+				}
+				break;
+			case 'c': 
+				t2p->pdf_creator = (unsigned char *)
+					_TIFFmalloc(strlen(optarg) + 1);
+				if(t2p->pdf_creator==NULL){
+					TIFFError(TIFF2PDF_MODULE, 
+				"Can't allocate %u bytes of memory for main", 
+						  strlen(optarg) + 1); 
+					goto fail;
+				}
+				strcpy((char *)t2p->pdf_creator, optarg);
+				t2p->pdf_creator[strlen(optarg)] = 0;
+				break;
+			case 'a': 
+				t2p->pdf_author = (unsigned char *)
+					_TIFFmalloc(strlen(optarg) + 1);
+				if(t2p->pdf_author==NULL){
+					TIFFError(
+						TIFF2PDF_MODULE, 
+				"Can't allocate %u bytes of memory for main", 
+						strlen(optarg) + 1); 
+					goto fail;
+				}
+				strcpy((char *)t2p->pdf_author, optarg);
+				t2p->pdf_author[strlen(optarg)]=0;
+				break;
+			case 't': 
+				t2p->pdf_title = (unsigned char*)
+					_TIFFmalloc(strlen(optarg)+1);
+				if(t2p->pdf_title==NULL){
+					TIFFError(
+						TIFF2PDF_MODULE, 
+				"Can't allocate %u bytes of memory for main", 
+						strlen(optarg) + 1); 
+					goto fail;
+				}
+				strcpy((char *)t2p->pdf_title, optarg);
+				t2p->pdf_title[strlen(optarg)] = 0;
+				break;
+			case 's': 
+				t2p->pdf_subject = (unsigned char*)
+					_TIFFmalloc(strlen(optarg) + 1);
+				if(t2p->pdf_subject==NULL){
+					TIFFError(
+						TIFF2PDF_MODULE, 
+				"Can't allocate %u bytes of memory for main", 
+						strlen(optarg)+1); 
+					goto fail;
+				}
+				strcpy((char *)t2p->pdf_subject, optarg);
+				t2p->pdf_subject[strlen(optarg)]=0;
+				break;
+			case 'k': 
+				t2p->pdf_keywords = (unsigned char*)
+					_TIFFmalloc(strlen(optarg) + 1);
+				if(t2p->pdf_keywords==NULL){
+					TIFFError(
+						TIFF2PDF_MODULE, 
+				"Can't allocate %u bytes of memory for main", 
+						strlen(optarg) + 1); 
+					goto fail;
+				}
+				strcpy((char *)t2p->pdf_keywords, optarg);
+				t2p->pdf_keywords[strlen(optarg)] = 0;
+				break;		
+			case 'b':
+				t2p->pdf_image_interpolate = 1;
+				break;
+			case 'h': 
+			case '?': 
+				tiff2pdf_usage();
+				goto success;
+				break;
+		}
+		}
+
+	/*
+	 * Input
+	 */
+	if(argc > optind) {
+		input = TIFFOpen(argv[optind++], "r");
+		if (input==NULL) {
+			TIFFError(TIFF2PDF_MODULE, 
+				  "Can't open input file %s for reading", 
+				  argv[optind-1]);
+			goto fail;
+		}
+	} else {
+		TIFFError(TIFF2PDF_MODULE, "No input file specified"); 
+		tiff2pdf_usage();
+		goto fail;
+	}
+
+	if(argc > optind) {
+		TIFFError(TIFF2PDF_MODULE, 
+			  "No support for multiple input files"); 
+		tiff2pdf_usage();
+		goto fail;
+	}
+
+	/*
+	 * Output
+	 */
+	t2p->outputdisable = 0;
+	if (outfilename) {
+		t2p->outputfile = fopen(outfilename, "wb");
+		if (t2p->outputfile == NULL) {
+			TIFFError(TIFF2PDF_MODULE,
+				  "Can't open output file %s for writing",
+				  outfilename);
+			goto fail;
+		}
+	} else {
+		outfilename = "-";
+		t2p->outputfile = stdout;
+	}
+
+	output = TIFFClientOpen(outfilename, "w", (thandle_t) t2p,
+				t2p_readproc, t2p_writeproc, t2p_seekproc, 
+				t2p_closeproc, t2p_sizeproc, 
+				t2p_mapproc, t2p_unmapproc );
+	if (output == NULL) {
+		TIFFError(TIFF2PDF_MODULE,
+			  "Can't initialize output descriptor");
+		goto fail;
+	}
+	
+	/*
+	 * Validate
+	 */
+	t2p_validate(t2p);
+	t2pSeekFile(output, (toff_t) 0, SEEK_SET);
+
+	/*
+	 * Write
+	 */
+	written = t2p_write_pdf(t2p, input, output);
+	if (t2p->t2p_error != 0) {
+		TIFFError(TIFF2PDF_MODULE,
+			  "An error occurred creating output PDF file");
+		goto fail;
+	}
+
+success:
+	if (output != NULL)
+		TIFFClose(output);
+	if (t2p != NULL)
+		t2p_free(t2p);
+	return(EXIT_SUCCESS);
+
+fail:
+	if(input != NULL)
+		TIFFClose(input);
+	if (output != NULL)
+		TIFFClose(output);
+	if (t2p != NULL)
+		t2p_free(t2p);
+	return(EXIT_FAILURE);
+  
+}
+
+void tiff2pdf_usage(){
+	char* lines[]={
+	"usage:  tiff2pdf [options] input.tiff",
+	"options:",
+	" -o: output to file name",
+#ifdef JPEG_SUPPORT
+	" -j: compress with JPEG", 
+#endif
+#ifdef ZIP_SUPPORT
+	" -z: compress with Zip/Deflate",
+#endif
+	" -q: compression quality",
+	" -n: no compressed data passthrough",
+	" -d: do not compress (decompress)",
+	" -i: invert colors",
+	" -u: set distance unit, 'i' for inch, 'm' for centimeter",
+	" -x: set x resolution default in dots per unit",
+	" -y: set y resolution default in dots per unit",
+	" -w: width in units",
+	" -l: length in units",
+	" -r: 'd' for resolution default, 'o' for resolution override",
+	" -p: paper size, eg \"letter\", \"legal\", \"A4\"",
+	" -f: set PDF \"Fit Window\" user preference",
+	" -e: date, overrides image or current date/time default, YYYYMMDDHHMMSS",
+	" -c: sets document creator, overrides image software default",
+	" -a: sets document author, overrides image artist default",
+	" -t: sets document title, overrides image document name default",
+	" -s: sets document subject, overrides image image description default",
+	" -k: sets document keywords",
+	" -b: set PDF \"Interpolate\" user preference",
+	" -h: usage",
+	NULL
+	};
+	int i=0;
+
+	fprintf(stderr, "%s\n\n", TIFFGetVersion());
+	for (i=0;lines[i]!=NULL;i++){
+		fprintf(stderr, "%s\n", lines[i]);
+	}
+
+	return;
+}
+
+int tiff2pdf_match_paper_size(float* width, float* length, char* papersize){
+
+	size_t i, len;
+	const char* sizes[]={
+		"LETTER", "A4", "LEGAL",
+		"EXECUTIVE", "LETTER", "LEGAL", "LEDGER", "TABLOID", 
+		"A", "B", "C", "D", "E", "F", "G", "H", "J", "K", 
+		"A10", "A9", "A8", "A7", "A6", "A5", "A4", "A3", "A2", "A1", "A0", 
+		"2A0", "4A0", "2A", "4A", 
+		"B10", "B9", "B8", "B7", "B6", "B5", "B4", "B3", "B2", "B1", "B0", 
+		"JISB10", "JISB9", "JISB8", "JISB7", "JISB6", "JISB5", "JISB4", 
+		"JISB3", "JISB2", "JISB1", "JISB0", 
+		"C10", "C9", "C8", "C7", "C6", "C5", "C4", "C3", "C2", "C1", "C0", 
+		"RA2", "RA1", "RA0", "SRA4", "SRA3", "SRA2", "SRA1", "SRA0", 
+		"A3EXTRA", "A4EXTRA", 
+		"STATEMENT", "FOLIO", "QUARTO", 
+		NULL
+	} ;
+	const int widths[]={
+		612, 595, 612,
+		522, 612,612,792,792,
+		612,792,1224,1584,2448,2016,792,2016,2448,2880,
+		74,105,147,210,298,420,595,842,1191,1684,2384,3370,4768,3370,4768,
+		88,125,176,249,354,499,709,1001,1417,2004,2835,
+		91,128,181,258,363,516,729,1032,1460,2064,2920,
+		79,113,162,230,323,459,649,918,1298,1298,2599,
+		1219,1729,2438,638,907,1276,1814,2551,
+		914,667,
+		396, 612, 609, 
+		0
+	};
+	const int lengths[]={
+		792,842,1008,
+		756,792,1008,1224,1224,
+		792,1224,1584,2448,3168,2880,6480,10296,12672,10296,
+		105,147,210,298,420,595,842,1191,1684,2384,3370,4768,6741,4768,6741,
+		125,176,249,354,499,709,1001,1417,2004,2835,4008,
+		128,181,258,363,516,729,1032,1460,2064,2920,4127,
+		113,162,230,323,459,649,918,1298,1837,1837,3677,
+		1729,2438,3458,907,1276,1814,2551,3628,
+		1262,914,
+		612, 936, 780, 
+		0
+	};
+
+	len=strlen(papersize);
+	for(i=0;i<len;i++){
+		papersize[i]=toupper(papersize[i]);
+	}
+	for(i=0;sizes[i]!=NULL; i++){
+		if (strcmp( (const char*)papersize, sizes[i])==0){
+			*width=(float)widths[i];
+			*length=(float)lengths[i];
+			return(1);
+		}
+	}
+
+	return(0);
+}
+
+/*
+	This function allocates and initializes a T2P context struct pointer.
+*/
+
+T2P* t2p_init(){
+
+	T2P* t2p = (T2P*) _TIFFmalloc(sizeof(T2P));
+	if(t2p==NULL){
+		TIFFError(
+			TIFF2PDF_MODULE, 
+			"Can't allocate %u bytes of memory for t2p_init", 
+			sizeof(T2P));
+		return( (T2P*) NULL );
+	}
+	_TIFFmemset(t2p, 0x00, sizeof(T2P));
+	t2p->pdf_majorversion=1;
+	t2p->pdf_minorversion=1;
+	t2p->pdf_defaultxres=300.0;
+	t2p->pdf_defaultyres=300.0;
+	t2p->pdf_defaultpagewidth=612.0;
+	t2p->pdf_defaultpagelength=792.0;
+	t2p->pdf_xrefcount=3; /* Catalog, Info, Pages */
+	
+	return(t2p);
+}
+
+/*
+	This function frees a T2P context struct pointer and any allocated data fields of it.
+*/
+
+void t2p_free(T2P* t2p){
+
+	int i=0;
+
+	if(t2p != NULL){
+		if(t2p->pdf_xrefoffsets != NULL){
+			_TIFFfree( (tdata_t) t2p->pdf_xrefoffsets);
+		}
+		if(t2p->tiff_pages != NULL){
+			_TIFFfree( (tdata_t) t2p->tiff_pages);
+		}
+		for(i=0;i<t2p->tiff_pagecount;i++){
+			if(t2p->tiff_tiles[i].tiles_tiles != NULL){
+				_TIFFfree( (tdata_t) t2p->tiff_tiles[i].tiles_tiles);
+			}
+		}
+		if(t2p->tiff_tiles != NULL){
+			_TIFFfree( (tdata_t) t2p->tiff_tiles);
+		}
+		if(t2p->pdf_palette != NULL){
+			_TIFFfree( (tdata_t) t2p->pdf_palette);
+		}
+		if(t2p->pdf_fileid != NULL){
+			_TIFFfree( (tdata_t) t2p->pdf_fileid);
+		}
+		if(t2p->pdf_datetime != NULL){
+			_TIFFfree( (tdata_t) t2p->pdf_datetime);
+		}
+		if(t2p->pdf_creator != NULL){
+			_TIFFfree( (tdata_t) t2p->pdf_creator);
+		}
+		if(t2p->pdf_author != NULL){
+			_TIFFfree( (tdata_t) t2p->pdf_author);
+		}
+		if(t2p->pdf_title != NULL){
+			_TIFFfree( (tdata_t) t2p->pdf_title);
+		}
+		if(t2p->pdf_subject != NULL){
+			_TIFFfree( (tdata_t) t2p->pdf_subject);
+		}
+		if(t2p->pdf_keywords != NULL){
+			_TIFFfree( (tdata_t) t2p->pdf_keywords);
+		}
+#ifdef OJPEG_SUPPORT
+		if(t2p->pdf_ojpegdata != NULL){
+			_TIFFfree( (tdata_t) t2p->pdf_ojpegdata);
+		}
+#endif
+		_TIFFfree( (tdata_t) t2p );
+	}
+
+	return;
+}
+
+/*
+	This function validates the values of a T2P context struct pointer
+        before calling t2p_write_pdf with it.
+*/
+
+void t2p_validate(T2P* t2p){
+
+#ifdef JPEG_SUPPORT
+	if(t2p->pdf_defaultcompression==T2P_COMPRESS_JPEG){
+		if(t2p->pdf_defaultcompressionquality>100 ||
+			t2p->pdf_defaultcompressionquality<1){
+			t2p->pdf_defaultcompressionquality=0;
+		}
+	}
+#endif
+#ifdef ZIP_SUPPORT
+	if(t2p->pdf_defaultcompression==T2P_COMPRESS_ZIP){
+ 		uint16 m=t2p->pdf_defaultcompressionquality%100;
+ 		if(t2p->pdf_defaultcompressionquality/100 > 9 ||
+ 			(m>1 && m<10) || m>15){
+ 			t2p->pdf_defaultcompressionquality=0;
+		}
+		if(t2p->pdf_defaultcompressionquality%100 !=0){
+ 			t2p->pdf_defaultcompressionquality/=100;
+ 			t2p->pdf_defaultcompressionquality*=100;
+			TIFFError(
+				TIFF2PDF_MODULE, 
+				"PNG Group predictor differencing not implemented, assuming compression quality %u", 
+				t2p->pdf_defaultcompressionquality);
+		}
+		t2p->pdf_defaultcompressionquality%=100;
+		if(t2p->pdf_minorversion<2){t2p->pdf_minorversion=2;}
+	}
+#endif
+	(void)0;
+
+	return;
+}
+
+
+/*
+	This function scans the input TIFF file for pages.  It attempts
+        to determine which IFD's of the TIFF file contain image document
+        pages.  For each, it gathers some information that has to do
+        with the output of the PDF document as a whole.  
+*/
+
+void t2p_read_tiff_init(T2P* t2p, TIFF* input){
+
+	tdir_t directorycount=0;
+	tdir_t i=0;
+	uint16 pagen=0;
+	uint16 paged=0;
+	uint16 xuint16=0;
+
+	directorycount=TIFFNumberOfDirectories(input);
+	t2p->tiff_pages = (T2P_PAGE*) _TIFFmalloc(directorycount * sizeof(T2P_PAGE));
+	if(t2p->tiff_pages==NULL){
+		TIFFError(
+			TIFF2PDF_MODULE, 
+			"Can't allocate %u bytes of memory for tiff_pages array, %s", 
+			directorycount * sizeof(T2P_PAGE), 
+			TIFFFileName(input));
+		t2p->t2p_error = T2P_ERR_ERROR;
+		return;
+	}
+	_TIFFmemset( t2p->tiff_pages, 0x00, directorycount * sizeof(T2P_PAGE));
+	t2p->tiff_tiles = (T2P_TILES*) _TIFFmalloc(directorycount * sizeof(T2P_TILES));
+	if(t2p->tiff_tiles==NULL){
+		TIFFError(
+			TIFF2PDF_MODULE, 
+			"Can't allocate %u bytes of memory for tiff_tiles array, %s", 
+			directorycount * sizeof(T2P_TILES), 
+			TIFFFileName(input));
+		t2p->t2p_error = T2P_ERR_ERROR;
+		return;
+	}
+	_TIFFmemset( t2p->tiff_tiles, 0x00, directorycount * sizeof(T2P_TILES));
+	for(i=0;i<directorycount;i++){
+		uint32 subfiletype = 0;
+		
+		if(!TIFFSetDirectory(input, i)){
+			TIFFError(
+				TIFF2PDF_MODULE, 
+				"Can't set directory %u of input file %s", 
+				i,
+				TIFFFileName(input));
+			t2p->t2p_error = T2P_ERR_ERROR;
+			return;
+		}
+		if(TIFFGetField(input, TIFFTAG_PAGENUMBER, &pagen, &paged)){
+			if((pagen>paged) && (paged != 0)){
+				t2p->tiff_pages[t2p->tiff_pagecount].page_number = 
+					paged;
+			} else {
+				t2p->tiff_pages[t2p->tiff_pagecount].page_number = 
+					pagen;
+			}
+			goto ispage2;
+		}
+		if(TIFFGetField(input, TIFFTAG_SUBFILETYPE, &subfiletype)){
+			if ( ((subfiletype & FILETYPE_PAGE) != 0)
+                             || (subfiletype == 0)){
+				goto ispage;
+			} else {
+				goto isnotpage;
+			}
+		}
+		if(TIFFGetField(input, TIFFTAG_OSUBFILETYPE, &subfiletype)){
+			if ((subfiletype == OFILETYPE_IMAGE) 
+				|| (subfiletype == OFILETYPE_PAGE)
+				|| (subfiletype == 0) ){
+				goto ispage;
+			} else {
+				goto isnotpage;
+			}
+		}
+		ispage:
+		t2p->tiff_pages[t2p->tiff_pagecount].page_number=t2p->tiff_pagecount;
+		ispage2:
+		t2p->tiff_pages[t2p->tiff_pagecount].page_directory=i;
+		if(TIFFIsTiled(input)){
+			t2p->tiff_pages[t2p->tiff_pagecount].page_tilecount = 
+				TIFFNumberOfTiles(input);
+		}
+		t2p->tiff_pagecount++;
+		isnotpage:
+		(void)0;
+	}
+	
+	qsort((void*) t2p->tiff_pages, t2p->tiff_pagecount,
+              sizeof(T2P_PAGE), t2p_cmp_t2p_page);
+
+	for(i=0;i<t2p->tiff_pagecount;i++){
+		t2p->pdf_xrefcount += 5;
+		TIFFSetDirectory(input, t2p->tiff_pages[i].page_directory );
+		if((TIFFGetField(input, TIFFTAG_PHOTOMETRIC, &xuint16)
+                    && (xuint16==PHOTOMETRIC_PALETTE))
+		   || TIFFGetField(input, TIFFTAG_INDEXED, &xuint16)) {
+			t2p->tiff_pages[i].page_extra++;
+			t2p->pdf_xrefcount++;
+		}
+#ifdef ZIP_SUPPORT
+		if (TIFFGetField(input, TIFFTAG_COMPRESSION, &xuint16)) {
+                        if( (xuint16== COMPRESSION_DEFLATE ||
+                             xuint16== COMPRESSION_ADOBE_DEFLATE) && 
+                            ((t2p->tiff_pages[i].page_tilecount != 0) 
+                             || TIFFNumberOfStrips(input)==1) &&
+                            (t2p->pdf_nopassthrough==0)	){
+                                if(t2p->pdf_minorversion<2){t2p->pdf_minorversion=2;}
+                        }
+                }
+#endif
+		if (TIFFGetField(input, TIFFTAG_TRANSFERFUNCTION,
+                                 &(t2p->tiff_transferfunction[0]),
+                                 &(t2p->tiff_transferfunction[1]),
+                                 &(t2p->tiff_transferfunction[2]))) {
+			if(t2p->tiff_transferfunction[1] !=
+			   t2p->tiff_transferfunction[0]) {
+				t2p->tiff_transferfunctioncount = 3;
+				t2p->tiff_pages[i].page_extra += 4;
+				t2p->pdf_xrefcount += 4;
+			} else {
+				t2p->tiff_transferfunctioncount = 1;
+				t2p->tiff_pages[i].page_extra += 2;
+				t2p->pdf_xrefcount += 2;
+			}
+			if(t2p->pdf_minorversion < 2)
+				t2p->pdf_minorversion = 2;
+                } else {
+			t2p->tiff_transferfunctioncount=0;
+		}
+		if( TIFFGetField(
+			input, 
+			TIFFTAG_ICCPROFILE, 
+			&(t2p->tiff_iccprofilelength), 
+			&(t2p->tiff_iccprofile)) != 0){
+			t2p->tiff_pages[i].page_extra++;
+			t2p->pdf_xrefcount++;
+			if(t2p->pdf_minorversion<3){t2p->pdf_minorversion=3;}
+		}
+		t2p->tiff_tiles[i].tiles_tilecount=
+			t2p->tiff_pages[i].page_tilecount;
+		if( (TIFFGetField(input, TIFFTAG_PLANARCONFIG, &xuint16) != 0)
+			&& (xuint16 == PLANARCONFIG_SEPARATE ) ){
+				TIFFGetField(input, TIFFTAG_SAMPLESPERPIXEL, &xuint16);
+				t2p->tiff_tiles[i].tiles_tilecount/= xuint16;
+		}
+		if( t2p->tiff_tiles[i].tiles_tilecount > 0){
+			t2p->pdf_xrefcount += 
+				(t2p->tiff_tiles[i].tiles_tilecount -1)*2;
+			TIFFGetField(input, 
+				TIFFTAG_TILEWIDTH, 
+				&( t2p->tiff_tiles[i].tiles_tilewidth) );
+			TIFFGetField(input, 
+				TIFFTAG_TILELENGTH, 
+				&( t2p->tiff_tiles[i].tiles_tilelength) );
+			t2p->tiff_tiles[i].tiles_tiles = 
+			(T2P_TILE*) _TIFFmalloc(
+				t2p->tiff_tiles[i].tiles_tilecount 
+				* sizeof(T2P_TILE) );
+			if( t2p->tiff_tiles[i].tiles_tiles == NULL){
+				TIFFError(
+					TIFF2PDF_MODULE, 
+					"Can't allocate %u bytes of memory for t2p_read_tiff_init, %s", 
+					t2p->tiff_tiles[i].tiles_tilecount * sizeof(T2P_TILE), 
+					TIFFFileName(input));
+				t2p->t2p_error = T2P_ERR_ERROR;
+				return;
+			}
+		}
+	}
+
+	return;
+}
+
+/*
+ * This function is used by qsort to sort a T2P_PAGE* array of page structures
+ * by page number.
+ */
+
+int t2p_cmp_t2p_page(const void* e1, const void* e2){
+
+	return( ((T2P_PAGE*)e1)->page_number - ((T2P_PAGE*)e2)->page_number );
+}
+
+/*
+	This function sets the input directory to the directory of a given
+	page and determines information about the image.  It checks
+	the image characteristics to determine if it is possible to convert
+	the image data into a page of PDF output, setting values of the T2P
+	struct for this page.  It determines what color space is used in
+	the output PDF to represent the image.
+	
+	It determines if the image can be converted as raw data without
+	requiring transcoding of the image data.
+*/
+
+void t2p_read_tiff_data(T2P* t2p, TIFF* input){
+
+	int i=0;
+	uint16* r;
+	uint16* g;
+	uint16* b;
+	uint16* a;
+	uint16 xuint16;
+	uint16* xuint16p;
+	float* xfloatp;
+
+	t2p->pdf_transcode = T2P_TRANSCODE_ENCODE;
+	t2p->pdf_sample = T2P_SAMPLE_NOTHING;
+        t2p->pdf_switchdecode = t2p->pdf_colorspace_invert;
+        
+	
+	TIFFSetDirectory(input, t2p->tiff_pages[t2p->pdf_page].page_directory);
+
+	TIFFGetField(input, TIFFTAG_IMAGEWIDTH, &(t2p->tiff_width));
+	if(t2p->tiff_width == 0){
+		TIFFError(
+			TIFF2PDF_MODULE, 
+			"No support for %s with zero width", 
+			TIFFFileName(input)	);
+		t2p->t2p_error = T2P_ERR_ERROR;
+		return;
+	}
+
+	TIFFGetField(input, TIFFTAG_IMAGELENGTH, &(t2p->tiff_length));
+	if(t2p->tiff_length == 0){
+		TIFFError(
+			TIFF2PDF_MODULE, 
+			"No support for %s with zero length", 
+			TIFFFileName(input)	);
+		t2p->t2p_error = T2P_ERR_ERROR;
+		return;
+	}
+
+        if(TIFFGetField(input, TIFFTAG_COMPRESSION, &(t2p->tiff_compression)) == 0){
+                TIFFError(
+                        TIFF2PDF_MODULE, 
+                        "No support for %s with no compression tag", 
+                        TIFFFileName(input)     );
+                t2p->t2p_error = T2P_ERR_ERROR;
+                return;
+
+        }
+        if( TIFFIsCODECConfigured(t2p->tiff_compression) == 0){
+		TIFFError(
+			TIFF2PDF_MODULE, 
+			"No support for %s with compression type %u:  not configured", 
+			TIFFFileName(input), 
+			t2p->tiff_compression	
+			);
+		t2p->t2p_error = T2P_ERR_ERROR;
+		return;
+	
+	}
+
+	TIFFGetFieldDefaulted(input, TIFFTAG_BITSPERSAMPLE, &(t2p->tiff_bitspersample));
+	switch(t2p->tiff_bitspersample){
+		case 1:
+		case 2:
+		case 4:
+		case 8:
+			break;
+		case 0:
+			TIFFWarning(
+				TIFF2PDF_MODULE, 
+				"Image %s has 0 bits per sample, assuming 1",
+				TIFFFileName(input));
+			t2p->tiff_bitspersample=1;
+			break;
+		default:
+			TIFFError(
+				TIFF2PDF_MODULE, 
+				"No support for %s with %u bits per sample",
+				TIFFFileName(input),
+				t2p->tiff_bitspersample);
+			t2p->t2p_error = T2P_ERR_ERROR;
+			return;
+	}
+
+	TIFFGetFieldDefaulted(input, TIFFTAG_SAMPLESPERPIXEL, &(t2p->tiff_samplesperpixel));
+	if(t2p->tiff_samplesperpixel>4){
+		TIFFError(
+			TIFF2PDF_MODULE, 
+			"No support for %s with %u samples per pixel",
+			TIFFFileName(input),
+			t2p->tiff_samplesperpixel);
+		t2p->t2p_error = T2P_ERR_ERROR;
+		return;
+	}
+	if(t2p->tiff_samplesperpixel==0){
+		TIFFWarning(
+			TIFF2PDF_MODULE, 
+			"Image %s has 0 samples per pixel, assuming 1",
+			TIFFFileName(input));
+		t2p->tiff_samplesperpixel=1;
+	}
+	
+	if(TIFFGetField(input, TIFFTAG_SAMPLEFORMAT, &xuint16) != 0 ){
+		switch(xuint16){
+			case 0:
+			case 1:
+			case 4:
+				break;
+			default:
+				TIFFError(
+					TIFF2PDF_MODULE, 
+					"No support for %s with sample format %u",
+					TIFFFileName(input),
+					xuint16);
+				t2p->t2p_error = T2P_ERR_ERROR;
+				return;
+				break;
+		}
+	}
+	
+	TIFFGetFieldDefaulted(input, TIFFTAG_FILLORDER, &(t2p->tiff_fillorder));
+	
+        if(TIFFGetField(input, TIFFTAG_PHOTOMETRIC, &(t2p->tiff_photometric)) == 0){
+                TIFFError(
+                        TIFF2PDF_MODULE, 
+                        "No support for %s with no photometric interpretation tag", 
+                        TIFFFileName(input)     );
+                t2p->t2p_error = T2P_ERR_ERROR;
+                return;
+
+        }
+        
+	switch(t2p->tiff_photometric){
+		case PHOTOMETRIC_MINISWHITE:
+		case PHOTOMETRIC_MINISBLACK: 
+			if (t2p->tiff_bitspersample==1){
+				t2p->pdf_colorspace=T2P_CS_BILEVEL;
+				if(t2p->tiff_photometric==PHOTOMETRIC_MINISWHITE){
+					t2p->pdf_switchdecode ^= 1;
+				}
+			} else {
+				t2p->pdf_colorspace=T2P_CS_GRAY;
+				if(t2p->tiff_photometric==PHOTOMETRIC_MINISWHITE){
+					t2p->pdf_switchdecode ^= 1;
+				} 
+			}
+			break;
+		case PHOTOMETRIC_RGB: 
+			t2p->pdf_colorspace=T2P_CS_RGB;
+			if(t2p->tiff_samplesperpixel == 3){
+				break;
+			}
+			if(TIFFGetField(input, TIFFTAG_INDEXED, &xuint16)){
+				if(xuint16==1)
+					goto photometric_palette;
+			}
+			if(t2p->tiff_samplesperpixel > 3) {
+				if(t2p->tiff_samplesperpixel == 4) {
+					t2p->pdf_colorspace = T2P_CS_RGB;
+					if(TIFFGetField(input,
+							TIFFTAG_EXTRASAMPLES,
+							&xuint16, &xuint16p)
+					   && xuint16 == 1) {
+						if(xuint16p[0] == EXTRASAMPLE_ASSOCALPHA){
+							t2p->pdf_sample=T2P_SAMPLE_RGBAA_TO_RGB;
+							break;
+						}
+						if(xuint16p[0] == EXTRASAMPLE_UNASSALPHA){
+							t2p->pdf_sample=T2P_SAMPLE_RGBA_TO_RGB;
+							break;
+						}
+						TIFFWarning(
+							TIFF2PDF_MODULE, 
+							"RGB image %s has 4 samples per pixel, assuming RGBA",
+							TIFFFileName(input));
+							break;
+					}
+					t2p->pdf_colorspace=T2P_CS_CMYK;
+					t2p->pdf_switchdecode ^= 1;
+					TIFFWarning(
+						TIFF2PDF_MODULE, 
+						"RGB image %s has 4 samples per pixel, assuming inverse CMYK",
+					TIFFFileName(input));
+					break;
+				} else {
+					TIFFError(
+						TIFF2PDF_MODULE, 
+						"No support for RGB image %s with %u samples per pixel", 
+						TIFFFileName(input), 
+						t2p->tiff_samplesperpixel);
+					t2p->t2p_error = T2P_ERR_ERROR;
+					break;
+				}
+			} else {
+				TIFFError(
+					TIFF2PDF_MODULE, 
+					"No support for RGB image %s with %u samples per pixel", 
+					TIFFFileName(input), 
+					t2p->tiff_samplesperpixel);
+				t2p->t2p_error = T2P_ERR_ERROR;
+				break;
+			}
+		case PHOTOMETRIC_PALETTE: 
+			photometric_palette:
+			if(t2p->tiff_samplesperpixel!=1){
+				TIFFError(
+					TIFF2PDF_MODULE, 
+					"No support for palettized image %s with not one sample per pixel", 
+					TIFFFileName(input));
+				t2p->t2p_error = T2P_ERR_ERROR;
+				return;
+			}
+			t2p->pdf_colorspace=T2P_CS_RGB | T2P_CS_PALETTE;
+			t2p->pdf_palettesize=0x0001<<t2p->tiff_bitspersample;
+			if(!TIFFGetField(input, TIFFTAG_COLORMAP, &r, &g, &b)){
+				TIFFError(
+					TIFF2PDF_MODULE, 
+					"Palettized image %s has no color map", 
+					TIFFFileName(input));
+				t2p->t2p_error = T2P_ERR_ERROR;
+				return;
+			} 
+			if(t2p->pdf_palette != NULL){
+				_TIFFfree(t2p->pdf_palette);
+				t2p->pdf_palette=NULL;
+			}
+			t2p->pdf_palette = (unsigned char*)
+				_TIFFmalloc(t2p->pdf_palettesize*3);
+			if(t2p->pdf_palette==NULL){
+				TIFFError(
+					TIFF2PDF_MODULE, 
+					"Can't allocate %u bytes of memory for t2p_read_tiff_image, %s", 
+					t2p->pdf_palettesize, 
+					TIFFFileName(input));
+				t2p->t2p_error = T2P_ERR_ERROR;
+				return;
+			}
+			for(i=0;i<t2p->pdf_palettesize;i++){
+				t2p->pdf_palette[(i*3)]  = (unsigned char) (r[i]>>8);
+				t2p->pdf_palette[(i*3)+1]= (unsigned char) (g[i]>>8);
+				t2p->pdf_palette[(i*3)+2]= (unsigned char) (b[i]>>8);
+			}
+			t2p->pdf_palettesize *= 3;
+			break;
+		case PHOTOMETRIC_SEPARATED:
+			if(TIFFGetField(input, TIFFTAG_INDEXED, &xuint16)){
+				if(xuint16==1){
+						goto photometric_palette_cmyk;
+				}
+			}
+			if( TIFFGetField(input, TIFFTAG_INKSET, &xuint16) ){
+				if(xuint16 != INKSET_CMYK){
+					TIFFError(
+						TIFF2PDF_MODULE, 
+						"No support for %s because its inkset is not CMYK",
+						TIFFFileName(input) );
+					t2p->t2p_error = T2P_ERR_ERROR;
+					return;
+				}
+			}
+			if(t2p->tiff_samplesperpixel==4){
+				t2p->pdf_colorspace=T2P_CS_CMYK;
+			} else {
+				TIFFError(
+					TIFF2PDF_MODULE, 
+					"No support for %s because it has %u samples per pixel",
+					TIFFFileName(input), 
+					t2p->tiff_samplesperpixel);
+				t2p->t2p_error = T2P_ERR_ERROR;
+				return;
+			}
+			break;
+			photometric_palette_cmyk:
+			if(t2p->tiff_samplesperpixel!=1){
+				TIFFError(
+					TIFF2PDF_MODULE, 
+					"No support for palettized CMYK image %s with not one sample per pixel", 
+					TIFFFileName(input));
+				t2p->t2p_error = T2P_ERR_ERROR;
+				return;
+			}
+			t2p->pdf_colorspace=T2P_CS_CMYK | T2P_CS_PALETTE;
+			t2p->pdf_palettesize=0x0001<<t2p->tiff_bitspersample;
+			if(!TIFFGetField(input, TIFFTAG_COLORMAP, &r, &g, &b, &a)){
+				TIFFError(
+					TIFF2PDF_MODULE, 
+					"Palettized image %s has no color map", 
+					TIFFFileName(input));
+				t2p->t2p_error = T2P_ERR_ERROR;
+				return;
+			} 
+			if(t2p->pdf_palette != NULL){
+				_TIFFfree(t2p->pdf_palette);
+				t2p->pdf_palette=NULL;
+			}
+			t2p->pdf_palette = (unsigned char*) 
+				_TIFFmalloc(t2p->pdf_palettesize*4);
+			if(t2p->pdf_palette==NULL){
+				TIFFError(
+					TIFF2PDF_MODULE, 
+					"Can't allocate %u bytes of memory for t2p_read_tiff_image, %s", 
+					t2p->pdf_palettesize, 
+					TIFFFileName(input));
+				t2p->t2p_error = T2P_ERR_ERROR;
+				return;
+			}
+			for(i=0;i<t2p->pdf_palettesize;i++){
+				t2p->pdf_palette[(i*4)]  = (unsigned char) (r[i]>>8);
+				t2p->pdf_palette[(i*4)+1]= (unsigned char) (g[i]>>8);
+				t2p->pdf_palette[(i*4)+2]= (unsigned char) (b[i]>>8);
+				t2p->pdf_palette[(i*4)+3]= (unsigned char) (a[i]>>8);
+			}
+			t2p->pdf_palettesize *= 4;
+			break;
+		case PHOTOMETRIC_YCBCR:
+			t2p->pdf_colorspace=T2P_CS_RGB;
+			if(t2p->tiff_samplesperpixel==1){
+				t2p->pdf_colorspace=T2P_CS_GRAY;
+				t2p->tiff_photometric=PHOTOMETRIC_MINISBLACK;
+				break;
+			}
+			t2p->pdf_sample=T2P_SAMPLE_YCBCR_TO_RGB;
+#ifdef JPEG_SUPPORT
+			if(t2p->pdf_defaultcompression==T2P_COMPRESS_JPEG){
+				t2p->pdf_sample=T2P_SAMPLE_NOTHING;
+			}
+#endif
+			break;
+		case PHOTOMETRIC_CIELAB:
+			t2p->pdf_labrange[0]= -127;
+			t2p->pdf_labrange[1]= 127;
+			t2p->pdf_labrange[2]= -127;
+			t2p->pdf_labrange[3]= 127;
+			t2p->pdf_sample=T2P_SAMPLE_LAB_SIGNED_TO_UNSIGNED;
+			t2p->pdf_colorspace=T2P_CS_LAB;
+			break;
+		case PHOTOMETRIC_ICCLAB:
+			t2p->pdf_labrange[0]= 0;
+			t2p->pdf_labrange[1]= 255;
+			t2p->pdf_labrange[2]= 0;
+			t2p->pdf_labrange[3]= 255;
+			t2p->pdf_colorspace=T2P_CS_LAB;
+			break;
+		case PHOTOMETRIC_ITULAB:
+			t2p->pdf_labrange[0]=-85;
+			t2p->pdf_labrange[1]=85;
+			t2p->pdf_labrange[2]=-75;
+			t2p->pdf_labrange[3]=124;
+			t2p->pdf_sample=T2P_SAMPLE_LAB_SIGNED_TO_UNSIGNED;
+			t2p->pdf_colorspace=T2P_CS_LAB;
+			break;
+		case PHOTOMETRIC_LOGL:
+		case PHOTOMETRIC_LOGLUV:
+			TIFFError(
+				TIFF2PDF_MODULE, 
+				"No support for %s with photometric interpretation LogL/LogLuv", 
+				TIFFFileName(input));
+			t2p->t2p_error = T2P_ERR_ERROR;
+			return;
+		default:
+			TIFFError(
+				TIFF2PDF_MODULE, 
+				"No support for %s with photometric interpretation %u", 
+				TIFFFileName(input),
+				t2p->tiff_photometric);
+			t2p->t2p_error = T2P_ERR_ERROR;
+			return;
+	}
+
+	if(TIFFGetField(input, TIFFTAG_PLANARCONFIG, &(t2p->tiff_planar))){
+		switch(t2p->tiff_planar){
+			case 0:
+				TIFFWarning(
+					TIFF2PDF_MODULE, 
+					"Image %s has planar configuration 0, assuming 1", 
+					TIFFFileName(input));
+				t2p->tiff_planar=PLANARCONFIG_CONTIG;
+			case PLANARCONFIG_CONTIG:
+				break;
+			case PLANARCONFIG_SEPARATE:
+				t2p->pdf_sample=T2P_SAMPLE_PLANAR_SEPARATE_TO_CONTIG;
+				if(t2p->tiff_bitspersample!=8){
+					TIFFError(
+						TIFF2PDF_MODULE, 
+						"No support for %s with separated planar configuration and %u bits per sample", 
+						TIFFFileName(input),
+						t2p->tiff_bitspersample);
+					t2p->t2p_error = T2P_ERR_ERROR;
+					return;
+				}
+				break;
+			default:
+				TIFFError(
+					TIFF2PDF_MODULE, 
+					"No support for %s with planar configuration %u", 
+					TIFFFileName(input),
+					t2p->tiff_planar);
+				t2p->t2p_error = T2P_ERR_ERROR;
+				return;
+		}
+	}
+
+        TIFFGetFieldDefaulted(input, TIFFTAG_ORIENTATION,
+                              &(t2p->tiff_orientation));
+        if(t2p->tiff_orientation>8){
+                TIFFWarning(TIFF2PDF_MODULE,
+                            "Image %s has orientation %u, assuming 0",
+                            TIFFFileName(input), t2p->tiff_orientation);
+                t2p->tiff_orientation=0;
+        }
+
+        if(TIFFGetField(input, TIFFTAG_XRESOLUTION, &(t2p->tiff_xres) ) == 0){
+                t2p->tiff_xres=0.0;
+        }
+        if(TIFFGetField(input, TIFFTAG_YRESOLUTION, &(t2p->tiff_yres) ) == 0){
+                t2p->tiff_yres=0.0;
+        }
+	TIFFGetFieldDefaulted(input, TIFFTAG_RESOLUTIONUNIT,
+			      &(t2p->tiff_resunit));
+	if(t2p->tiff_resunit == RESUNIT_CENTIMETER) {
+		t2p->tiff_xres *= 2.54F;
+		t2p->tiff_yres *= 2.54F;
+	} else if (t2p->tiff_resunit != RESUNIT_INCH
+		   && t2p->pdf_centimeters != 0) {
+		t2p->tiff_xres *= 2.54F;
+		t2p->tiff_yres *= 2.54F;
+	}
+
+	t2p_compose_pdf_page(t2p);
+
+	t2p->pdf_transcode = T2P_TRANSCODE_ENCODE;
+	if(t2p->pdf_nopassthrough==0){
+#ifdef CCITT_SUPPORT
+		if(t2p->tiff_compression==COMPRESSION_CCITTFAX4  
+			){
+			if(TIFFIsTiled(input) || (TIFFNumberOfStrips(input)==1) ){
+				t2p->pdf_transcode = T2P_TRANSCODE_RAW;
+				t2p->pdf_compression=T2P_COMPRESS_G4;
+			}
+		}
+#endif
+#ifdef ZIP_SUPPORT
+		if(t2p->tiff_compression== COMPRESSION_ADOBE_DEFLATE 
+			|| t2p->tiff_compression==COMPRESSION_DEFLATE){
+			if(TIFFIsTiled(input) || (TIFFNumberOfStrips(input)==1) ){
+				t2p->pdf_transcode = T2P_TRANSCODE_RAW;
+				t2p->pdf_compression=T2P_COMPRESS_ZIP;
+			}
+		}
+#endif
+#ifdef OJPEG_SUPPORT
+		if(t2p->tiff_compression==COMPRESSION_OJPEG){
+			t2p->pdf_transcode = T2P_TRANSCODE_RAW;
+			t2p->pdf_compression=T2P_COMPRESS_JPEG;
+			t2p_process_ojpeg_tables(t2p, input);
+		}
+#endif
+#ifdef JPEG_SUPPORT
+		if(t2p->tiff_compression==COMPRESSION_JPEG){
+			t2p->pdf_transcode = T2P_TRANSCODE_RAW;
+			t2p->pdf_compression=T2P_COMPRESS_JPEG;
+		}
+#endif
+		(void)0;
+	}
+
+	if(t2p->pdf_transcode!=T2P_TRANSCODE_RAW){
+		t2p->pdf_compression = t2p->pdf_defaultcompression;
+	}
+
+#ifdef JPEG_SUPPORT
+	if(t2p->pdf_defaultcompression==T2P_COMPRESS_JPEG){
+		if(t2p->pdf_colorspace & T2P_CS_PALETTE){
+			t2p->pdf_sample|=T2P_SAMPLE_REALIZE_PALETTE;
+			t2p->pdf_colorspace ^= T2P_CS_PALETTE;
+			t2p->tiff_pages[t2p->pdf_page].page_extra--;
+		}
+	}
+	if(t2p->tiff_compression==COMPRESSION_JPEG){
+		if(t2p->tiff_planar==PLANARCONFIG_SEPARATE){
+			TIFFError(
+				TIFF2PDF_MODULE, 
+				"No support for %s with JPEG compression and separated planar configuration", 
+				TIFFFileName(input));
+				t2p->t2p_error=T2P_ERR_ERROR;
+			return;
+		}
+	}
+#endif
+#ifdef OJPEG_SUPPORT
+	if(t2p->tiff_compression==COMPRESSION_OJPEG){
+		if(t2p->tiff_planar==PLANARCONFIG_SEPARATE){
+			TIFFError(
+				TIFF2PDF_MODULE, 
+				"No support for %s with OJPEG compression and separated planar configuration", 
+				TIFFFileName(input));
+				t2p->t2p_error=T2P_ERR_ERROR;
+			return;
+		}
+	}
+#endif
+
+	if(t2p->pdf_sample & T2P_SAMPLE_REALIZE_PALETTE){
+		if(t2p->pdf_colorspace & T2P_CS_CMYK){
+			t2p->tiff_samplesperpixel=4;
+			t2p->tiff_photometric=PHOTOMETRIC_SEPARATED;
+		} else {
+			t2p->tiff_samplesperpixel=3;
+			t2p->tiff_photometric=PHOTOMETRIC_RGB;
+		}
+	}
+
+	if (TIFFGetField(input, TIFFTAG_TRANSFERFUNCTION,
+			 &(t2p->tiff_transferfunction[0]),
+			 &(t2p->tiff_transferfunction[1]),
+			 &(t2p->tiff_transferfunction[2]))) {
+		if(t2p->tiff_transferfunction[1] !=
+		   t2p->tiff_transferfunction[0]) {
+			t2p->tiff_transferfunctioncount=3;
+		} else {
+			t2p->tiff_transferfunctioncount=1;
+		}
+	} else {
+		t2p->tiff_transferfunctioncount=0;
+	}
+	if(TIFFGetField(input, TIFFTAG_WHITEPOINT, &xfloatp)!=0){
+		t2p->tiff_whitechromaticities[0]=xfloatp[0];
+		t2p->tiff_whitechromaticities[1]=xfloatp[1];
+		if(t2p->pdf_colorspace & T2P_CS_GRAY){
+			t2p->pdf_colorspace |= T2P_CS_CALGRAY;
+		}
+		if(t2p->pdf_colorspace & T2P_CS_RGB){
+			t2p->pdf_colorspace |= T2P_CS_CALRGB;
+		}
+	}
+	if(TIFFGetField(input, TIFFTAG_PRIMARYCHROMATICITIES, &xfloatp)!=0){
+		t2p->tiff_primarychromaticities[0]=xfloatp[0];
+		t2p->tiff_primarychromaticities[1]=xfloatp[1];
+		t2p->tiff_primarychromaticities[2]=xfloatp[2];
+		t2p->tiff_primarychromaticities[3]=xfloatp[3];
+		t2p->tiff_primarychromaticities[4]=xfloatp[4];
+		t2p->tiff_primarychromaticities[5]=xfloatp[5];
+		if(t2p->pdf_colorspace & T2P_CS_RGB){
+			t2p->pdf_colorspace |= T2P_CS_CALRGB;
+		}
+	}
+	if(t2p->pdf_colorspace & T2P_CS_LAB){
+		if(TIFFGetField(input, TIFFTAG_WHITEPOINT, &xfloatp) != 0){
+			t2p->tiff_whitechromaticities[0]=xfloatp[0];
+			t2p->tiff_whitechromaticities[1]=xfloatp[1];
+		} else {
+			t2p->tiff_whitechromaticities[0]=0.3457F; /* 0.3127F; */
+			t2p->tiff_whitechromaticities[1]=0.3585F; /* 0.3290F; */
+		}
+	}
+	if(TIFFGetField(input, 
+		TIFFTAG_ICCPROFILE, 
+		&(t2p->tiff_iccprofilelength), 
+		&(t2p->tiff_iccprofile))!=0){
+		t2p->pdf_colorspace |= T2P_CS_ICCBASED;
+	} else {
+		t2p->tiff_iccprofilelength=0;
+		t2p->tiff_iccprofile=NULL;
+	}
+	
+#ifdef CCITT_SUPPORT
+	if( t2p->tiff_bitspersample==1 &&
+		t2p->tiff_samplesperpixel==1){
+		t2p->pdf_compression = T2P_COMPRESS_G4;
+	}
+#endif
+
+
+	return;
+}
+
+/*
+	This function returns the necessary size of a data buffer to contain the raw or 
+	uncompressed image data from the input TIFF for a page.
+*/
+
+void t2p_read_tiff_size(T2P* t2p, TIFF* input){
+
+	uint32* sbc=NULL;
+#if defined(JPEG_SUPPORT) || defined (OJPEG_SUPPORT)
+	unsigned char* jpt=NULL;
+	tstrip_t i=0;
+	tstrip_t stripcount=0;
+#endif
+        uint64 k = 0;
+
+	if(t2p->pdf_transcode == T2P_TRANSCODE_RAW){
+#ifdef CCITT_SUPPORT
+		if(t2p->pdf_compression == T2P_COMPRESS_G4 ){
+			TIFFGetField(input, TIFFTAG_STRIPBYTECOUNTS, &sbc);
+			t2p->tiff_datasize=sbc[0];
+			return;
+		}
+#endif
+#ifdef ZIP_SUPPORT
+		if(t2p->pdf_compression == T2P_COMPRESS_ZIP){
+			TIFFGetField(input, TIFFTAG_STRIPBYTECOUNTS, &sbc);
+			t2p->tiff_datasize=sbc[0];
+			return;
+		}
+#endif
+#ifdef OJPEG_SUPPORT
+		if(t2p->tiff_compression == COMPRESSION_OJPEG){
+			if(!TIFFGetField(input, TIFFTAG_STRIPBYTECOUNTS, &sbc)){
+				TIFFError(TIFF2PDF_MODULE, 
+					"Input file %s missing field: TIFFTAG_STRIPBYTECOUNTS",
+					TIFFFileName(input));
+				t2p->t2p_error = T2P_ERR_ERROR;
+				return;
+			}
+			stripcount=TIFFNumberOfStrips(input);
+			for(i=0;i<stripcount;i++){
+				k = checkAdd64(k, sbc[i], t2p);
+			}
+			if(TIFFGetField(input, TIFFTAG_JPEGIFOFFSET, &(t2p->tiff_dataoffset))){
+				if(t2p->tiff_dataoffset != 0){
+					if(TIFFGetField(input, TIFFTAG_JPEGIFBYTECOUNT, &(t2p->tiff_datasize))!=0){
+						if(t2p->tiff_datasize < k) {
+							TIFFWarning(TIFF2PDF_MODULE, 
+								"Input file %s has short JPEG interchange file byte count", 
+								TIFFFileName(input));
+							t2p->pdf_ojpegiflength=t2p->tiff_datasize;
+							k = checkAdd64(k, t2p->tiff_datasize, t2p);
+							k = checkAdd64(k, 6, t2p);
+							k = checkAdd64(k, stripcount, t2p);
+							k = checkAdd64(k, stripcount, t2p);
+							t2p->tiff_datasize = (tsize_t) k;
+							if ((uint64) t2p->tiff_datasize != k) {
+								TIFFError(TIFF2PDF_MODULE, "Integer overflow");
+								t2p->t2p_error = T2P_ERR_ERROR;
+							}
+							return;
+						}
+						return;
+					}else {
+						TIFFError(TIFF2PDF_MODULE, 
+							"Input file %s missing field: TIFFTAG_JPEGIFBYTECOUNT",
+							TIFFFileName(input));
+							t2p->t2p_error = T2P_ERR_ERROR;
+							return;
+					}
+				}
+			}
+			k = checkAdd64(k, stripcount, t2p);
+			k = checkAdd64(k, stripcount, t2p);
+			k = checkAdd64(k, 2048, t2p);
+			t2p->tiff_datasize = (tsize_t) k;
+			if ((uint64) t2p->tiff_datasize != k) {
+				TIFFError(TIFF2PDF_MODULE, "Integer overflow");
+				t2p->t2p_error = T2P_ERR_ERROR;
+			}
+			return;
+		}
+#endif
+#ifdef JPEG_SUPPORT
+		if(t2p->tiff_compression == COMPRESSION_JPEG) {
+			uint32 count = 0;
+			if(TIFFGetField(input, TIFFTAG_JPEGTABLES, &count, &jpt) != 0 ){
+				if(count > 4){
+					k += count;
+					k -= 2; /* don't use EOI of header */
+				}
+			} else {
+				k = 2; /* SOI for first strip */
+			}
+			stripcount=TIFFNumberOfStrips(input);
+			if(!TIFFGetField(input, TIFFTAG_STRIPBYTECOUNTS, &sbc)){
+				TIFFError(TIFF2PDF_MODULE, 
+					"Input file %s missing field: TIFFTAG_STRIPBYTECOUNTS",
+					TIFFFileName(input));
+				t2p->t2p_error = T2P_ERR_ERROR;
+				return;
+			}
+			for(i=0;i<stripcount;i++){
+				k = checkAdd64(k, sbc[i], t2p);
+				k -=4; /* don't use SOI or EOI of strip */
+			}
+			k = checkAdd64(k, 2, t2p); /* use EOI of last strip */
+			t2p->tiff_datasize = (tsize_t) k;
+			if ((uint64) t2p->tiff_datasize != k) {
+				TIFFError(TIFF2PDF_MODULE, "Integer overflow");
+				t2p->t2p_error = T2P_ERR_ERROR;
+			}
+		}
+#endif
+		(void) 0;
+	}
+	k = checkMultiply64(TIFFScanlineSize(input), t2p->tiff_length, t2p);
+	if(t2p->tiff_planar==PLANARCONFIG_SEPARATE){
+		k = checkMultiply64(k, t2p->tiff_samplesperpixel, t2p);
+	}
+	if (k == 0) {
+		/* Assume we had overflow inside TIFFScanlineSize */
+		t2p->t2p_error = T2P_ERR_ERROR;
+	}
+
+	t2p->tiff_datasize = (tsize_t) k;
+	if ((uint64) t2p->tiff_datasize != k) {
+		TIFFError(TIFF2PDF_MODULE, "Integer overflow");
+		t2p->t2p_error = T2P_ERR_ERROR;
+	}
+
+	return;
+}
+
+/*
+	This function returns the necessary size of a data buffer to contain the raw or 
+	uncompressed image data from the input TIFF for a tile of a page.
+*/
+
+void t2p_read_tiff_size_tile(T2P* t2p, TIFF* input, ttile_t tile){
+
+	uint32* tbc = NULL;
+	uint16 edge=0;
+#ifdef JPEG_SUPPORT
+	unsigned char* jpt;
+#endif
+        uint64 k;
+
+	edge |= t2p_tile_is_right_edge(t2p->tiff_tiles[t2p->pdf_page], tile);
+	edge |= t2p_tile_is_bottom_edge(t2p->tiff_tiles[t2p->pdf_page], tile);
+	
+	if(t2p->pdf_transcode==T2P_TRANSCODE_RAW){
+		if(edge
+#if defined(JPEG_SUPPORT) || defined(OJPEG_SUPPORT)
+		&& !(t2p->pdf_compression==T2P_COMPRESS_JPEG)
+#endif
+		){
+			t2p->tiff_datasize=TIFFTileSize(input);
+			if (t2p->tiff_datasize == 0) {
+				/* Assume we had overflow inside TIFFTileSize */
+				t2p->t2p_error = T2P_ERR_ERROR;
+			}
+			return;
+		} else {
+			TIFFGetField(input, TIFFTAG_TILEBYTECOUNTS, &tbc);
+			k=tbc[tile];
+#ifdef OJPEG_SUPPORT
+			if(t2p->tiff_compression==COMPRESSION_OJPEG){
+			  	k = checkAdd64(k, 2048, t2p);
+			}
+#endif
+#ifdef JPEG_SUPPORT
+			if(t2p->tiff_compression==COMPRESSION_JPEG) {
+				uint32 count = 0;
+				if(TIFFGetField(input, TIFFTAG_JPEGTABLES, &count, &jpt)!=0){
+					if(count > 4){
+						k = checkAdd64(k, count, t2p);
+						k -= 4; /* don't use EOI of header or SOI of tile */
+
+
+					}
+				}
+			}
+#endif
+			t2p->tiff_datasize = (tsize_t) k;
+			if ((uint64) t2p->tiff_datasize != k) {
+				TIFFError(TIFF2PDF_MODULE, "Integer overflow");
+				t2p->t2p_error = T2P_ERR_ERROR;
+			}
+			return;
+		}
+	}
+	k = TIFFTileSize(input);
+	if(t2p->tiff_planar==PLANARCONFIG_SEPARATE){
+		k = checkMultiply64(k, t2p->tiff_samplesperpixel, t2p);
+	}
+	if (k == 0) {
+		/* Assume we had overflow inside TIFFTileSize */
+		t2p->t2p_error = T2P_ERR_ERROR;
+	}
+
+	t2p->tiff_datasize = (tsize_t) k;
+	if ((uint64) t2p->tiff_datasize != k) {
+		TIFFError(TIFF2PDF_MODULE, "Integer overflow");
+		t2p->t2p_error = T2P_ERR_ERROR;
+	}
+
+	return;
+}
+
+/*
+ * This functions returns a non-zero value when the tile is on the right edge
+ * and does not have full imaged tile width.
+ */
+
+int t2p_tile_is_right_edge(T2P_TILES tiles, ttile_t tile){
+
+	if( ((tile+1) % tiles.tiles_tilecountx == 0) 
+		&& (tiles.tiles_edgetilewidth != 0) ){
+		return(1);
+	} else {
+		return(0);
+	}
+}
+
+/*
+ * This functions returns a non-zero value when the tile is on the bottom edge
+ * and does not have full imaged tile length.
+ */
+
+int t2p_tile_is_bottom_edge(T2P_TILES tiles, ttile_t tile){
+
+	if( ((tile+1) > (tiles.tiles_tilecount-tiles.tiles_tilecountx) )
+		&& (tiles.tiles_edgetilelength != 0) ){
+		return(1);
+	} else {
+		return(0);
+	}
+}
+
+/*
+ * This function returns a non-zero value when the tile is a right edge tile
+ * or a bottom edge tile.
+ */
+
+int t2p_tile_is_edge(T2P_TILES tiles, ttile_t tile){
+
+	return(t2p_tile_is_right_edge(tiles, tile) | t2p_tile_is_bottom_edge(tiles, tile) );
+}
+
+/*
+	This function returns a non-zero value when the tile is a right edge tile and a bottom 
+	edge tile.
+*/
+
+int t2p_tile_is_corner_edge(T2P_TILES tiles, ttile_t tile){
+
+	return(t2p_tile_is_right_edge(tiles, tile) & t2p_tile_is_bottom_edge(tiles, tile) );
+}
+
+
+/*
+	This function reads the raster image data from the input TIFF for an image and writes 
+	the data to the output PDF XObject image dictionary stream.  It returns the amount written 
+	or zero on error.
+*/
+
+tsize_t t2p_readwrite_pdf_image(T2P* t2p, TIFF* input, TIFF* output){
+
+	tsize_t written=0;
+	unsigned char* buffer=NULL;
+	unsigned char* samplebuffer=NULL;
+	tsize_t bufferoffset=0;
+	tsize_t samplebufferoffset=0;
+	tsize_t read=0;
+	tstrip_t i=0;
+	tstrip_t j=0;
+	tstrip_t stripcount=0;
+	tsize_t stripsize=0;
+	tsize_t sepstripcount=0;
+	tsize_t sepstripsize=0;
+#ifdef OJPEG_SUPPORT
+	toff_t inputoffset=0;
+	uint16 h_samp=1;
+	uint16 v_samp=1;
+	uint16 ri=1;
+	uint32 rows=0;
+#endif
+#ifdef JPEG_SUPPORT
+	unsigned char* jpt;
+	float* xfloatp;
+	uint32* sbc;
+	unsigned char* stripbuffer;
+	tsize_t striplength=0;
+	uint32 max_striplength=0;
+#endif
+
+	/* Fail if prior error (in particular, can't trust tiff_datasize) */
+	if (t2p->t2p_error != T2P_ERR_OK)
+		return(0);
+
+	if(t2p->pdf_transcode == T2P_TRANSCODE_RAW){
+#ifdef CCITT_SUPPORT
+		if(t2p->pdf_compression == T2P_COMPRESS_G4){
+			buffer = (unsigned char*)
+				_TIFFmalloc(t2p->tiff_datasize);
+			if (buffer == NULL) {
+				TIFFError(TIFF2PDF_MODULE, 
+	"Can't allocate %u bytes of memory for t2p_readwrite_pdf_image, %s", 
+					t2p->tiff_datasize, 
+					TIFFFileName(input));
+				t2p->t2p_error = T2P_ERR_ERROR;
+				return(0);
+			}
+			TIFFReadRawStrip(input, 0, (tdata_t) buffer,
+					 t2p->tiff_datasize);
+			if (t2p->tiff_fillorder==FILLORDER_LSB2MSB){
+					/*
+					 * make sure is lsb-to-msb
+					 * bit-endianness fill order
+					 */
+					TIFFReverseBits(buffer,
+							t2p->tiff_datasize);
+			}
+			t2pWriteFile(output, (tdata_t) buffer,
+				      t2p->tiff_datasize);
+			_TIFFfree(buffer);
+			return(t2p->tiff_datasize);
+		}
+#endif
+#ifdef ZIP_SUPPORT
+		if (t2p->pdf_compression == T2P_COMPRESS_ZIP) {
+			buffer = (unsigned char*)
+				_TIFFmalloc(t2p->tiff_datasize);
+                        memset(buffer, 0, t2p->tiff_datasize);
+			if(buffer == NULL){
+				TIFFError(TIFF2PDF_MODULE, 
+	"Can't allocate %u bytes of memory for t2p_readwrite_pdf_image, %s", 
+					t2p->tiff_datasize, 
+					TIFFFileName(input));
+				t2p->t2p_error = T2P_ERR_ERROR;
+				return(0);
+			}
+			TIFFReadRawStrip(input, 0, (tdata_t) buffer,
+					 t2p->tiff_datasize);
+			if (t2p->tiff_fillorder==FILLORDER_LSB2MSB) {
+					TIFFReverseBits(buffer,
+							t2p->tiff_datasize);
+			}
+			t2pWriteFile(output, (tdata_t) buffer,
+				      t2p->tiff_datasize);
+			_TIFFfree(buffer);
+			return(t2p->tiff_datasize);
+		}
+#endif
+#ifdef OJPEG_SUPPORT
+		if(t2p->tiff_compression == COMPRESSION_OJPEG) {
+
+			if(t2p->tiff_dataoffset != 0) {
+				buffer = (unsigned char*)
+					_TIFFmalloc(t2p->tiff_datasize);
+                                memset(buffer, 0, t2p->tiff_datasize);
+				if(buffer == NULL) {
+					TIFFError(TIFF2PDF_MODULE, 
+	"Can't allocate %u bytes of memory for t2p_readwrite_pdf_image, %s", 
+						t2p->tiff_datasize, 
+						TIFFFileName(input));
+					t2p->t2p_error = T2P_ERR_ERROR;
+					return(0);
+				}
+				if(t2p->pdf_ojpegiflength==0){
+					inputoffset=t2pSeekFile(input, 0,
+								 SEEK_CUR);
+					t2pSeekFile(input,
+						     t2p->tiff_dataoffset,
+						     SEEK_SET);
+					t2pReadFile(input, (tdata_t) buffer,
+						     t2p->tiff_datasize);
+					t2pSeekFile(input, inputoffset,
+						     SEEK_SET);
+					t2pWriteFile(output, (tdata_t) buffer,
+						      t2p->tiff_datasize);
+					_TIFFfree(buffer);
+					return(t2p->tiff_datasize);
+				} else {
+					inputoffset=t2pSeekFile(input, 0,
+								 SEEK_CUR);
+					t2pSeekFile(input,
+						     t2p->tiff_dataoffset,
+						     SEEK_SET);
+					bufferoffset = t2pReadFile(input,
+						(tdata_t) buffer,
+						t2p->pdf_ojpegiflength);
+					t2p->pdf_ojpegiflength = 0;
+					t2pSeekFile(input, inputoffset,
+						     SEEK_SET);
+					TIFFGetField(input,
+						     TIFFTAG_YCBCRSUBSAMPLING,
+						     &h_samp, &v_samp);
+					buffer[bufferoffset++]= 0xff;
+					buffer[bufferoffset++]= 0xdd;
+					buffer[bufferoffset++]= 0x00;
+					buffer[bufferoffset++]= 0x04;
+					h_samp*=8;
+					v_samp*=8;
+					ri=(t2p->tiff_width+h_samp-1) / h_samp;
+					TIFFGetField(input,
+						     TIFFTAG_ROWSPERSTRIP,
+						     &rows);
+					ri*=(rows+v_samp-1)/v_samp;
+					buffer[bufferoffset++]= (ri>>8) & 0xff;
+					buffer[bufferoffset++]= ri & 0xff;
+					stripcount=TIFFNumberOfStrips(input);
+					for(i=0;i<stripcount;i++){
+						if(i != 0 ){ 
+							buffer[bufferoffset++]=0xff;
+							buffer[bufferoffset++]=(0xd0 | ((i-1)%8));
+						}
+						bufferoffset+=TIFFReadRawStrip(input, 
+							i, 
+							(tdata_t) &(((unsigned char*)buffer)[bufferoffset]), 
+							-1);
+					}
+					t2pWriteFile(output, (tdata_t) buffer, bufferoffset);
+					_TIFFfree(buffer);
+					return(bufferoffset);
+				}
+			} else {
+				if(! t2p->pdf_ojpegdata){
+					TIFFError(TIFF2PDF_MODULE, 
+				"No support for OJPEG image %s with bad tables", 
+						TIFFFileName(input));
+					t2p->t2p_error = T2P_ERR_ERROR;
+					return(0);
+				}
+				buffer = (unsigned char*)
+					_TIFFmalloc(t2p->tiff_datasize);
+                                memset(buffer, 0, t2p->tiff_datasize);
+				if(buffer==NULL){
+					TIFFError(TIFF2PDF_MODULE, 
+	"Can't allocate %u bytes of memory for t2p_readwrite_pdf_image, %s", 
+						t2p->tiff_datasize, 
+						TIFFFileName(input));
+					t2p->t2p_error = T2P_ERR_ERROR;
+					return(0);
+				}
+				_TIFFmemcpy(buffer, t2p->pdf_ojpegdata, t2p->pdf_ojpegdatalength);
+				bufferoffset=t2p->pdf_ojpegdatalength;
+				stripcount=TIFFNumberOfStrips(input);
+				for(i=0;i<stripcount;i++){
+					if(i != 0){
+						buffer[bufferoffset++]=0xff;
+						buffer[bufferoffset++]=(0xd0 | ((i-1)%8));
+					}
+					bufferoffset+=TIFFReadRawStrip(input, 
+						i, 
+						(tdata_t) &(((unsigned char*)buffer)[bufferoffset]), 
+						-1);
+				}
+				if( ! ( (buffer[bufferoffset-1]==0xd9) && (buffer[bufferoffset-2]==0xff) ) ){
+						buffer[bufferoffset++]=0xff;
+						buffer[bufferoffset++]=0xd9;
+				}
+				t2pWriteFile(output, (tdata_t) buffer, bufferoffset);
+				_TIFFfree(buffer);
+				return(bufferoffset);
+				TIFFError(TIFF2PDF_MODULE, 
+	"No support for OJPEG image %s with no JPEG File Interchange offset", 
+					TIFFFileName(input));
+				t2p->t2p_error = T2P_ERR_ERROR;
+				return(0);
+			}
+			return(t2p->tiff_datasize);
+		}
+#endif
+#ifdef JPEG_SUPPORT
+		if(t2p->tiff_compression == COMPRESSION_JPEG) {
+			uint32 count = 0;
+			buffer = (unsigned char*)
+				_TIFFmalloc(t2p->tiff_datasize);
+                        memset(buffer, 0, t2p->tiff_datasize);
+			if(buffer==NULL){
+				TIFFError(TIFF2PDF_MODULE, 
+	"Can't allocate %u bytes of memory for t2p_readwrite_pdf_image, %s", 
+					t2p->tiff_datasize, 
+					TIFFFileName(input));
+				t2p->t2p_error = T2P_ERR_ERROR;
+				return(0);
+			}
+			if (TIFFGetField(input, TIFFTAG_JPEGTABLES, &count, &jpt) != 0) {
+				if(count > 4) {
+					_TIFFmemcpy(buffer, jpt, count);
+					bufferoffset += count - 2;
+				}
+			}
+			stripcount=TIFFNumberOfStrips(input);
+			TIFFGetField(input, TIFFTAG_STRIPBYTECOUNTS, &sbc);
+			for(i=0;i<stripcount;i++){
+				if(sbc[i]>max_striplength) max_striplength=sbc[i];
+			}
+			stripbuffer = (unsigned char*)
+				_TIFFmalloc(max_striplength);
+			if(stripbuffer==NULL){
+				TIFFError(TIFF2PDF_MODULE, 
+	"Can't allocate %u bytes of memory for t2p_readwrite_pdf_image, %s", 
+					max_striplength, 
+					TIFFFileName(input));
+				_TIFFfree(buffer);
+				t2p->t2p_error = T2P_ERR_ERROR;
+				return(0);
+			}
+			for(i=0;i<stripcount;i++){
+				striplength=TIFFReadRawStrip(input, i, (tdata_t) stripbuffer, -1);
+				if(!t2p_process_jpeg_strip(
+					stripbuffer, 
+					&striplength, 
+					buffer, 
+					&bufferoffset, 
+					i, 
+					t2p->tiff_length)){
+						TIFFError(TIFF2PDF_MODULE, 
+				"Can't process JPEG data in input file %s", 
+							TIFFFileName(input));
+						_TIFFfree(samplebuffer);
+						_TIFFfree(buffer);
+						t2p->t2p_error = T2P_ERR_ERROR;
+						return(0);
+				}
+			}
+			buffer[bufferoffset++]=0xff; 
+			buffer[bufferoffset++]=0xd9;
+			t2pWriteFile(output, (tdata_t) buffer, bufferoffset);
+			_TIFFfree(stripbuffer);
+			_TIFFfree(buffer);
+			return(bufferoffset);
+		}
+#endif
+		(void)0;
+	}
+
+	if(t2p->pdf_sample==T2P_SAMPLE_NOTHING){
+		buffer = (unsigned char*) _TIFFmalloc(t2p->tiff_datasize);
+                memset(buffer, 0, t2p->tiff_datasize);
+		if(buffer==NULL){
+			TIFFError(TIFF2PDF_MODULE, 
+	"Can't allocate %u bytes of memory for t2p_readwrite_pdf_image, %s", 
+				t2p->tiff_datasize, 
+				TIFFFileName(input));
+			t2p->t2p_error = T2P_ERR_ERROR;
+			return(0);
+		}
+		stripsize=TIFFStripSize(input);
+		stripcount=TIFFNumberOfStrips(input);
+		for(i=0;i<stripcount;i++){
+			read = 
+				TIFFReadEncodedStrip(input, 
+				i, 
+				(tdata_t) &buffer[bufferoffset], 
+				stripsize);
+			if(read==-1){
+				TIFFError(TIFF2PDF_MODULE, 
+					"Error on decoding strip %u of %s", 
+					i, 
+					TIFFFileName(input));
+				_TIFFfree(buffer);
+				t2p->t2p_error=T2P_ERR_ERROR;
+				return(0);
+			}
+			bufferoffset+=read;
+		}
+	} else {
+		if(t2p->pdf_sample & T2P_SAMPLE_PLANAR_SEPARATE_TO_CONTIG){
+		
+			sepstripsize=TIFFStripSize(input);
+			sepstripcount=TIFFNumberOfStrips(input);
+		
+			stripsize=sepstripsize*t2p->tiff_samplesperpixel;
+			stripcount=sepstripcount/t2p->tiff_samplesperpixel;
+			
+			buffer = (unsigned char*) _TIFFmalloc(t2p->tiff_datasize);
+                        memset(buffer, 0, t2p->tiff_datasize);
+			if(buffer==NULL){
+				TIFFError(TIFF2PDF_MODULE, 
+	"Can't allocate %u bytes of memory for t2p_readwrite_pdf_image, %s", 
+					t2p->tiff_datasize, 
+					TIFFFileName(input));
+				t2p->t2p_error = T2P_ERR_ERROR;
+				return(0);
+			}
+			samplebuffer = (unsigned char*) _TIFFmalloc(stripsize);
+			if(samplebuffer==NULL){
+				TIFFError(TIFF2PDF_MODULE, 
+	"Can't allocate %u bytes of memory for t2p_readwrite_pdf_image, %s", 
+					t2p->tiff_datasize, 
+					TIFFFileName(input));
+				t2p->t2p_error = T2P_ERR_ERROR;
+				return(0);
+			}
+			for(i=0;i<stripcount;i++){
+				samplebufferoffset=0;
+				for(j=0;j<t2p->tiff_samplesperpixel;j++){
+					read = 
+						TIFFReadEncodedStrip(input, 
+							i + j*stripcount, 
+							(tdata_t) &(samplebuffer[samplebufferoffset]), 
+							sepstripsize);
+					if(read==-1){
+						TIFFError(TIFF2PDF_MODULE, 
+					"Error on decoding strip %u of %s", 
+							i + j*stripcount, 
+							TIFFFileName(input));
+							_TIFFfree(buffer);
+						t2p->t2p_error=T2P_ERR_ERROR;
+						return(0);
+					}
+					samplebufferoffset+=read;
+				}
+				t2p_sample_planar_separate_to_contig(
+					t2p,
+					&(buffer[bufferoffset]),
+					samplebuffer, 
+					samplebufferoffset); 
+				bufferoffset+=samplebufferoffset;
+			}
+			_TIFFfree(samplebuffer);
+			goto dataready;
+		}
+
+		buffer = (unsigned char*) _TIFFmalloc(t2p->tiff_datasize);
+                memset(buffer, 0, t2p->tiff_datasize);
+		if(buffer==NULL){
+			TIFFError(TIFF2PDF_MODULE, 
+	"Can't allocate %u bytes of memory for t2p_readwrite_pdf_image, %s", 
+				t2p->tiff_datasize, 
+				TIFFFileName(input));
+			t2p->t2p_error = T2P_ERR_ERROR;
+			return(0);
+		}
+		stripsize=TIFFStripSize(input);
+		stripcount=TIFFNumberOfStrips(input);
+		for(i=0;i<stripcount;i++){
+			read = 
+				TIFFReadEncodedStrip(input, 
+				i, 
+				(tdata_t) &buffer[bufferoffset], 
+				stripsize);
+			if(read==-1){
+				TIFFError(TIFF2PDF_MODULE, 
+					"Error on decoding strip %u of %s", 
+					i, 
+					TIFFFileName(input));
+				_TIFFfree(samplebuffer);
+				_TIFFfree(buffer);
+				t2p->t2p_error=T2P_ERR_ERROR;
+				return(0);
+			}
+			bufferoffset+=read;
+		}
+
+		if(t2p->pdf_sample & T2P_SAMPLE_REALIZE_PALETTE){
+			samplebuffer=(unsigned char*)_TIFFrealloc( 
+				(tdata_t) buffer, 
+				t2p->tiff_datasize * t2p->tiff_samplesperpixel);
+			if(samplebuffer==NULL){
+				TIFFError(TIFF2PDF_MODULE, 
+	"Can't allocate %u bytes of memory for t2p_readwrite_pdf_image, %s", 
+					t2p->tiff_datasize, 
+					TIFFFileName(input));
+				t2p->t2p_error = T2P_ERR_ERROR;
+			  _TIFFfree(buffer);
+			} else {
+				buffer=samplebuffer;
+				t2p->tiff_datasize *= t2p->tiff_samplesperpixel;
+			}
+			t2p_sample_realize_palette(t2p, buffer);
+		}
+
+		if(t2p->pdf_sample & T2P_SAMPLE_RGBA_TO_RGB){
+			t2p->tiff_datasize=t2p_sample_rgba_to_rgb(
+				(tdata_t)buffer, 
+				t2p->tiff_width*t2p->tiff_length);
+		}
+
+		if(t2p->pdf_sample & T2P_SAMPLE_RGBAA_TO_RGB){
+			t2p->tiff_datasize=t2p_sample_rgbaa_to_rgb(
+				(tdata_t)buffer, 
+				t2p->tiff_width*t2p->tiff_length);
+		}
+
+		if(t2p->pdf_sample & T2P_SAMPLE_YCBCR_TO_RGB){
+			samplebuffer=(unsigned char*)_TIFFrealloc(
+				(tdata_t)buffer, 
+				t2p->tiff_width*t2p->tiff_length*4);
+			if(samplebuffer==NULL){
+				TIFFError(TIFF2PDF_MODULE, 
+	"Can't allocate %u bytes of memory for t2p_readwrite_pdf_image, %s", 
+					t2p->tiff_datasize, 
+					TIFFFileName(input));
+				t2p->t2p_error = T2P_ERR_ERROR;
+				_TIFFfree(buffer);
+				return(0);
+			} else {
+				buffer=samplebuffer;
+			}
+			if(!TIFFReadRGBAImageOriented(
+				input, 
+				t2p->tiff_width, 
+				t2p->tiff_length, 
+				(uint32*)buffer, 
+				ORIENTATION_TOPLEFT,
+				0)){
+				TIFFError(TIFF2PDF_MODULE, 
+	"Can't use TIFFReadRGBAImageOriented to extract RGB image from %s", 
+					TIFFFileName(input));
+				t2p->t2p_error = T2P_ERR_ERROR;
+				return(0);
+			}
+			t2p->tiff_datasize=t2p_sample_abgr_to_rgb(
+				(tdata_t) buffer, 
+				t2p->tiff_width*t2p->tiff_length);
+
+		}
+
+		if(t2p->pdf_sample & T2P_SAMPLE_LAB_SIGNED_TO_UNSIGNED){
+			t2p->tiff_datasize=t2p_sample_lab_signed_to_unsigned(
+				(tdata_t)buffer, 
+				t2p->tiff_width*t2p->tiff_length);
+		}
+	}
+
+dataready:
+
+	t2p_disable(output);
+	TIFFSetField(output, TIFFTAG_PHOTOMETRIC, t2p->tiff_photometric);
+	TIFFSetField(output, TIFFTAG_BITSPERSAMPLE, t2p->tiff_bitspersample);
+	TIFFSetField(output, TIFFTAG_SAMPLESPERPIXEL, t2p->tiff_samplesperpixel);
+	TIFFSetField(output, TIFFTAG_IMAGEWIDTH, t2p->tiff_width);
+	TIFFSetField(output, TIFFTAG_IMAGELENGTH, t2p->tiff_length);
+	TIFFSetField(output, TIFFTAG_ROWSPERSTRIP, t2p->tiff_length);
+	TIFFSetField(output, TIFFTAG_PLANARCONFIG, PLANARCONFIG_CONTIG);
+	TIFFSetField(output, TIFFTAG_FILLORDER, FILLORDER_MSB2LSB);
+
+	switch(t2p->pdf_compression){
+	case T2P_COMPRESS_NONE:
+		TIFFSetField(output, TIFFTAG_COMPRESSION, COMPRESSION_NONE);
+		break;
+#ifdef CCITT_SUPPORT
+	case T2P_COMPRESS_G4:
+		TIFFSetField(output, TIFFTAG_COMPRESSION, COMPRESSION_CCITTFAX4);
+		break;
+#endif
+#ifdef JPEG_SUPPORT
+	case T2P_COMPRESS_JPEG:
+		if(t2p->tiff_photometric==PHOTOMETRIC_YCBCR) {
+			uint16 hor = 0, ver = 0;
+			if (TIFFGetField(input, TIFFTAG_YCBCRSUBSAMPLING, &hor, &ver) !=0 ) {
+				if(hor != 0 && ver != 0){
+					TIFFSetField(output, TIFFTAG_YCBCRSUBSAMPLING, hor, ver);
+				}
+			}
+			if(TIFFGetField(input, TIFFTAG_REFERENCEBLACKWHITE, &xfloatp)!=0){
+				TIFFSetField(output, TIFFTAG_REFERENCEBLACKWHITE, xfloatp);
+			}
+		}
+		if(TIFFSetField(output, TIFFTAG_COMPRESSION, COMPRESSION_JPEG)==0){
+			TIFFError(TIFF2PDF_MODULE, 
+		"Unable to use JPEG compression for input %s and output %s", 
+				TIFFFileName(input),
+				TIFFFileName(output));
+			_TIFFfree(buffer);
+			t2p->t2p_error = T2P_ERR_ERROR;
+			return(0);
+		}
+		TIFFSetField(output, TIFFTAG_JPEGTABLESMODE, 0);
+
+		if(t2p->pdf_colorspace & (T2P_CS_RGB | T2P_CS_LAB)){
+			TIFFSetField(output, TIFFTAG_PHOTOMETRIC, PHOTOMETRIC_YCBCR);
+			if(t2p->tiff_photometric != PHOTOMETRIC_YCBCR){
+				TIFFSetField(output, TIFFTAG_JPEGCOLORMODE, JPEGCOLORMODE_RGB);
+			} else {
+				TIFFSetField(output, TIFFTAG_JPEGCOLORMODE, JPEGCOLORMODE_RAW);
+			}
+		}
+		if(t2p->pdf_colorspace & T2P_CS_GRAY){
+			(void)0;
+		}
+		if(t2p->pdf_colorspace & T2P_CS_CMYK){
+			(void)0;
+		}
+		if(t2p->pdf_defaultcompressionquality != 0){
+			TIFFSetField(output, 
+				TIFFTAG_JPEGQUALITY, 
+				t2p->pdf_defaultcompressionquality);
+		}
+	
+		break;
+#endif
+#ifdef ZIP_SUPPORT
+	case T2P_COMPRESS_ZIP:
+		TIFFSetField(output, TIFFTAG_COMPRESSION, COMPRESSION_DEFLATE);
+		if(t2p->pdf_defaultcompressionquality%100 != 0){
+			TIFFSetField(output, 
+				TIFFTAG_PREDICTOR, 
+				t2p->pdf_defaultcompressionquality % 100);
+		}
+		if(t2p->pdf_defaultcompressionquality/100 != 0){
+			TIFFSetField(output, 
+				TIFFTAG_ZIPQUALITY, 
+				(t2p->pdf_defaultcompressionquality / 100));
+		}
+		break;
+#endif
+	default:
+		break;
+	}
+
+	t2p_enable(output);
+	t2p->outputwritten = 0;
+#ifdef JPEG_SUPPORT
+	if(t2p->pdf_compression == T2P_COMPRESS_JPEG
+	   && t2p->tiff_photometric == PHOTOMETRIC_YCBCR){
+		bufferoffset = TIFFWriteEncodedStrip(output, (tstrip_t)0,
+						     buffer,
+						     stripsize * stripcount); 
+	} else
+#endif
+	{
+		bufferoffset = TIFFWriteEncodedStrip(output, (tstrip_t)0,
+						     buffer,
+						     t2p->tiff_datasize); 
+	}
+	if (buffer != NULL) {
+		_TIFFfree(buffer);
+		buffer=NULL;
+	}
+
+	if (bufferoffset == (tsize_t)-1) {
+		TIFFError(TIFF2PDF_MODULE, 
+			  "Error writing encoded strip to output PDF %s", 
+			  TIFFFileName(output));
+		t2p->t2p_error = T2P_ERR_ERROR;
+		return(0);
+	}
+	
+	written = t2p->outputwritten;
+	return(written);
+}
+
+/*
+ * This function reads the raster image data from the input TIFF for an image
+ * tile and writes the data to the output PDF XObject image dictionary stream
+ * for the tile.  It returns the amount written or zero on error.
+ */
+
+tsize_t t2p_readwrite_pdf_image_tile(T2P* t2p, TIFF* input, TIFF* output, ttile_t tile){
+
+	uint16 edge=0;
+	tsize_t written=0;
+	unsigned char* buffer=NULL;
+	tsize_t bufferoffset=0;
+	unsigned char* samplebuffer=NULL;
+	tsize_t samplebufferoffset=0;
+	tsize_t read=0;
+	uint16 i=0;
+	ttile_t tilecount=0;
+	tsize_t tilesize=0;
+	ttile_t septilecount=0;
+	tsize_t septilesize=0;
+#ifdef JPEG_SUPPORT
+	unsigned char* jpt;
+	float* xfloatp;
+	uint32 xuint32=0;
+#endif
+
+	/* Fail if prior error (in particular, can't trust tiff_datasize) */
+	if (t2p->t2p_error != T2P_ERR_OK)
+		return(0);
+
+	edge |= t2p_tile_is_right_edge(t2p->tiff_tiles[t2p->pdf_page], tile);
+	edge |= t2p_tile_is_bottom_edge(t2p->tiff_tiles[t2p->pdf_page], tile);
+
+	if( (t2p->pdf_transcode == T2P_TRANSCODE_RAW) && ((edge == 0)
+#if defined(JPEG_SUPPORT) || defined(OJPEG_SUPPORT)
+		|| (t2p->pdf_compression == T2P_COMPRESS_JPEG)
+#endif
+	)
+	){
+#ifdef CCITT_SUPPORT
+		if(t2p->pdf_compression == T2P_COMPRESS_G4){
+			buffer= (unsigned char*) _TIFFmalloc(t2p->tiff_datasize);
+			if(buffer==NULL){
+				TIFFError(TIFF2PDF_MODULE, 
+					"Can't allocate %u bytes of memory "
+                                        "for t2p_readwrite_pdf_image_tile, %s", 
+					t2p->tiff_datasize, 
+					TIFFFileName(input));
+				t2p->t2p_error = T2P_ERR_ERROR;
+				return(0);
+			}
+			TIFFReadRawTile(input, tile, (tdata_t) buffer, t2p->tiff_datasize);
+			if (t2p->tiff_fillorder==FILLORDER_LSB2MSB){
+					TIFFReverseBits(buffer, t2p->tiff_datasize);
+			}
+			t2pWriteFile(output, (tdata_t) buffer, t2p->tiff_datasize);
+			_TIFFfree(buffer);
+			return(t2p->tiff_datasize);
+		}
+#endif
+#ifdef ZIP_SUPPORT
+		if(t2p->pdf_compression == T2P_COMPRESS_ZIP){
+			buffer= (unsigned char*) _TIFFmalloc(t2p->tiff_datasize);
+			if(buffer==NULL){
+				TIFFError(TIFF2PDF_MODULE, 
+					"Can't allocate %u bytes of memory "
+                                        "for t2p_readwrite_pdf_image_tile, %s", 
+					t2p->tiff_datasize, 
+					TIFFFileName(input));
+				t2p->t2p_error = T2P_ERR_ERROR;
+				return(0);
+			}
+			TIFFReadRawTile(input, tile, (tdata_t) buffer, t2p->tiff_datasize);
+			if (t2p->tiff_fillorder==FILLORDER_LSB2MSB){
+					TIFFReverseBits(buffer, t2p->tiff_datasize);
+			}
+			t2pWriteFile(output, (tdata_t) buffer, t2p->tiff_datasize);
+			_TIFFfree(buffer);
+			return(t2p->tiff_datasize);
+		}
+#endif
+#ifdef OJPEG_SUPPORT
+		if(t2p->tiff_compression == COMPRESSION_OJPEG){
+			if(! t2p->pdf_ojpegdata){
+				TIFFError(TIFF2PDF_MODULE, 
+					"No support for OJPEG image %s with "
+                                        "bad tables", 
+					TIFFFileName(input));
+				t2p->t2p_error = T2P_ERR_ERROR;
+				return(0);
+			}
+			buffer=(unsigned char*) _TIFFmalloc(t2p->tiff_datasize);
+			if(buffer==NULL){
+				TIFFError(TIFF2PDF_MODULE, 
+					"Can't allocate %u bytes of memory "
+                                        "for t2p_readwrite_pdf_image, %s", 
+					t2p->tiff_datasize, 
+					TIFFFileName(input));
+				t2p->t2p_error = T2P_ERR_ERROR;
+				return(0);
+			}
+			_TIFFmemcpy(buffer, t2p->pdf_ojpegdata, t2p->pdf_ojpegdatalength);
+			if(edge!=0){
+				if(t2p_tile_is_bottom_edge(t2p->tiff_tiles[t2p->pdf_page], tile)){
+					buffer[7]=
+						(t2p->tiff_tiles[t2p->pdf_page].tiles_edgetilelength >> 8) & 0xff;
+					buffer[8]=
+						(t2p->tiff_tiles[t2p->pdf_page].tiles_edgetilelength ) & 0xff;
+				}
+				if(t2p_tile_is_right_edge(t2p->tiff_tiles[t2p->pdf_page], tile)){
+					buffer[9]=
+						(t2p->tiff_tiles[t2p->pdf_page].tiles_edgetilewidth >> 8) & 0xff;
+					buffer[10]=
+						(t2p->tiff_tiles[t2p->pdf_page].tiles_edgetilewidth ) & 0xff;
+				}
+			}
+			bufferoffset=t2p->pdf_ojpegdatalength;
+			bufferoffset+=TIFFReadRawTile(input, 
+					tile, 
+					(tdata_t) &(((unsigned char*)buffer)[bufferoffset]), 
+					-1);
+			((unsigned char*)buffer)[bufferoffset++]=0xff;
+			((unsigned char*)buffer)[bufferoffset++]=0xd9;
+			t2pWriteFile(output, (tdata_t) buffer, bufferoffset);
+			_TIFFfree(buffer);
+			return(bufferoffset);
+		}
+#endif
+#ifdef JPEG_SUPPORT
+		if(t2p->tiff_compression == COMPRESSION_JPEG){
+			unsigned char table_end[2];
+			uint32 count = 0;
+			buffer= (unsigned char*) _TIFFmalloc(t2p->tiff_datasize);
+			if(buffer==NULL){
+				TIFFError(TIFF2PDF_MODULE, 
+					"Can't allocate %u bytes of memory "
+                                        "for t2p_readwrite_pdf_image_tile, %s", 
+					t2p->tiff_datasize, 
+					TIFFFileName(input));
+				t2p->t2p_error = T2P_ERR_ERROR;
+				return(0);
+			}
+			if(TIFFGetField(input, TIFFTAG_JPEGTABLES, &count, &jpt) != 0) {
+				if (count > 0) {
+					_TIFFmemcpy(buffer, jpt, count);
+					bufferoffset += count - 2;
+					table_end[0] = buffer[bufferoffset-2];
+					table_end[1] = buffer[bufferoffset-1];
+				}
+				if (count > 0) {
+					xuint32 = bufferoffset;
+					bufferoffset += TIFFReadRawTile(
+						input, 
+						tile, 
+						(tdata_t) &(((unsigned char*)buffer)[bufferoffset-2]), 
+						-1);
+						buffer[xuint32-2]=table_end[0];
+						buffer[xuint32-1]=table_end[1];
+				} else {
+					bufferoffset += TIFFReadRawTile(
+						input, 
+						tile, 
+						(tdata_t) &(((unsigned char*)buffer)[bufferoffset]), 
+						-1);
+				}
+			}
+			t2pWriteFile(output, (tdata_t) buffer, bufferoffset);
+			_TIFFfree(buffer);
+			return(bufferoffset);
+		}
+#endif
+		(void)0;
+	}
+
+	if(t2p->pdf_sample==T2P_SAMPLE_NOTHING){
+		buffer = (unsigned char*) _TIFFmalloc(t2p->tiff_datasize);
+		if(buffer==NULL){
+			TIFFError(TIFF2PDF_MODULE, 
+				"Can't allocate %u bytes of memory for "
+                                "t2p_readwrite_pdf_image_tile, %s", 
+				t2p->tiff_datasize, 
+				TIFFFileName(input));
+			t2p->t2p_error = T2P_ERR_ERROR;
+			return(0);
+		}
+
+		read = TIFFReadEncodedTile(
+			input, 
+			tile, 
+			(tdata_t) &buffer[bufferoffset], 
+			t2p->tiff_datasize);
+		if(read==-1){
+			TIFFError(TIFF2PDF_MODULE, 
+				"Error on decoding tile %u of %s", 
+				tile, 
+				TIFFFileName(input));
+			_TIFFfree(buffer);
+			t2p->t2p_error=T2P_ERR_ERROR;
+			return(0);
+		}
+
+	} else {
+
+		if(t2p->pdf_sample == T2P_SAMPLE_PLANAR_SEPARATE_TO_CONTIG){
+			septilesize=TIFFTileSize(input);
+			septilecount=TIFFNumberOfTiles(input);
+			tilesize=septilesize*t2p->tiff_samplesperpixel;
+			tilecount=septilecount/t2p->tiff_samplesperpixel;
+			buffer = (unsigned char*) _TIFFmalloc(t2p->tiff_datasize);
+			if(buffer==NULL){
+				TIFFError(TIFF2PDF_MODULE, 
+					"Can't allocate %u bytes of memory "
+                                        "for t2p_readwrite_pdf_image_tile, %s", 
+					t2p->tiff_datasize, 
+					TIFFFileName(input));
+				t2p->t2p_error = T2P_ERR_ERROR;
+				return(0);
+			}
+			samplebuffer = (unsigned char*) _TIFFmalloc(t2p->tiff_datasize);
+			if(samplebuffer==NULL){
+				TIFFError(TIFF2PDF_MODULE, 
+					"Can't allocate %u bytes of memory "
+                                        "for t2p_readwrite_pdf_image_tile, %s", 
+					t2p->tiff_datasize, 
+					TIFFFileName(input));
+				t2p->t2p_error = T2P_ERR_ERROR;
+				return(0);
+			}
+			samplebufferoffset=0;
+			for(i=0;i<t2p->tiff_samplesperpixel;i++){
+				read = 
+					TIFFReadEncodedTile(input, 
+						tile + i*tilecount, 
+						(tdata_t) &(samplebuffer[samplebufferoffset]), 
+						septilesize);
+				if(read==-1){
+					TIFFError(TIFF2PDF_MODULE, 
+						"Error on decoding tile %u of %s", 
+						tile + i*tilecount, 
+						TIFFFileName(input));
+						_TIFFfree(samplebuffer);
+						_TIFFfree(buffer);
+					t2p->t2p_error=T2P_ERR_ERROR;
+					return(0);
+				}
+				samplebufferoffset+=read;
+			}
+			t2p_sample_planar_separate_to_contig(
+				t2p,
+				&(buffer[bufferoffset]),
+				samplebuffer, 
+				samplebufferoffset); 
+			bufferoffset+=samplebufferoffset;
+			_TIFFfree(samplebuffer);
+		}
+
+		if(buffer==NULL){
+			buffer = (unsigned char*) _TIFFmalloc(t2p->tiff_datasize);
+			if(buffer==NULL){
+				TIFFError(TIFF2PDF_MODULE, 
+					"Can't allocate %u bytes of memory "
+                                        "for t2p_readwrite_pdf_image_tile, %s", 
+					t2p->tiff_datasize, 
+					TIFFFileName(input));
+				t2p->t2p_error = T2P_ERR_ERROR;
+				return(0);
+			}
+			read = TIFFReadEncodedTile(
+				input, 
+				tile, 
+				(tdata_t) &buffer[bufferoffset], 
+				t2p->tiff_datasize);
+			if(read==-1){
+				TIFFError(TIFF2PDF_MODULE, 
+					"Error on decoding tile %u of %s", 
+					tile, 
+					TIFFFileName(input));
+				_TIFFfree(buffer);
+				t2p->t2p_error=T2P_ERR_ERROR;
+				return(0);
+			}
+		}
+
+		if(t2p->pdf_sample & T2P_SAMPLE_RGBA_TO_RGB){
+			t2p->tiff_datasize=t2p_sample_rgba_to_rgb(
+				(tdata_t)buffer, 
+				t2p->tiff_tiles[t2p->pdf_page].tiles_tilewidth
+				*t2p->tiff_tiles[t2p->pdf_page].tiles_tilelength);
+		}
+
+		if(t2p->pdf_sample & T2P_SAMPLE_RGBAA_TO_RGB){
+			t2p->tiff_datasize=t2p_sample_rgbaa_to_rgb(
+				(tdata_t)buffer, 
+				t2p->tiff_tiles[t2p->pdf_page].tiles_tilewidth
+				*t2p->tiff_tiles[t2p->pdf_page].tiles_tilelength);
+		}
+
+		if(t2p->pdf_sample & T2P_SAMPLE_YCBCR_TO_RGB){
+			TIFFError(TIFF2PDF_MODULE, 
+				"No support for YCbCr to RGB in tile for %s", 
+				TIFFFileName(input));
+			_TIFFfree(buffer);
+			t2p->t2p_error = T2P_ERR_ERROR;
+			return(0);
+		}
+
+		if(t2p->pdf_sample & T2P_SAMPLE_LAB_SIGNED_TO_UNSIGNED){
+			t2p->tiff_datasize=t2p_sample_lab_signed_to_unsigned(
+				(tdata_t)buffer, 
+				t2p->tiff_tiles[t2p->pdf_page].tiles_tilewidth
+				*t2p->tiff_tiles[t2p->pdf_page].tiles_tilelength);
+		}
+	}
+
+	if(t2p_tile_is_right_edge(t2p->tiff_tiles[t2p->pdf_page], tile) != 0){
+		t2p_tile_collapse_left(
+			buffer, 
+			TIFFTileRowSize(input),
+			t2p->tiff_tiles[t2p->pdf_page].tiles_tilewidth,
+			t2p->tiff_tiles[t2p->pdf_page].tiles_edgetilewidth, 
+			t2p->tiff_tiles[t2p->pdf_page].tiles_tilelength);
+	}
+
+
+	t2p_disable(output);
+	TIFFSetField(output, TIFFTAG_PHOTOMETRIC, t2p->tiff_photometric);
+	TIFFSetField(output, TIFFTAG_BITSPERSAMPLE, t2p->tiff_bitspersample);
+	TIFFSetField(output, TIFFTAG_SAMPLESPERPIXEL, t2p->tiff_samplesperpixel);
+	if(t2p_tile_is_right_edge(t2p->tiff_tiles[t2p->pdf_page], tile) == 0){
+		TIFFSetField(
+			output, 
+			TIFFTAG_IMAGEWIDTH, 
+			t2p->tiff_tiles[t2p->pdf_page].tiles_tilewidth);
+	} else {
+		TIFFSetField(
+			output, 
+			TIFFTAG_IMAGEWIDTH, 
+			t2p->tiff_tiles[t2p->pdf_page].tiles_edgetilewidth);
+	}
+	if(t2p_tile_is_bottom_edge(t2p->tiff_tiles[t2p->pdf_page], tile) == 0){
+		TIFFSetField(
+			output, 
+			TIFFTAG_IMAGELENGTH, 
+			t2p->tiff_tiles[t2p->pdf_page].tiles_tilelength);
+		TIFFSetField(
+			output, 
+			TIFFTAG_ROWSPERSTRIP, 
+			t2p->tiff_tiles[t2p->pdf_page].tiles_tilelength);
+	} else {
+		TIFFSetField(
+			output, 
+			TIFFTAG_IMAGELENGTH, 
+			t2p->tiff_tiles[t2p->pdf_page].tiles_edgetilelength);
+		TIFFSetField(
+			output, 
+			TIFFTAG_ROWSPERSTRIP, 
+			t2p->tiff_tiles[t2p->pdf_page].tiles_edgetilelength);
+	}
+	TIFFSetField(output, TIFFTAG_PLANARCONFIG, PLANARCONFIG_CONTIG);
+	TIFFSetField(output, TIFFTAG_FILLORDER, FILLORDER_MSB2LSB);
+
+	switch(t2p->pdf_compression){
+	case T2P_COMPRESS_NONE:
+		TIFFSetField(output, TIFFTAG_COMPRESSION, COMPRESSION_NONE);
+		break;
+#ifdef CCITT_SUPPORT
+	case T2P_COMPRESS_G4:
+		TIFFSetField(output, TIFFTAG_COMPRESSION, COMPRESSION_CCITTFAX4);
+		break;
+#endif
+#ifdef JPEG_SUPPORT
+	case T2P_COMPRESS_JPEG:
+		if (t2p->tiff_photometric==PHOTOMETRIC_YCBCR) {
+			uint16 hor = 0, ver = 0;
+			if (TIFFGetField(input, TIFFTAG_YCBCRSUBSAMPLING, &hor, &ver)!=0) {
+				if (hor != 0 && ver != 0) {
+					TIFFSetField(output, TIFFTAG_YCBCRSUBSAMPLING, hor, ver);
+				}
+			}
+			if(TIFFGetField(input, TIFFTAG_REFERENCEBLACKWHITE, &xfloatp)!=0){
+				TIFFSetField(output, TIFFTAG_REFERENCEBLACKWHITE, xfloatp);
+			}
+		}
+		TIFFSetField(output, TIFFTAG_COMPRESSION, COMPRESSION_JPEG);
+		TIFFSetField(output, TIFFTAG_JPEGTABLESMODE, 0); /* JPEGTABLESMODE_NONE */
+		if(t2p->pdf_colorspace & (T2P_CS_RGB | T2P_CS_LAB)){
+			TIFFSetField(output, TIFFTAG_PHOTOMETRIC, PHOTOMETRIC_YCBCR);
+			if(t2p->tiff_photometric != PHOTOMETRIC_YCBCR){
+				TIFFSetField(output, TIFFTAG_JPEGCOLORMODE, JPEGCOLORMODE_RGB);
+			} else {
+				TIFFSetField(output, TIFFTAG_JPEGCOLORMODE, JPEGCOLORMODE_RAW);
+			}
+		}
+		if(t2p->pdf_colorspace & T2P_CS_GRAY){
+			(void)0;
+		}
+		if(t2p->pdf_colorspace & T2P_CS_CMYK){
+			(void)0;
+		}
+		if(t2p->pdf_defaultcompressionquality != 0){
+			TIFFSetField(output, 
+				TIFFTAG_JPEGQUALITY, 
+				t2p->pdf_defaultcompressionquality);
+		}
+		break;
+#endif
+#ifdef ZIP_SUPPORT
+	case T2P_COMPRESS_ZIP:
+		TIFFSetField(output, TIFFTAG_COMPRESSION, COMPRESSION_DEFLATE);
+		if(t2p->pdf_defaultcompressionquality%100 != 0){
+			TIFFSetField(output, 
+				TIFFTAG_PREDICTOR, 
+				t2p->pdf_defaultcompressionquality % 100);
+		}
+		if(t2p->pdf_defaultcompressionquality/100 != 0){
+			TIFFSetField(output, 
+				TIFFTAG_ZIPQUALITY, 
+				(t2p->pdf_defaultcompressionquality / 100));
+		}
+		break;
+#endif
+	default:
+		break;
+	}
+
+	t2p_enable(output);
+	t2p->outputwritten = 0;
+	bufferoffset = TIFFWriteEncodedStrip(output, (tstrip_t) 0, buffer,
+					     TIFFStripSize(output)); 
+	if (buffer != NULL) {
+		_TIFFfree(buffer);
+		buffer = NULL;
+	}
+	if (bufferoffset == -1) {
+		TIFFError(TIFF2PDF_MODULE, 
+			  "Error writing encoded tile to output PDF %s", 
+			  TIFFFileName(output));
+		t2p->t2p_error = T2P_ERR_ERROR;
+		return(0);
+	}
+	
+	written = t2p->outputwritten;
+	
+	return(written);
+}
+
+#ifdef OJPEG_SUPPORT
+int t2p_process_ojpeg_tables(T2P* t2p, TIFF* input){
+	uint16 proc=0;
+	void* q;
+	uint32 q_length=0;
+	void* dc;
+	uint32 dc_length=0;
+	void* ac;
+	uint32 ac_length=0;
+	uint16* lp;
+	uint16* pt;
+	uint16 h_samp=1;
+	uint16 v_samp=1;
+	unsigned char* ojpegdata;
+	uint16 table_count;
+	uint32 offset_table;
+	uint32 offset_ms_l;
+	uint32 code_count;
+	uint32 i=0;
+	uint32 dest=0;
+	uint16 ri=0;
+	uint32 rows=0;
+	
+	if(!TIFFGetField(input, TIFFTAG_JPEGPROC, &proc)){
+		TIFFError(TIFF2PDF_MODULE, 
+			"Missing JPEGProc field in OJPEG image %s", 
+			TIFFFileName(input));
+			t2p->t2p_error = T2P_ERR_ERROR;
+		return(0);
+	}
+	if(proc!=JPEGPROC_BASELINE && proc!=JPEGPROC_LOSSLESS){
+		TIFFError(TIFF2PDF_MODULE, 
+			"Bad JPEGProc field in OJPEG image %s", 
+			TIFFFileName(input));
+			t2p->t2p_error = T2P_ERR_ERROR;
+		return(0);
+	}
+	if(!TIFFGetField(input, TIFFTAG_JPEGQTABLES, &q_length, &q)){
+		TIFFError(TIFF2PDF_MODULE, 
+			"Missing JPEGQTables field in OJPEG image %s", 
+			TIFFFileName(input));
+			t2p->t2p_error = T2P_ERR_ERROR;
+		return(0);
+	}
+	if(q_length < (64U * t2p->tiff_samplesperpixel)){
+		TIFFError(TIFF2PDF_MODULE, 
+			"Bad JPEGQTables field in OJPEG image %s", 
+			TIFFFileName(input));
+			t2p->t2p_error = T2P_ERR_ERROR;
+		return(0);
+	} 
+	if(!TIFFGetField(input, TIFFTAG_JPEGDCTABLES, &dc_length, &dc)){
+		TIFFError(TIFF2PDF_MODULE, 
+			"Missing JPEGDCTables field in OJPEG image %s", 
+			TIFFFileName(input));
+			t2p->t2p_error = T2P_ERR_ERROR;
+		return(0);
+	}
+	if(proc==JPEGPROC_BASELINE){
+		if(!TIFFGetField(input, TIFFTAG_JPEGACTABLES, &ac_length, &ac)){
+			TIFFError(TIFF2PDF_MODULE, 
+				"Missing JPEGACTables field in OJPEG image %s", 
+				TIFFFileName(input));
+				t2p->t2p_error = T2P_ERR_ERROR;
+			return(0);
+		}
+	} else {
+		if(!TIFFGetField(input, TIFFTAG_JPEGLOSSLESSPREDICTORS, &lp)){
+			TIFFError(TIFF2PDF_MODULE, 
+				"Missing JPEGLosslessPredictors field in OJPEG image %s", 
+				TIFFFileName(input));
+				t2p->t2p_error = T2P_ERR_ERROR;
+				return(0);
+		}
+		if(!TIFFGetField(input, TIFFTAG_JPEGPOINTTRANSFORM, &pt)){
+			TIFFError(TIFF2PDF_MODULE, 
+				"Missing JPEGPointTransform field in OJPEG image %s", 
+				TIFFFileName(input));
+				t2p->t2p_error = T2P_ERR_ERROR;
+			return(0);
+		}
+	}
+	if(!TIFFGetField(input, TIFFTAG_YCBCRSUBSAMPLING, &h_samp, &v_samp)){
+		h_samp=1;
+		v_samp=1;
+	}
+	if(t2p->pdf_ojpegdata != NULL){
+		_TIFFfree(t2p->pdf_ojpegdata);
+		t2p->pdf_ojpegdata=NULL;
+	} 
+	t2p->pdf_ojpegdata = _TIFFmalloc(2048);
+	if(t2p->pdf_ojpegdata == NULL){
+		TIFFError(TIFF2PDF_MODULE, 
+			"Can't allocate %u bytes of memory for t2p_process_ojpeg_tables, %s", 
+			2048, 
+			TIFFFileName(input));
+		return(0);
+	}
+	_TIFFmemset(t2p->pdf_ojpegdata, 0x00, 2048);
+	t2p->pdf_ojpegdatalength = 0;
+	table_count=t2p->tiff_samplesperpixel;
+	if(proc==JPEGPROC_BASELINE){
+		if(table_count>2) table_count=2;
+	}
+	ojpegdata=(unsigned char*)t2p->pdf_ojpegdata;
+	ojpegdata[t2p->pdf_ojpegdatalength++]=0xff;
+	ojpegdata[t2p->pdf_ojpegdatalength++]=0xd8;
+	ojpegdata[t2p->pdf_ojpegdatalength++]=0xff;
+	if(proc==JPEGPROC_BASELINE){
+		ojpegdata[t2p->pdf_ojpegdatalength++]=0xc0;
+	} else {
+		ojpegdata[t2p->pdf_ojpegdatalength++]=0xc3;
+	}
+	ojpegdata[t2p->pdf_ojpegdatalength++]=0x00;
+	ojpegdata[t2p->pdf_ojpegdatalength++]=(8 + 3*t2p->tiff_samplesperpixel);
+	ojpegdata[t2p->pdf_ojpegdatalength++]=(t2p->tiff_bitspersample & 0xff);
+	if(TIFFIsTiled(input)){
+		ojpegdata[t2p->pdf_ojpegdatalength++]=
+			(t2p->tiff_tiles[t2p->pdf_page].tiles_tilelength >> 8) & 0xff;
+		ojpegdata[t2p->pdf_ojpegdatalength++]=
+			(t2p->tiff_tiles[t2p->pdf_page].tiles_tilelength ) & 0xff;
+		ojpegdata[t2p->pdf_ojpegdatalength++]=
+			(t2p->tiff_tiles[t2p->pdf_page].tiles_tilewidth >> 8) & 0xff;
+		ojpegdata[t2p->pdf_ojpegdatalength++]=
+			(t2p->tiff_tiles[t2p->pdf_page].tiles_tilewidth ) & 0xff;
+	} else {
+		ojpegdata[t2p->pdf_ojpegdatalength++]=
+			(t2p->tiff_length >> 8) & 0xff;
+		ojpegdata[t2p->pdf_ojpegdatalength++]=
+			(t2p->tiff_length ) & 0xff;
+		ojpegdata[t2p->pdf_ojpegdatalength++]=
+			(t2p->tiff_width >> 8) & 0xff;
+		ojpegdata[t2p->pdf_ojpegdatalength++]=
+			(t2p->tiff_width ) & 0xff;
+	}
+	ojpegdata[t2p->pdf_ojpegdatalength++]=(t2p->tiff_samplesperpixel & 0xff);
+	for(i=0;i<t2p->tiff_samplesperpixel;i++){
+		ojpegdata[t2p->pdf_ojpegdatalength++]=i;
+		if(i==0){
+			ojpegdata[t2p->pdf_ojpegdatalength] |= h_samp<<4 & 0xf0;;
+			ojpegdata[t2p->pdf_ojpegdatalength++] |= v_samp & 0x0f;
+		} else {
+				ojpegdata[t2p->pdf_ojpegdatalength++]= 0x11;
+		}
+		ojpegdata[t2p->pdf_ojpegdatalength++]=i;
+	}
+	for(dest=0;dest<t2p->tiff_samplesperpixel;dest++){
+		ojpegdata[t2p->pdf_ojpegdatalength++]=0xff;
+		ojpegdata[t2p->pdf_ojpegdatalength++]=0xdb;
+		ojpegdata[t2p->pdf_ojpegdatalength++]=0x00;
+		ojpegdata[t2p->pdf_ojpegdatalength++]=0x43;
+		ojpegdata[t2p->pdf_ojpegdatalength++]=dest;
+		_TIFFmemcpy( &(ojpegdata[t2p->pdf_ojpegdatalength++]), 
+			&(((unsigned char*)q)[64*dest]), 64);
+		t2p->pdf_ojpegdatalength+=64;
+	}
+	offset_table=0;
+	for(dest=0;dest<table_count;dest++){
+		ojpegdata[t2p->pdf_ojpegdatalength++]=0xff;
+		ojpegdata[t2p->pdf_ojpegdatalength++]=0xc4;
+		offset_ms_l=t2p->pdf_ojpegdatalength;
+		t2p->pdf_ojpegdatalength+=2;
+		ojpegdata[t2p->pdf_ojpegdatalength++]=dest & 0x0f;
+		_TIFFmemcpy( &(ojpegdata[t2p->pdf_ojpegdatalength]), 
+			&(((unsigned char*)dc)[offset_table]), 16);
+		code_count=0;
+		offset_table+=16;
+		for(i=0;i<16;i++){
+			code_count+=ojpegdata[t2p->pdf_ojpegdatalength++];
+		}
+		ojpegdata[offset_ms_l]=((19+code_count)>>8) & 0xff;
+		ojpegdata[offset_ms_l+1]=(19+code_count) & 0xff;
+		_TIFFmemcpy( &(ojpegdata[t2p->pdf_ojpegdatalength]), 
+			&(((unsigned char*)dc)[offset_table]), code_count);
+		offset_table+=code_count;
+		t2p->pdf_ojpegdatalength+=code_count;
+	}
+	if(proc==JPEGPROC_BASELINE){
+	offset_table=0;
+		for(dest=0;dest<table_count;dest++){
+			ojpegdata[t2p->pdf_ojpegdatalength++]=0xff;
+			ojpegdata[t2p->pdf_ojpegdatalength++]=0xc4;
+			offset_ms_l=t2p->pdf_ojpegdatalength;
+			t2p->pdf_ojpegdatalength+=2;
+			ojpegdata[t2p->pdf_ojpegdatalength] |= 0x10;
+			ojpegdata[t2p->pdf_ojpegdatalength++] |=dest & 0x0f;
+			_TIFFmemcpy( &(ojpegdata[t2p->pdf_ojpegdatalength]), 
+				&(((unsigned char*)ac)[offset_table]), 16);
+			code_count=0;
+			offset_table+=16;
+			for(i=0;i<16;i++){
+				code_count+=ojpegdata[t2p->pdf_ojpegdatalength++];
+			}	
+			ojpegdata[offset_ms_l]=((19+code_count)>>8) & 0xff;
+			ojpegdata[offset_ms_l+1]=(19+code_count) & 0xff;
+			_TIFFmemcpy( &(ojpegdata[t2p->pdf_ojpegdatalength]), 
+				&(((unsigned char*)ac)[offset_table]), code_count);
+			offset_table+=code_count;
+			t2p->pdf_ojpegdatalength+=code_count;
+		}
+	}
+	if(TIFFNumberOfStrips(input)>1){
+		ojpegdata[t2p->pdf_ojpegdatalength++]=0xff;
+		ojpegdata[t2p->pdf_ojpegdatalength++]=0xdd;
+		ojpegdata[t2p->pdf_ojpegdatalength++]=0x00;
+		ojpegdata[t2p->pdf_ojpegdatalength++]=0x04;
+		h_samp*=8;
+		v_samp*=8;
+		ri=(t2p->tiff_width+h_samp-1) / h_samp;
+		TIFFGetField(input, TIFFTAG_ROWSPERSTRIP, &rows);
+		ri*=(rows+v_samp-1)/v_samp;
+		ojpegdata[t2p->pdf_ojpegdatalength++]= (ri>>8) & 0xff;
+		ojpegdata[t2p->pdf_ojpegdatalength++]= ri & 0xff;
+	}
+	ojpegdata[t2p->pdf_ojpegdatalength++]=0xff;
+	ojpegdata[t2p->pdf_ojpegdatalength++]=0xda;
+	ojpegdata[t2p->pdf_ojpegdatalength++]=0x00;
+	ojpegdata[t2p->pdf_ojpegdatalength++]=(6 + 2*t2p->tiff_samplesperpixel);
+	ojpegdata[t2p->pdf_ojpegdatalength++]=t2p->tiff_samplesperpixel & 0xff;
+	for(i=0;i<t2p->tiff_samplesperpixel;i++){
+		ojpegdata[t2p->pdf_ojpegdatalength++]= i & 0xff;
+		if(proc==JPEGPROC_BASELINE){
+			ojpegdata[t2p->pdf_ojpegdatalength] |= 
+				( ( (i>(table_count-1U)) ? (table_count-1U) : i) << 4U) & 0xf0;
+			ojpegdata[t2p->pdf_ojpegdatalength++] |= 
+				( (i>(table_count-1U)) ? (table_count-1U) : i) & 0x0f;
+		} else {
+			ojpegdata[t2p->pdf_ojpegdatalength++] =  (i << 4) & 0xf0;
+		}
+	}
+	if(proc==JPEGPROC_BASELINE){
+		t2p->pdf_ojpegdatalength++;
+		ojpegdata[t2p->pdf_ojpegdatalength++]=0x3f;
+		t2p->pdf_ojpegdatalength++;
+	} else {
+		ojpegdata[t2p->pdf_ojpegdatalength++]= (lp[0] & 0xff);
+		t2p->pdf_ojpegdatalength++;
+		ojpegdata[t2p->pdf_ojpegdatalength++]= (pt[0] & 0x0f);
+	}
+
+	return(1);
+}
+#endif
+
+#ifdef JPEG_SUPPORT
+int t2p_process_jpeg_strip(
+	unsigned char* strip, 
+	tsize_t* striplength, 
+	unsigned char* buffer, 
+	tsize_t* bufferoffset, 
+	tstrip_t no, 
+	uint32 height){
+
+	tsize_t i=0;
+	uint16 ri =0;
+	uint16 v_samp=1;
+	uint16 h_samp=1;
+	int j=0;
+	
+	i++;
+	
+	while(i<(*striplength)){
+		switch( strip[i] ){
+			case 0xd8:
+				i+=2;
+				break;
+			case 0xc0:
+			case 0xc1:
+			case 0xc3:
+			case 0xc9:
+			case 0xca:
+				if(no==0){
+					_TIFFmemcpy(&(buffer[*bufferoffset]), &(strip[i-1]), strip[i+2]+2);
+					for(j=0;j<buffer[*bufferoffset+9];j++){
+						if( (buffer[*bufferoffset+11+(2*j)]>>4) > h_samp) 
+							h_samp = (buffer[*bufferoffset+11+(2*j)]>>4);
+						if( (buffer[*bufferoffset+11+(2*j)] & 0x0f) > v_samp) 
+							v_samp = (buffer[*bufferoffset+11+(2*j)] & 0x0f);
+					}
+					v_samp*=8;
+					h_samp*=8;
+					ri=((( ((uint16)(buffer[*bufferoffset+5])<<8) | 
+					(uint16)(buffer[*bufferoffset+6]) )+v_samp-1)/ 
+					v_samp);
+					ri*=((( ((uint16)(buffer[*bufferoffset+7])<<8) | 
+					(uint16)(buffer[*bufferoffset+8]) )+h_samp-1)/ 
+					h_samp);
+					buffer[*bufferoffset+5]=
+                                          (unsigned char) ((height>>8) & 0xff);
+					buffer[*bufferoffset+6]=
+                                            (unsigned char) (height & 0xff);
+					*bufferoffset+=strip[i+2]+2;
+					i+=strip[i+2]+2;
+
+					buffer[(*bufferoffset)++]=0xff;
+					buffer[(*bufferoffset)++]=0xdd;
+					buffer[(*bufferoffset)++]=0x00;
+					buffer[(*bufferoffset)++]=0x04;
+					buffer[(*bufferoffset)++]=(ri >> 8) & 0xff;
+					buffer[(*bufferoffset)++]= ri & 0xff;
+				} else {
+					i+=strip[i+2]+2;
+				}
+				break;
+			case 0xc4:
+			case 0xdb:
+				_TIFFmemcpy(&(buffer[*bufferoffset]), &(strip[i-1]), strip[i+2]+2);
+				*bufferoffset+=strip[i+2]+2;
+				i+=strip[i+2]+2;
+				break;
+			case 0xda:
+				if(no==0){
+					_TIFFmemcpy(&(buffer[*bufferoffset]), &(strip[i-1]), strip[i+2]+2);
+					*bufferoffset+=strip[i+2]+2;
+					i+=strip[i+2]+2;
+				} else {
+					buffer[(*bufferoffset)++]=0xff;
+					buffer[(*bufferoffset)++]=
+                                            (unsigned char)(0xd0 | ((no-1)%8));
+					i+=strip[i+2]+2;
+				}
+				_TIFFmemcpy(&(buffer[*bufferoffset]), &(strip[i-1]), (*striplength)-i-1);
+				*bufferoffset+=(*striplength)-i-1;
+				return(1);
+			default:
+				i+=strip[i+2]+2;
+		}
+	}
+	
+
+	return(0);
+}
+#endif
+
+/*
+	This functions converts a tilewidth x tilelength buffer of samples into an edgetilewidth x 
+	tilelength buffer of samples.
+*/
+void t2p_tile_collapse_left(
+	tdata_t buffer, 
+	tsize_t scanwidth, 
+	uint32 tilewidth, 
+	uint32 edgetilewidth, 
+	uint32 tilelength){
+	
+	uint32 i=0;
+	tsize_t edgescanwidth=0;
+	
+	edgescanwidth = (scanwidth * edgetilewidth + (tilewidth - 1))/ tilewidth;
+	for(i=i;i<tilelength;i++){
+		_TIFFmemcpy( 
+			&(((char*)buffer)[edgescanwidth*i]), 
+			&(((char*)buffer)[scanwidth*i]), 
+			edgescanwidth);
+	}
+	
+	return;
+}
+
+
+/*
+ * This function calls TIFFWriteDirectory on the output after blanking its
+ * output by replacing the read, write, and seek procedures with empty
+ * implementations, then it replaces the original implementations.
+ */
+
+void
+t2p_write_advance_directory(T2P* t2p, TIFF* output)
+{
+	t2p_disable(output);
+	if(!TIFFWriteDirectory(output)){
+		TIFFError(TIFF2PDF_MODULE, 
+			"Error writing virtual directory to output PDF %s", 
+			TIFFFileName(output));
+		t2p->t2p_error = T2P_ERR_ERROR;
+		return;
+	}
+	t2p_enable(output);
+	return;
+}
+
+tsize_t t2p_sample_planar_separate_to_contig(
+											T2P* t2p, 
+                                                    unsigned char* buffer, 
+                                                    unsigned char* samplebuffer, 
+                                                    tsize_t samplebuffersize){
+
+	tsize_t stride=0;
+	tsize_t i=0;
+	tsize_t j=0;
+	
+	stride=samplebuffersize/t2p->tiff_samplesperpixel;
+	for(i=0;i<stride;i++){
+		for(j=0;j<t2p->tiff_samplesperpixel;j++){
+			buffer[i*t2p->tiff_samplesperpixel + j] = samplebuffer[i + j*stride];
+		}
+	}
+
+	return(samplebuffersize);
+}
+
+tsize_t t2p_sample_realize_palette(T2P* t2p, unsigned char* buffer){
+
+	uint32 sample_count=0;
+	uint16 component_count=0;
+	uint32 palette_offset=0;
+	uint32 sample_offset=0;
+	uint32 i=0;
+	uint32 j=0;
+	sample_count=t2p->tiff_width*t2p->tiff_length;
+	component_count=t2p->tiff_samplesperpixel;
+	
+	for(i=sample_count;i>0;i--){
+		palette_offset=buffer[i-1] * component_count;
+		sample_offset= (i-1) * component_count;
+		for(j=0;j<component_count;j++){
+			buffer[sample_offset+j]=t2p->pdf_palette[palette_offset+j];
+		}
+	}
+
+	return(0);
+}
+
+/*
+	This functions converts in place a buffer of ABGR interleaved data
+	into RGB interleaved data, discarding A.
+*/
+
+tsize_t t2p_sample_abgr_to_rgb(tdata_t data, uint32 samplecount)
+{
+	uint32 i=0;
+	uint32 sample=0;
+	
+	for(i=0;i<samplecount;i++){
+		sample=((uint32*)data)[i];
+		((char*)data)[i*3]= (char) (sample & 0xff);
+		((char*)data)[i*3+1]= (char) ((sample>>8) & 0xff);
+		((char*)data)[i*3+2]= (char) ((sample>>16) & 0xff);
+	}
+
+	return(i*3);
+}
+
+/*
+ * This functions converts in place a buffer of RGBA interleaved data
+ * into RGB interleaved data, discarding A.
+ */
+
+tsize_t
+t2p_sample_rgbaa_to_rgb(tdata_t data, uint32 samplecount)
+{
+	uint32 i;
+	
+	for(i = 0; i < samplecount; i++)
+		memcpy((uint8*)data + i * 3, (uint8*)data + i * 4, 3);
+
+	return(i * 3);
+}
+
+/*
+ * This functions converts in place a buffer of RGBA interleaved data
+ * into RGB interleaved data, adding 255-A to each component sample.
+ */
+
+tsize_t
+t2p_sample_rgba_to_rgb(tdata_t data, uint32 samplecount)
+{
+	uint32 i = 0;
+	uint32 sample = 0;
+	uint8 alpha = 0;
+	
+	for (i = 0; i < samplecount; i++) {
+		sample=((uint32*)data)[i];
+		alpha=(uint8)((255 - (sample & 0xff)));
+		((uint8 *)data)[i * 3] = (uint8) ((sample >> 24) & 0xff) + alpha;
+		((uint8 *)data)[i * 3 + 1] = (uint8) ((sample >> 16) & 0xff) + alpha;
+		((uint8 *)data)[i * 3 + 2] = (uint8) ((sample >> 8) & 0xff) + alpha;
+		
+	}
+
+	return (i * 3);
+}
+
+/*
+	This function converts the a and b samples of Lab data from signed
+	to unsigned.
+*/
+
+tsize_t t2p_sample_lab_signed_to_unsigned(tdata_t buffer, uint32 samplecount){
+
+	uint32 i=0;
+
+	for(i=0;i<samplecount;i++){
+		if( (((unsigned char*)buffer)[(i*3)+1] & 0x80) !=0){
+			((unsigned char*)buffer)[(i*3)+1] =
+				(unsigned char)(0x80 + ((char*)buffer)[(i*3)+1]);
+		} else {
+			((unsigned char*)buffer)[(i*3)+1] |= 0x80;
+		}
+		if( (((unsigned char*)buffer)[(i*3)+2] & 0x80) !=0){
+			((unsigned char*)buffer)[(i*3)+2] =
+				(unsigned char)(0x80 + ((char*)buffer)[(i*3)+2]);
+		} else {
+			((unsigned char*)buffer)[(i*3)+2] |= 0x80;
+		}
+	}
+
+	return(samplecount*3);
+}
+
+/* 
+	This function writes the PDF header to output.
+*/
+
+tsize_t t2p_write_pdf_header(T2P* t2p, TIFF* output){
+
+	tsize_t written=0;
+	char buffer[16];
+	int buflen=0;
+	
+	buflen=sprintf(buffer, "%%PDF-%u.%u ", t2p->pdf_majorversion&0xff, t2p->pdf_minorversion&0xff);
+	written += t2pWriteFile(output, (tdata_t) buffer, buflen);
+	written += t2pWriteFile(output, (tdata_t)"\n%\342\343\317\323\n", 7);
+
+	return(written);
+}
+
+/*
+	This function writes the beginning of a PDF object to output.
+*/
+
+tsize_t t2p_write_pdf_obj_start(uint32 number, TIFF* output){
+
+	tsize_t written=0;
+	char buffer[16];
+	int buflen=0;
+
+	buflen=sprintf(buffer, "%lu", (unsigned long)number);
+	written += t2pWriteFile(output, (tdata_t) buffer, buflen );
+	written += t2pWriteFile(output, (tdata_t) " 0 obj\n", 7);
+
+	return(written);
+}
+
+/*
+	This function writes the end of a PDF object to output.
+*/
+
+tsize_t t2p_write_pdf_obj_end(TIFF* output){
+
+	tsize_t written=0;
+
+	written += t2pWriteFile(output, (tdata_t) "endobj\n", 7);
+
+	return(written);
+}
+
+/*
+	This function writes a PDF name object to output.
+*/
+
+tsize_t t2p_write_pdf_name(unsigned char* name, TIFF* output){
+
+	tsize_t written=0;
+	uint32 i=0;
+	char buffer[64];
+	uint16 nextchar=0;
+	uint32 namelen=0;
+	
+	namelen = strlen((char *)name);
+	if (namelen>126) {
+		namelen=126;
+	}
+	written += t2pWriteFile(output, (tdata_t) "/", 1);
+	for (i=0;i<namelen;i++){
+		if ( ((unsigned char)name[i]) < 0x21){
+			sprintf(buffer, "#%.2X", name[i]);
+			buffer[sizeof(buffer) - 1] = '\0';
+			written += t2pWriteFile(output, (tdata_t) buffer, 3);
+			nextchar=1;
+		}
+		if ( ((unsigned char)name[i]) > 0x7E){
+			sprintf(buffer, "#%.2X", name[i]);
+			buffer[sizeof(buffer) - 1] = '\0';
+			written += t2pWriteFile(output, (tdata_t) buffer, 3);
+			nextchar=1;
+		}
+		if (nextchar==0){
+			switch (name[i]){
+				case 0x23:
+					sprintf(buffer, "#%.2X", name[i]);
+					buffer[sizeof(buffer) - 1] = '\0';
+					written += t2pWriteFile(output, (tdata_t) buffer, 3);
+					break;
+				case 0x25:
+					sprintf(buffer, "#%.2X", name[i]);
+					buffer[sizeof(buffer) - 1] = '\0';
+					written += t2pWriteFile(output, (tdata_t) buffer, 3);
+					break;
+				case 0x28:
+					sprintf(buffer, "#%.2X", name[i]);
+					buffer[sizeof(buffer) - 1] = '\0';
+					written += t2pWriteFile(output, (tdata_t) buffer, 3);
+					break;
+				case 0x29:
+					sprintf(buffer, "#%.2X", name[i]); 
+					buffer[sizeof(buffer) - 1] = '\0';
+					written += t2pWriteFile(output, (tdata_t) buffer, 3);
+					break;
+				case 0x2F:
+					sprintf(buffer, "#%.2X", name[i]); 
+					buffer[sizeof(buffer) - 1] = '\0';
+					written += t2pWriteFile(output, (tdata_t) buffer, 3);
+					break;
+				case 0x3C:
+					sprintf(buffer, "#%.2X", name[i]); 
+					buffer[sizeof(buffer) - 1] = '\0';
+					written += t2pWriteFile(output, (tdata_t) buffer, 3);
+					break;
+				case 0x3E:
+					sprintf(buffer, "#%.2X", name[i]);
+					buffer[sizeof(buffer) - 1] = '\0';
+					written += t2pWriteFile(output, (tdata_t) buffer, 3);
+					break;
+				case 0x5B:
+					sprintf(buffer, "#%.2X", name[i]); 
+					buffer[sizeof(buffer) - 1] = '\0';
+					written += t2pWriteFile(output, (tdata_t) buffer, 3);
+					break;
+				case 0x5D:
+					sprintf(buffer, "#%.2X", name[i]);
+					buffer[sizeof(buffer) - 1] = '\0';
+					written += t2pWriteFile(output, (tdata_t) buffer, 3);
+					break;
+				case 0x7B:
+					sprintf(buffer, "#%.2X", name[i]); 
+					buffer[sizeof(buffer) - 1] = '\0';
+					written += t2pWriteFile(output, (tdata_t) buffer, 3);
+					break;
+				case 0x7D:
+					sprintf(buffer, "#%.2X", name[i]); 
+					buffer[sizeof(buffer) - 1] = '\0';
+					written += t2pWriteFile(output, (tdata_t) buffer, 3);
+					break;
+				default:
+					written += t2pWriteFile(output, (tdata_t) &name[i], 1);
+			}
+		}
+		nextchar=0;
+	}
+	written += t2pWriteFile(output, (tdata_t) " ", 1);
+
+	return(written);
+}
+
+/*
+	This function writes a PDF string object to output.
+*/
+	
+tsize_t t2p_write_pdf_string(unsigned char* pdfstr, TIFF* output){
+
+	tsize_t written = 0;
+	uint32 i = 0;
+	char buffer[64];
+	uint32 len = 0;
+	
+	len = strlen((char *)pdfstr);
+	written += t2pWriteFile(output, (tdata_t) "(", 1);
+	for (i=0; i<len; i++) {
+		if((pdfstr[i]&0x80) || (pdfstr[i]==127) || (pdfstr[i]<32)){
+			sprintf(buffer, "\\%.3hho", pdfstr[i]);
+			buffer[sizeof(buffer) - 1] = '\0';
+			written += t2pWriteFile(output, (tdata_t) buffer, 4);
+		} else {
+			switch (pdfstr[i]){
+				case 0x08:
+					written += t2pWriteFile(output, (tdata_t) "\\b", 2);
+					break;
+				case 0x09:
+					written += t2pWriteFile(output, (tdata_t) "\\t", 2);
+					break;
+				case 0x0A:
+					written += t2pWriteFile(output, (tdata_t) "\\n", 2);
+					break;
+				case 0x0C:
+					written += t2pWriteFile(output, (tdata_t) "\\f", 2);
+					break;
+				case 0x0D:
+					written += t2pWriteFile(output, (tdata_t) "\\r", 2);
+					break;
+				case 0x28:
+					written += t2pWriteFile(output, (tdata_t) "\\(", 2);
+					break;
+				case 0x29:
+					written += t2pWriteFile(output, (tdata_t) "\\)", 2);
+					break;
+				case 0x5C:
+					written += t2pWriteFile(output, (tdata_t) "\\\\", 2);
+					break;
+				default:
+					written += t2pWriteFile(output, (tdata_t) &pdfstr[i], 1);
+			}
+		}
+	}
+	written += t2pWriteFile(output, (tdata_t) ") ", 1);
+
+	return(written);
+}
+
+
+/*
+	This function writes a buffer of data to output.
+*/
+
+tsize_t t2p_write_pdf_stream(tdata_t buffer, tsize_t len, TIFF* output){
+
+	tsize_t written=0;
+
+	written += t2pWriteFile(output, (tdata_t) buffer, len);
+
+	return(written);
+}
+
+/*
+	This functions writes the beginning of a PDF stream to output.
+*/
+
+tsize_t t2p_write_pdf_stream_start(TIFF* output){
+
+	tsize_t written=0;
+
+	written += t2pWriteFile(output, (tdata_t) "stream\n", 7);
+
+	return(written);
+}
+
+/*
+	This function writes the end of a PDF stream to output. 
+*/
+
+tsize_t t2p_write_pdf_stream_end(TIFF* output){
+
+	tsize_t written=0;
+
+	written += t2pWriteFile(output, (tdata_t) "\nendstream\n", 11);
+
+	return(written);
+}
+
+/*
+	This function writes a stream dictionary for a PDF stream to output.
+*/
+
+tsize_t t2p_write_pdf_stream_dict(tsize_t len, uint32 number, TIFF* output){
+	
+	tsize_t written=0;
+	char buffer[16];
+	int buflen=0;
+	
+	written += t2pWriteFile(output, (tdata_t) "/Length ", 8);
+	if(len!=0){
+		written += t2p_write_pdf_stream_length(len, output);
+	} else {
+		buflen=sprintf(buffer, "%lu", (unsigned long)number);
+		written += t2pWriteFile(output, (tdata_t) buffer, buflen);
+		written += t2pWriteFile(output, (tdata_t) " 0 R \n", 6);
+	}
+	
+	return(written);
+}
+
+/*
+	This functions writes the beginning of a PDF stream dictionary to output.
+*/
+
+tsize_t t2p_write_pdf_stream_dict_start(TIFF* output){
+
+	tsize_t written=0;
+
+	written += t2pWriteFile(output, (tdata_t) "<< \n", 4);
+
+	return(written);
+}
+
+/*
+	This function writes the end of a PDF stream dictionary to output. 
+*/
+
+tsize_t t2p_write_pdf_stream_dict_end(TIFF* output){
+
+	tsize_t written=0;
+
+	written += t2pWriteFile(output, (tdata_t) " >>\n", 4);
+
+	return(written);
+}
+
+/*
+	This function writes a number to output.
+*/
+
+tsize_t t2p_write_pdf_stream_length(tsize_t len, TIFF* output){
+
+	tsize_t written=0;
+	char buffer[16];
+	int buflen=0;
+
+	buflen=sprintf(buffer, "%lu", (unsigned long)len);
+	written += t2pWriteFile(output, (tdata_t) buffer, buflen);
+	written += t2pWriteFile(output, (tdata_t) "\n", 1);
+
+	return(written);
+}
+
+/*
+	This function writes the PDF Catalog structure to output.
+*/
+
+tsize_t t2p_write_pdf_catalog(T2P* t2p, TIFF* output){
+
+	tsize_t written=0;
+	char buffer[16];
+	int buflen=0;
+
+	written += t2pWriteFile(output, 
+		(tdata_t)"<< \n/Type /Catalog \n/Pages ", 
+		27);
+	buflen=sprintf(buffer, "%lu", (unsigned long)t2p->pdf_pages);
+	written += t2pWriteFile(output, (tdata_t) buffer, buflen );
+	written += t2pWriteFile(output, (tdata_t) " 0 R \n", 6);
+	if(t2p->pdf_fitwindow){
+		written += t2pWriteFile(output, 
+			(tdata_t) "/ViewerPreferences <</FitWindow true>>\n", 
+			39);
+	}
+	written += t2pWriteFile(output, (tdata_t)">>\n", 3);
+
+	return(written);
+}
+
+/*
+	This function writes the PDF Info structure to output.
+*/
+
+tsize_t t2p_write_pdf_info(T2P* t2p, TIFF* input, TIFF* output){
+
+	tsize_t written = 0;
+	unsigned char* info;
+	char buffer[512];
+	int buflen = 0;
+
+	if(t2p->pdf_datetime==NULL){
+		t2p_pdf_tifftime(t2p, input);
+	}
+	if(strlen((char *)t2p->pdf_datetime) > 0){
+		written += t2pWriteFile(output, (tdata_t) "<< \n/CreationDate ", 18);
+		written += t2p_write_pdf_string(t2p->pdf_datetime, output);
+		written += t2pWriteFile(output, (tdata_t) "\n/ModDate ", 10);
+		written += t2p_write_pdf_string(t2p->pdf_datetime, output);
+	}
+	written += t2pWriteFile(output, (tdata_t) "\n/Producer ", 11);
+	_TIFFmemset((tdata_t)buffer, 0x00, sizeof(buffer));
+	buflen = sprintf(buffer, "libtiff / tiff2pdf - %d", TIFFLIB_VERSION);
+	written += t2p_write_pdf_string((unsigned char*)buffer, output);
+	written += t2pWriteFile(output, (tdata_t) "\n", 1);
+	if(t2p->pdf_creator != NULL){ 
+		if(strlen((char *)t2p->pdf_creator)>0){
+			if(strlen((char *)t2p->pdf_creator) > 511) {
+				t2p->pdf_creator[512] = '\0';
+			}
+			written += t2pWriteFile(output, (tdata_t) "/Creator ", 9);
+			written += t2p_write_pdf_string(t2p->pdf_creator, output);
+			written += t2pWriteFile(output, (tdata_t) "\n", 1);
+		}
+	} else{
+		if( TIFFGetField(input, TIFFTAG_SOFTWARE, &info) != 0){
+			if(strlen((char *)info) > 511) {
+				info[512] = '\0';
+			}
+			written += t2pWriteFile(output, (tdata_t) "/Creator ", 9);
+			written += t2p_write_pdf_string(info, output);
+			written += t2pWriteFile(output, (tdata_t) "\n", 1);
+		}
+	}
+	if(t2p->pdf_author != NULL) { 
+		if(strlen((char *)t2p->pdf_author) > 0) {
+			if(strlen((char *)t2p->pdf_author) > 511) {
+				t2p->pdf_author[512] = '\0';
+			}
+			written += t2pWriteFile(output, (tdata_t) "/Author ", 8);
+			written += t2p_write_pdf_string(t2p->pdf_author, output);
+			written += t2pWriteFile(output, (tdata_t) "\n", 1);
+		}
+	} else{
+		if( TIFFGetField(input, TIFFTAG_ARTIST, &info) != 0){
+			if(strlen((char *)info) > 511) {
+				info[512] = '\0';
+			}
+			written += t2pWriteFile(output, (tdata_t) "/Author ", 8);
+			written += t2p_write_pdf_string(info, output);
+			written += t2pWriteFile(output, (tdata_t) "\n", 1);
+		} else if ( TIFFGetField(input, TIFFTAG_COPYRIGHT, &info) != 0){
+			if(strlen((char *)info) > 511) {
+				info[512] = '\0';
+			}
+			written += t2pWriteFile(output, (tdata_t) "/Author ", 8);
+			written += t2p_write_pdf_string(info, output);
+			written += t2pWriteFile(output, (tdata_t) "\n", 1);
+		} 
+	}
+	if(t2p->pdf_title != NULL) {
+		if(strlen((char *)t2p->pdf_title) > 0) {
+			if(strlen((char *)t2p->pdf_title) > 511) {
+				t2p->pdf_title[512] = '\0';
+			}
+			written += t2pWriteFile(output, (tdata_t) "/Title ", 7);
+			written += t2p_write_pdf_string(t2p->pdf_title, output);
+			written += t2pWriteFile(output, (tdata_t) "\n", 1);
+		}
+	} else{
+		if( TIFFGetField(input, TIFFTAG_DOCUMENTNAME, &info) != 0){
+			if(strlen((char *)info) > 511) {
+				info[512] = '\0';
+			}
+			written += t2pWriteFile(output, (tdata_t) "/Title ", 7);
+			written += t2p_write_pdf_string(info, output);
+			written += t2pWriteFile(output, (tdata_t) "\n", 1);
+		}
+	}
+	if(t2p->pdf_subject != NULL) {
+		if(strlen((char *)t2p->pdf_subject) > 0) {
+			if(strlen((char *)t2p->pdf_subject) > 511) {
+				t2p->pdf_subject[512] = '\0';
+			}
+			written += t2pWriteFile(output, (tdata_t) "/Subject ", 9);
+			written += t2p_write_pdf_string(t2p->pdf_subject, output);
+			written += t2pWriteFile(output, (tdata_t) "\n", 1);
+		}
+	} else {
+		if(TIFFGetField(input, TIFFTAG_IMAGEDESCRIPTION, &info) != 0) {
+			if(strlen((char *)info) > 511) {
+				info[512] = '\0';
+			}
+			written += t2pWriteFile(output, (tdata_t) "/Subject ", 9);
+			written += t2p_write_pdf_string(info, output);
+			written += t2pWriteFile(output, (tdata_t) "\n", 1);
+		}
+	}
+	if(t2p->pdf_keywords != NULL) { 
+		if(strlen((char *)t2p->pdf_keywords) > 0) {
+			if(strlen((char *)t2p->pdf_keywords) > 511) {
+				t2p->pdf_keywords[512] = '\0';
+			}
+			written += t2pWriteFile(output, (tdata_t) "/Keywords ", 10);
+			written += t2p_write_pdf_string(t2p->pdf_keywords, output);
+			written += t2pWriteFile(output, (tdata_t) "\n", 1);
+		}
+	}
+	written += t2pWriteFile(output, (tdata_t) ">> \n", 4);	
+
+	return(written);
+}
+
+/*
+ * This function fills a string of a T2P struct with the current time as a PDF
+ * date string, it is called by t2p_pdf_tifftime.
+ */
+
+void t2p_pdf_currenttime(T2P* t2p)
+{
+
+	struct tm* currenttime;
+	time_t timenow;
+
+	timenow=time(0);
+	currenttime=localtime(&timenow);
+	sprintf((char *)t2p->pdf_datetime, "D:%.4d%.2d%.2d%.2d%.2d%.2d",
+		(currenttime->tm_year+1900) % 65536, 
+		(currenttime->tm_mon+1) % 256, 
+		(currenttime->tm_mday) % 256, 
+		(currenttime->tm_hour) % 256, 
+		(currenttime->tm_min) % 256, 
+		(currenttime->tm_sec) % 256);
+
+	return;
+}
+
+/*
+ * This function fills a string of a T2P struct with the date and time of a
+ * TIFF file if it exists or the current time as a PDF date string.
+ */
+
+void t2p_pdf_tifftime(T2P* t2p, TIFF* input){
+
+	char* datetime;
+
+	t2p->pdf_datetime = (unsigned char*) _TIFFmalloc(19);
+	if(t2p->pdf_datetime == NULL){
+		TIFFError(TIFF2PDF_MODULE, 
+		"Can't allocate %u bytes of memory for t2p_pdf_tiff_time", 17); 
+		t2p->t2p_error = T2P_ERR_ERROR;
+		return;
+	}
+	t2p->pdf_datetime[16] = '\0';
+	if( TIFFGetField(input, TIFFTAG_DATETIME, &datetime) != 0 
+	    && (strlen(datetime) >= 19) ){
+		t2p->pdf_datetime[0]='D';
+		t2p->pdf_datetime[1]=':';
+		t2p->pdf_datetime[2]=datetime[0];
+		t2p->pdf_datetime[3]=datetime[1];
+		t2p->pdf_datetime[4]=datetime[2];
+		t2p->pdf_datetime[5]=datetime[3];
+		t2p->pdf_datetime[6]=datetime[5];
+		t2p->pdf_datetime[7]=datetime[6];
+		t2p->pdf_datetime[8]=datetime[8];
+		t2p->pdf_datetime[9]=datetime[9];
+		t2p->pdf_datetime[10]=datetime[11];
+		t2p->pdf_datetime[11]=datetime[12];
+		t2p->pdf_datetime[12]=datetime[14];
+		t2p->pdf_datetime[13]=datetime[15];
+		t2p->pdf_datetime[14]=datetime[17];
+		t2p->pdf_datetime[15]=datetime[18];
+	} else {
+		t2p_pdf_currenttime(t2p);
+	}
+
+	return;
+}
+
+/*
+ * This function writes a PDF Pages Tree structure to output.
+ */
+
+tsize_t t2p_write_pdf_pages(T2P* t2p, TIFF* output)
+{
+	tsize_t written=0;
+	tdir_t i=0;
+	char buffer[16];
+	int buflen=0;
+
+	int page=0;
+	written += t2pWriteFile(output, 
+		(tdata_t) "<< \n/Type /Pages \n/Kids [ ", 26);
+	page = t2p->pdf_pages+1;
+	for (i=0;i<t2p->tiff_pagecount;i++){
+		buflen=sprintf(buffer, "%d", page);
+		written += t2pWriteFile(output, (tdata_t) buffer, buflen);
+		written += t2pWriteFile(output, (tdata_t) " 0 R ", 5);
+		if ( ((i+1)%8)==0 ) {
+			written += t2pWriteFile(output, (tdata_t) "\n", 1);
+		}
+		page +=3;
+		page += t2p->tiff_pages[i].page_extra;
+		if(t2p->tiff_pages[i].page_tilecount>0){
+			page += (2 * t2p->tiff_pages[i].page_tilecount);
+		} else {
+			page +=2;
+		}
+	}
+	written += t2pWriteFile(output, (tdata_t) "] \n/Count ", 10);
+	_TIFFmemset(buffer, 0x00, 16);
+	buflen=sprintf(buffer, "%d", t2p->tiff_pagecount);
+	written += t2pWriteFile(output, (tdata_t) buffer, buflen);
+	written += t2pWriteFile(output, (tdata_t) " \n>> \n", 6);
+
+	return(written);
+}
+
+/*
+	This function writes a PDF Page structure to output.
+*/
+
+tsize_t t2p_write_pdf_page(uint32 object, T2P* t2p, TIFF* output){
+
+	unsigned int i=0;
+	tsize_t written=0;
+	char buffer[16];
+	int buflen=0;
+	
+	written += t2pWriteFile(output, (tdata_t) "<<\n/Type /Page \n/Parent ", 24);
+	buflen=sprintf(buffer, "%lu", (unsigned long)t2p->pdf_pages);
+	written += t2pWriteFile(output, (tdata_t) buffer, buflen);
+	written += t2pWriteFile(output, (tdata_t) " 0 R \n", 6);
+	written += t2pWriteFile(output, (tdata_t) "/MediaBox [", 11); 
+	buflen=sprintf(buffer, "%.4f",t2p->pdf_mediabox.x1);
+	written += t2pWriteFile(output, (tdata_t) buffer, buflen);
+	written += t2pWriteFile(output, (tdata_t) " ", 1); 
+	buflen=sprintf(buffer, "%.4f",t2p->pdf_mediabox.y1);
+	written += t2pWriteFile(output, (tdata_t) buffer, buflen);
+	written += t2pWriteFile(output, (tdata_t) " ", 1); 
+	buflen=sprintf(buffer, "%.4f",t2p->pdf_mediabox.x2);
+	written += t2pWriteFile(output, (tdata_t) buffer, buflen);
+	written += t2pWriteFile(output, (tdata_t) " ", 1); 
+	buflen=sprintf(buffer, "%.4f",t2p->pdf_mediabox.y2);
+	written += t2pWriteFile(output, (tdata_t) buffer, buflen);
+	written += t2pWriteFile(output, (tdata_t) "] \n", 3); 
+	written += t2pWriteFile(output, (tdata_t) "/Contents ", 10);
+	buflen=sprintf(buffer, "%lu", (unsigned long)(object + 1));
+	written += t2pWriteFile(output, (tdata_t) buffer, buflen);
+	written += t2pWriteFile(output, (tdata_t) " 0 R \n", 6);
+	written += t2pWriteFile(output, (tdata_t) "/Resources << \n", 15);
+	if( t2p->tiff_tiles[t2p->pdf_page].tiles_tilecount != 0 ){
+		written += t2pWriteFile(output, (tdata_t) "/XObject <<\n", 12);
+		for(i=0;i<t2p->tiff_tiles[t2p->pdf_page].tiles_tilecount;i++){
+			written += t2pWriteFile(output, (tdata_t) "/Im", 3);
+			buflen = sprintf(buffer, "%u", t2p->pdf_page+1);
+			written += t2pWriteFile(output, (tdata_t) buffer, buflen);
+			written += t2pWriteFile(output, (tdata_t) "_", 1);
+			buflen = sprintf(buffer, "%u", i+1);
+			written += t2pWriteFile(output, (tdata_t) buffer, buflen);
+			written += t2pWriteFile(output, (tdata_t) " ", 1);
+			buflen = sprintf(
+				buffer, 
+				"%lu", 
+				(unsigned long)(object+3+(2*i)+t2p->tiff_pages[t2p->pdf_page].page_extra)); 
+			written += t2pWriteFile(output, (tdata_t) buffer, buflen);
+			written += t2pWriteFile(output, (tdata_t) " 0 R ", 5);
+			if(i%4==3){
+				written += t2pWriteFile(output, (tdata_t) "\n", 1);
+			}
+		}
+		written += t2pWriteFile(output, (tdata_t) ">>\n", 3);
+	} else {
+			written += t2pWriteFile(output, (tdata_t) "/XObject <<\n", 12);
+			written += t2pWriteFile(output, (tdata_t) "/Im", 3);
+			buflen = sprintf(buffer, "%u", t2p->pdf_page+1);
+			written += t2pWriteFile(output, (tdata_t) buffer, buflen);
+			written += t2pWriteFile(output, (tdata_t) " ", 1);
+			buflen = sprintf(
+				buffer, 
+				"%lu", 
+				(unsigned long)(object+3+(2*i)+t2p->tiff_pages[t2p->pdf_page].page_extra)); 
+			written += t2pWriteFile(output, (tdata_t) buffer, buflen);
+			written += t2pWriteFile(output, (tdata_t) " 0 R ", 5);
+		written += t2pWriteFile(output, (tdata_t) ">>\n", 3);
+	}
+	if(t2p->tiff_transferfunctioncount != 0) {
+		written += t2pWriteFile(output, (tdata_t) "/ExtGState <<", 13);
+		t2pWriteFile(output, (tdata_t) "/GS1 ", 5);
+		buflen = sprintf(
+			buffer, 
+			"%lu", 
+			(unsigned long)(object + 3)); 
+		written += t2pWriteFile(output, (tdata_t) buffer, buflen);
+		written += t2pWriteFile(output, (tdata_t) " 0 R ", 5);
+		written += t2pWriteFile(output, (tdata_t) ">> \n", 4);
+	}
+	written += t2pWriteFile(output, (tdata_t) "/ProcSet [ ", 11);
+	if(t2p->pdf_colorspace == T2P_CS_BILEVEL 
+		|| t2p->pdf_colorspace == T2P_CS_GRAY
+		){
+		written += t2pWriteFile(output, (tdata_t) "/ImageB ", 8);
+	} else {
+		written += t2pWriteFile(output, (tdata_t) "/ImageC ", 8);
+		if(t2p->pdf_colorspace & T2P_CS_PALETTE){
+			written += t2pWriteFile(output, (tdata_t) "/ImageI ", 8);
+		}
+	}
+	written += t2pWriteFile(output, (tdata_t) "]\n>>\n>>\n", 8);
+
+	return(written);
+}
+
+/*
+	This function composes the page size and image and tile locations on a page.
+*/
+
+void t2p_compose_pdf_page(T2P* t2p){
+
+	uint32 i=0;
+	uint32 i2=0;
+	T2P_TILE* tiles=NULL;
+	T2P_BOX* boxp=NULL;
+	uint32 tilecountx=0;
+	uint32 tilecounty=0;
+	uint32 tilewidth=0;
+	uint32 tilelength=0;
+	int istiled=0;
+	float f=0;
+	
+	t2p->pdf_xres = t2p->tiff_xres;
+	t2p->pdf_yres = t2p->tiff_yres;
+	if(t2p->pdf_overrideres) {
+		t2p->pdf_xres = t2p->pdf_defaultxres;
+		t2p->pdf_yres = t2p->pdf_defaultyres;
+	}
+	if(t2p->pdf_xres == 0.0)
+		t2p->pdf_xres = t2p->pdf_defaultxres;
+	if(t2p->pdf_yres == 0.0)
+		t2p->pdf_yres = t2p->pdf_defaultyres;
+	if (t2p->tiff_resunit != RESUNIT_CENTIMETER	/* RESUNIT_NONE and */
+	    && t2p->tiff_resunit != RESUNIT_INCH) {	/* other cases */
+		t2p->pdf_imagewidth = ((float)(t2p->tiff_width))/t2p->pdf_xres;
+		t2p->pdf_imagelength = ((float)(t2p->tiff_length))/t2p->pdf_yres;
+	} else {
+		t2p->pdf_imagewidth = 
+			((float)(t2p->tiff_width))*PS_UNIT_SIZE/t2p->pdf_xres;
+		t2p->pdf_imagelength = 
+			((float)(t2p->tiff_length))*PS_UNIT_SIZE/t2p->pdf_yres;
+	}
+	if(t2p->pdf_overridepagesize != 0) {
+		t2p->pdf_pagewidth = t2p->pdf_defaultpagewidth;
+		t2p->pdf_pagelength = t2p->pdf_defaultpagelength;
+	} else {
+		t2p->pdf_pagewidth = t2p->pdf_imagewidth;
+		t2p->pdf_pagelength = t2p->pdf_imagelength;
+	}
+	t2p->pdf_mediabox.x1=0.0;
+	t2p->pdf_mediabox.y1=0.0;
+	t2p->pdf_mediabox.x2=t2p->pdf_pagewidth;
+	t2p->pdf_mediabox.y2=t2p->pdf_pagelength;
+	t2p->pdf_imagebox.x1=0.0;
+	t2p->pdf_imagebox.y1=0.0;
+	t2p->pdf_imagebox.x2=t2p->pdf_imagewidth;
+	t2p->pdf_imagebox.y2=t2p->pdf_imagelength;
+	if(t2p->pdf_overridepagesize!=0){
+		t2p->pdf_imagebox.x1+=((t2p->pdf_pagewidth-t2p->pdf_imagewidth)/2.0F);
+		t2p->pdf_imagebox.y1+=((t2p->pdf_pagelength-t2p->pdf_imagelength)/2.0F);
+		t2p->pdf_imagebox.x2+=((t2p->pdf_pagewidth-t2p->pdf_imagewidth)/2.0F);
+		t2p->pdf_imagebox.y2+=((t2p->pdf_pagelength-t2p->pdf_imagelength)/2.0F);
+	}
+	if(t2p->tiff_orientation > 4){
+		f=t2p->pdf_mediabox.x2;
+		t2p->pdf_mediabox.x2=t2p->pdf_mediabox.y2;
+		t2p->pdf_mediabox.y2=f;
+	}
+	istiled=((t2p->tiff_tiles[t2p->pdf_page]).tiles_tilecount==0) ? 0 : 1;
+	if(istiled==0){
+		t2p_compose_pdf_page_orient(&(t2p->pdf_imagebox), t2p->tiff_orientation);
+		return;
+	} else {
+		tilewidth=(t2p->tiff_tiles[t2p->pdf_page]).tiles_tilewidth;
+		tilelength=(t2p->tiff_tiles[t2p->pdf_page]).tiles_tilelength;
+		tilecountx=(t2p->tiff_width + 
+			tilewidth -1)/ 
+			tilewidth;
+		(t2p->tiff_tiles[t2p->pdf_page]).tiles_tilecountx=tilecountx;
+		tilecounty=(t2p->tiff_length + 
+			tilelength -1)/ 
+			tilelength;
+		(t2p->tiff_tiles[t2p->pdf_page]).tiles_tilecounty=tilecounty;
+		(t2p->tiff_tiles[t2p->pdf_page]).tiles_edgetilewidth=
+			t2p->tiff_width % tilewidth;
+		(t2p->tiff_tiles[t2p->pdf_page]).tiles_edgetilelength=
+			t2p->tiff_length % tilelength;
+		tiles=(t2p->tiff_tiles[t2p->pdf_page]).tiles_tiles;
+		for(i2=0;i2<tilecounty-1;i2++){
+			for(i=0;i<tilecountx-1;i++){
+				boxp=&(tiles[i2*tilecountx+i].tile_box);
+				boxp->x1 = 
+					t2p->pdf_imagebox.x1 
+					+ ((float)(t2p->pdf_imagewidth * i * tilewidth)
+					/ (float)t2p->tiff_width);
+				boxp->x2 = 
+					t2p->pdf_imagebox.x1 
+					+ ((float)(t2p->pdf_imagewidth * (i+1) * tilewidth)
+					/ (float)t2p->tiff_width);
+				boxp->y1 = 
+					t2p->pdf_imagebox.y2 
+					- ((float)(t2p->pdf_imagelength * (i2+1) * tilelength)
+					/ (float)t2p->tiff_length);
+				boxp->y2 = 
+					t2p->pdf_imagebox.y2 
+					- ((float)(t2p->pdf_imagelength * i2 * tilelength)
+					/ (float)t2p->tiff_length);
+			}
+			boxp=&(tiles[i2*tilecountx+i].tile_box);
+			boxp->x1 = 
+				t2p->pdf_imagebox.x1 
+				+ ((float)(t2p->pdf_imagewidth * i * tilewidth)
+				/ (float)t2p->tiff_width);
+			boxp->x2 = t2p->pdf_imagebox.x2;
+			boxp->y1 = 
+				t2p->pdf_imagebox.y2 
+				- ((float)(t2p->pdf_imagelength * (i2+1) * tilelength)
+				/ (float)t2p->tiff_length);
+			boxp->y2 = 
+				t2p->pdf_imagebox.y2 
+				- ((float)(t2p->pdf_imagelength * i2 * tilelength)
+				/ (float)t2p->tiff_length);
+		}
+		for(i=0;i<tilecountx-1;i++){
+			boxp=&(tiles[i2*tilecountx+i].tile_box);
+			boxp->x1 = 
+				t2p->pdf_imagebox.x1 
+				+ ((float)(t2p->pdf_imagewidth * i * tilewidth)
+				/ (float)t2p->tiff_width);
+			boxp->x2 = 
+				t2p->pdf_imagebox.x1 
+				+ ((float)(t2p->pdf_imagewidth * (i+1) * tilewidth)
+				/ (float)t2p->tiff_width);
+			boxp->y1 = t2p->pdf_imagebox.y1;
+			boxp->y2 = 
+				t2p->pdf_imagebox.y2 
+				- ((float)(t2p->pdf_imagelength * i2 * tilelength)
+				/ (float)t2p->tiff_length);
+		}
+		boxp=&(tiles[i2*tilecountx+i].tile_box);
+		boxp->x1 = 
+			t2p->pdf_imagebox.x1 
+			+ ((float)(t2p->pdf_imagewidth * i * tilewidth)
+			/ (float)t2p->tiff_width);
+		boxp->x2 = t2p->pdf_imagebox.x2;
+		boxp->y1 = t2p->pdf_imagebox.y1;
+		boxp->y2 = 
+			t2p->pdf_imagebox.y2 
+			- ((float)(t2p->pdf_imagelength * i2 * tilelength)
+			/ (float)t2p->tiff_length);
+	}
+	if(t2p->tiff_orientation==0 || t2p->tiff_orientation==1){
+		for(i=0;i<(t2p->tiff_tiles[t2p->pdf_page]).tiles_tilecount;i++){
+			t2p_compose_pdf_page_orient( &(tiles[i].tile_box) , 0);
+		}
+		return;
+	}
+	for(i=0;i<(t2p->tiff_tiles[t2p->pdf_page]).tiles_tilecount;i++){
+		boxp=&(tiles[i].tile_box);
+		boxp->x1 -= t2p->pdf_imagebox.x1;
+		boxp->x2 -= t2p->pdf_imagebox.x1;
+		boxp->y1 -= t2p->pdf_imagebox.y1;
+		boxp->y2 -= t2p->pdf_imagebox.y1;
+		if(t2p->tiff_orientation==2 || t2p->tiff_orientation==3){
+			boxp->x1 = t2p->pdf_imagebox.x2 - t2p->pdf_imagebox.x1 - boxp->x1;
+			boxp->x2 = t2p->pdf_imagebox.x2 - t2p->pdf_imagebox.x1 - boxp->x2;
+		}
+		if(t2p->tiff_orientation==3 || t2p->tiff_orientation==4){
+			boxp->y1 = t2p->pdf_imagebox.y2 - t2p->pdf_imagebox.y1 - boxp->y1;
+			boxp->y2 = t2p->pdf_imagebox.y2 - t2p->pdf_imagebox.y1 - boxp->y2;
+		}
+		if(t2p->tiff_orientation==8 || t2p->tiff_orientation==5){
+			boxp->y1 = t2p->pdf_imagebox.y2 - t2p->pdf_imagebox.y1 - boxp->y1;
+			boxp->y2 = t2p->pdf_imagebox.y2 - t2p->pdf_imagebox.y1 - boxp->y2;
+		}
+		if(t2p->tiff_orientation==5 || t2p->tiff_orientation==6){
+			boxp->x1 = t2p->pdf_imagebox.x2 - t2p->pdf_imagebox.x1 - boxp->x1;
+			boxp->x2 = t2p->pdf_imagebox.x2 - t2p->pdf_imagebox.x1 - boxp->x2;
+		}
+		if(t2p->tiff_orientation > 4){
+			f=boxp->x1;
+			boxp->x1 = boxp->y1;
+			boxp->y1 = f;
+			f=boxp->x2;
+			boxp->x2 = boxp->y2;
+			boxp->y2 = f; 
+			t2p_compose_pdf_page_orient_flip(boxp, t2p->tiff_orientation);
+		} else {
+			t2p_compose_pdf_page_orient(boxp, t2p->tiff_orientation);
+		}
+		
+	}
+
+	return;
+}
+
+void t2p_compose_pdf_page_orient(T2P_BOX* boxp, uint16 orientation){
+
+	float m1[9];
+	float f=0.0;
+	
+	if( boxp->x1 > boxp->x2){
+		f=boxp->x1;
+		boxp->x1=boxp->x2;
+		boxp->x2 = f;
+	}
+	if( boxp->y1 > boxp->y2){
+		f=boxp->y1;
+		boxp->y1=boxp->y2;
+		boxp->y2 = f;
+	}
+	boxp->mat[0]=m1[0]=boxp->x2-boxp->x1;
+	boxp->mat[1]=m1[1]=0.0;
+	boxp->mat[2]=m1[2]=0.0;
+	boxp->mat[3]=m1[3]=0.0;
+	boxp->mat[4]=m1[4]=boxp->y2-boxp->y1;
+	boxp->mat[5]=m1[5]=0.0;
+	boxp->mat[6]=m1[6]=boxp->x1;
+	boxp->mat[7]=m1[7]=boxp->y1;
+	boxp->mat[8]=m1[8]=1.0;
+	switch(orientation){
+		case 0:
+		case 1:
+			break;
+		case 2:
+			boxp->mat[0]=0.0F-m1[0];
+			boxp->mat[6]+=m1[0];
+			break;
+		case 3:
+			boxp->mat[0]=0.0F-m1[0];
+			boxp->mat[4]=0.0F-m1[4];
+			boxp->mat[6]+=m1[0];
+			boxp->mat[7]+=m1[4];
+			break;
+		case 4:
+			boxp->mat[4]=0.0F-m1[4];
+			boxp->mat[7]+=m1[4];
+			break;
+		case 5:
+			boxp->mat[0]=0.0F;
+			boxp->mat[1]=0.0F-m1[0];
+			boxp->mat[3]=0.0F-m1[4];
+			boxp->mat[4]=0.0F;
+			boxp->mat[6]+=m1[4];
+			boxp->mat[7]+=m1[0];
+			break;
+		case 6:
+			boxp->mat[0]=0.0F;
+			boxp->mat[1]=0.0F-m1[0];
+			boxp->mat[3]=m1[4];
+			boxp->mat[4]=0.0F;
+			boxp->mat[7]+=m1[0];
+			break;
+		case 7:
+			boxp->mat[0]=0.0F;
+			boxp->mat[1]=m1[0];
+			boxp->mat[3]=m1[4];
+			boxp->mat[4]=0.0F;
+			break;
+		case 8:
+			boxp->mat[0]=0.0F;
+			boxp->mat[1]=m1[0];
+			boxp->mat[3]=0.0F-m1[4];
+			boxp->mat[4]=0.0F;
+			boxp->mat[6]+=m1[4];
+			break;
+	}
+
+	return;
+}
+
+void t2p_compose_pdf_page_orient_flip(T2P_BOX* boxp, uint16 orientation){
+
+	float m1[9];
+	float f=0.0;
+	
+	if( boxp->x1 > boxp->x2){
+		f=boxp->x1;
+		boxp->x1=boxp->x2;
+		boxp->x2 = f;
+	}
+	if( boxp->y1 > boxp->y2){
+		f=boxp->y1;
+		boxp->y1=boxp->y2;
+		boxp->y2 = f;
+	}
+	boxp->mat[0]=m1[0]=boxp->x2-boxp->x1;
+	boxp->mat[1]=m1[1]=0.0F;
+	boxp->mat[2]=m1[2]=0.0F;
+	boxp->mat[3]=m1[3]=0.0F;
+	boxp->mat[4]=m1[4]=boxp->y2-boxp->y1;
+	boxp->mat[5]=m1[5]=0.0F;
+	boxp->mat[6]=m1[6]=boxp->x1;
+	boxp->mat[7]=m1[7]=boxp->y1;
+	boxp->mat[8]=m1[8]=1.0F;
+	switch(orientation){
+		case 5:
+			boxp->mat[0]=0.0F;
+			boxp->mat[1]=0.0F-m1[4];
+			boxp->mat[3]=0.0F-m1[0];
+			boxp->mat[4]=0.0F;
+			boxp->mat[6]+=m1[0];
+			boxp->mat[7]+=m1[4];
+			break;
+		case 6:
+			boxp->mat[0]=0.0F;
+			boxp->mat[1]=0.0F-m1[4];
+			boxp->mat[3]=m1[0];
+			boxp->mat[4]=0.0F;
+			boxp->mat[7]+=m1[4];
+			break;
+		case 7:
+			boxp->mat[0]=0.0F;
+			boxp->mat[1]=m1[4];
+			boxp->mat[3]=m1[0];
+			boxp->mat[4]=0.0F;
+			break;
+		case 8:
+			boxp->mat[0]=0.0F;
+			boxp->mat[1]=m1[4];
+			boxp->mat[3]=0.0F-m1[0];
+			boxp->mat[4]=0.0F;
+			boxp->mat[6]+=m1[0];
+			break;
+	}
+
+	return;
+}
+
+/*
+	This function writes a PDF Contents stream to output.
+*/
+
+tsize_t t2p_write_pdf_page_content_stream(T2P* t2p, TIFF* output){
+
+	tsize_t written=0;
+	ttile_t i=0;
+	char buffer[512];
+	int buflen=0;
+	T2P_BOX box;
+	
+	if(t2p->tiff_tiles[t2p->pdf_page].tiles_tilecount>0){ 
+		for(i=0;i<t2p->tiff_tiles[t2p->pdf_page].tiles_tilecount; i++){
+			box=t2p->tiff_tiles[t2p->pdf_page].tiles_tiles[i].tile_box;
+			buflen=sprintf(buffer, 
+				"q %s %.4f %.4f %.4f %.4f %.4f %.4f cm /Im%d_%ld Do Q\n", 
+				t2p->tiff_transferfunctioncount?"/GS1 gs ":"",
+				box.mat[0],
+				box.mat[1],
+				box.mat[3],
+				box.mat[4],
+				box.mat[6],
+				box.mat[7],
+				t2p->pdf_page + 1, 
+				(long)(i + 1));
+			written += t2p_write_pdf_stream(buffer, buflen, output);
+		}
+	} else {
+		box=t2p->pdf_imagebox;
+		buflen=sprintf(buffer, 
+			"q %s %.4f %.4f %.4f %.4f %.4f %.4f cm /Im%d Do Q\n", 
+			t2p->tiff_transferfunctioncount?"/GS1 gs ":"",
+			box.mat[0],
+			box.mat[1],
+			box.mat[3],
+			box.mat[4],
+			box.mat[6],
+			box.mat[7],
+			t2p->pdf_page+1);
+		written += t2p_write_pdf_stream(buffer, buflen, output);
+	}
+
+	return(written);
+}
+
+/*
+	This function writes a PDF Image XObject stream dictionary to output. 
+*/
+
+tsize_t t2p_write_pdf_xobject_stream_dict(ttile_t tile, 
+                                                 T2P* t2p, 
+                                                 TIFF* output){
+
+	tsize_t written=0;
+	char buffer[16];
+	int buflen=0;
+
+	written += t2p_write_pdf_stream_dict(0, t2p->pdf_xrefcount+1, output); 
+	written += t2pWriteFile(output, 
+		(tdata_t) "/Type /XObject \n/Subtype /Image \n/Name /Im", 
+		42);
+	buflen=sprintf(buffer, "%u", t2p->pdf_page+1);
+	written += t2pWriteFile(output, (tdata_t) buffer, buflen);
+	if(tile != 0){
+		written += t2pWriteFile(output, (tdata_t) "_", 1);
+		buflen=sprintf(buffer, "%lu", (unsigned long)tile);
+		written += t2pWriteFile(output, (tdata_t) buffer, buflen);
+	}
+	written += t2pWriteFile(output, (tdata_t) "\n/Width ", 8);
+	_TIFFmemset((tdata_t)buffer, 0x00, 16);
+	if(tile==0){
+		buflen=sprintf(buffer, "%lu", (unsigned long)t2p->tiff_width);
+	} else {
+		if(t2p_tile_is_right_edge(t2p->tiff_tiles[t2p->pdf_page], tile-1)!=0){
+			buflen=sprintf(
+				buffer, 
+				"%lu", 
+				(unsigned long)t2p->tiff_tiles[t2p->pdf_page].tiles_edgetilewidth);
+		} else {
+			buflen=sprintf(
+				buffer, 
+				"%lu", 
+				(unsigned long)t2p->tiff_tiles[t2p->pdf_page].tiles_tilewidth);
+		}
+	}
+	written += t2pWriteFile(output, (tdata_t) buffer, buflen);
+	written += t2pWriteFile(output, (tdata_t) "\n/Height ", 9);
+	_TIFFmemset((tdata_t)buffer, 0x00, 16);
+	if(tile==0){
+		buflen=sprintf(buffer, "%lu", (unsigned long)t2p->tiff_length);
+	} else {
+		if(t2p_tile_is_bottom_edge(t2p->tiff_tiles[t2p->pdf_page], tile-1)!=0){
+			buflen=sprintf(
+				buffer, 
+				"%lu", 
+				(unsigned long)t2p->tiff_tiles[t2p->pdf_page].tiles_edgetilelength);
+		} else {
+			buflen=sprintf(
+				buffer, 
+				"%lu", 
+				(unsigned long)t2p->tiff_tiles[t2p->pdf_page].tiles_tilelength);
+		}
+	}
+	written += t2pWriteFile(output, (tdata_t) buffer, buflen);
+	written += t2pWriteFile(output, (tdata_t) "\n/BitsPerComponent ", 19);
+	_TIFFmemset((tdata_t)buffer, 0x00, 16);
+	buflen=sprintf(buffer, "%u", t2p->tiff_bitspersample);
+	written += t2pWriteFile(output, (tdata_t) buffer, buflen);
+	written += t2pWriteFile(output, (tdata_t) "\n/ColorSpace ", 13);
+	written += t2p_write_pdf_xobject_cs(t2p, output);
+	if (t2p->pdf_image_interpolate)
+		written += t2pWriteFile(output,
+					 (tdata_t) "\n/Interpolate true", 18);
+	if( (t2p->pdf_switchdecode != 0)
+#ifdef CCITT_SUPPORT
+		&& ! (t2p->pdf_colorspace == T2P_CS_BILEVEL 
+		&& t2p->pdf_compression == T2P_COMPRESS_G4)
+#endif
+		){
+		written += t2p_write_pdf_xobject_decode(t2p, output);
+	}
+	written += t2p_write_pdf_xobject_stream_filter(tile, t2p, output);
+	
+	return(written);
+}
+
+/*
+ * 	This function writes a PDF Image XObject Colorspace name to output.
+ */
+
+
+tsize_t t2p_write_pdf_xobject_cs(T2P* t2p, TIFF* output){
+
+	tsize_t written=0;
+	char buffer[128];
+	int buflen=0;
+
+	float X_W=1.0;
+	float Y_W=1.0;
+	float Z_W=1.0;
+	
+	if( (t2p->pdf_colorspace & T2P_CS_ICCBASED) != 0){
+		written += t2p_write_pdf_xobject_icccs(t2p, output);
+		return(written);
+	}
+	if( (t2p->pdf_colorspace & T2P_CS_PALETTE) != 0){
+		written += t2pWriteFile(output, (tdata_t) "[ /Indexed ", 11);
+		t2p->pdf_colorspace ^= T2P_CS_PALETTE;
+		written += t2p_write_pdf_xobject_cs(t2p, output);
+		t2p->pdf_colorspace |= T2P_CS_PALETTE;
+		buflen=sprintf(buffer, "%u", (0x0001 << t2p->tiff_bitspersample)-1 );
+		written += t2pWriteFile(output, (tdata_t) buffer, buflen);
+		written += t2pWriteFile(output, (tdata_t) " ", 1);
+		_TIFFmemset(buffer, 0x00, 16);
+		buflen=sprintf(buffer, "%lu", (unsigned long)t2p->pdf_palettecs ); 
+		written += t2pWriteFile(output, (tdata_t) buffer, buflen);
+		written += t2pWriteFile(output, (tdata_t) " 0 R ]\n", 7);
+		return(written);
+	}
+	if(t2p->pdf_colorspace & T2P_CS_BILEVEL){
+			written += t2pWriteFile(output, (tdata_t) "/DeviceGray \n", 13);
+	}
+	if(t2p->pdf_colorspace & T2P_CS_GRAY){
+			if(t2p->pdf_colorspace & T2P_CS_CALGRAY){
+				written += t2p_write_pdf_xobject_calcs(t2p, output);
+			} else {
+				written += t2pWriteFile(output, (tdata_t) "/DeviceGray \n", 13);
+			}
+	}
+	if(t2p->pdf_colorspace & T2P_CS_RGB){
+			if(t2p->pdf_colorspace & T2P_CS_CALRGB){
+				written += t2p_write_pdf_xobject_calcs(t2p, output);
+			} else {
+				written += t2pWriteFile(output, (tdata_t) "/DeviceRGB \n", 12);
+			}
+	}
+	if(t2p->pdf_colorspace & T2P_CS_CMYK){
+			written += t2pWriteFile(output, (tdata_t) "/DeviceCMYK \n", 13);
+	}
+	if(t2p->pdf_colorspace & T2P_CS_LAB){
+			written += t2pWriteFile(output, (tdata_t) "[/Lab << \n", 10);
+			written += t2pWriteFile(output, (tdata_t) "/WhitePoint ", 12);
+			X_W = t2p->tiff_whitechromaticities[0];
+			Y_W = t2p->tiff_whitechromaticities[1];
+			Z_W = 1.0F - (X_W + Y_W);
+			X_W /= Y_W;
+			Z_W /= Y_W;
+			Y_W = 1.0F;
+			buflen=sprintf(buffer, "[%.4f %.4f %.4f] \n", X_W, Y_W, Z_W);
+			written += t2pWriteFile(output, (tdata_t) buffer, buflen);
+			X_W = 0.3457F; /* 0.3127F; */ /* D50, commented D65 */
+			Y_W = 0.3585F; /* 0.3290F; */
+			Z_W = 1.0F - (X_W + Y_W);
+			X_W /= Y_W;
+			Z_W /= Y_W;
+			Y_W = 1.0F;
+			buflen=sprintf(buffer, "[%.4f %.4f %.4f] \n", X_W, Y_W, Z_W);
+			written += t2pWriteFile(output, (tdata_t) buffer, buflen);
+			written += t2pWriteFile(output, (tdata_t) "/Range ", 7);
+			buflen=sprintf(buffer, "[%d %d %d %d] \n", 
+				t2p->pdf_labrange[0], 
+				t2p->pdf_labrange[1], 
+				t2p->pdf_labrange[2], 
+				t2p->pdf_labrange[3]);
+			written += t2pWriteFile(output, (tdata_t) buffer, buflen);
+			written += t2pWriteFile(output, (tdata_t) ">>] \n", 5);
+			
+	}
+	
+	return(written);
+}
+
+tsize_t t2p_write_pdf_transfer(T2P* t2p, TIFF* output){
+
+	tsize_t written=0;
+	char buffer[16];
+	int buflen=0;
+
+	written += t2pWriteFile(output, (tdata_t) "<< /Type /ExtGState \n/TR ", 25);
+	if(t2p->tiff_transferfunctioncount == 1){
+		buflen=sprintf(buffer, "%lu",
+			       (unsigned long)(t2p->pdf_xrefcount + 1));
+		written += t2pWriteFile(output, (tdata_t) buffer, buflen);
+		written += t2pWriteFile(output, (tdata_t) " 0 R ", 5);
+	} else {
+		written += t2pWriteFile(output, (tdata_t) "[ ", 2);
+		buflen=sprintf(buffer, "%lu",
+			       (unsigned long)(t2p->pdf_xrefcount + 1));
+		written += t2pWriteFile(output, (tdata_t) buffer, buflen);
+		written += t2pWriteFile(output, (tdata_t) " 0 R ", 5);
+		buflen=sprintf(buffer, "%lu",
+			       (unsigned long)(t2p->pdf_xrefcount + 2));
+		written += t2pWriteFile(output, (tdata_t) buffer, buflen);
+		written += t2pWriteFile(output, (tdata_t) " 0 R ", 5);
+		buflen=sprintf(buffer, "%lu",
+			       (unsigned long)(t2p->pdf_xrefcount + 3));
+		written += t2pWriteFile(output, (tdata_t) buffer, buflen);
+		written += t2pWriteFile(output, (tdata_t) " 0 R ", 5);
+		written += t2pWriteFile(output, (tdata_t) "/Identity ] ", 12);
+	}
+
+	written += t2pWriteFile(output, (tdata_t) " >> \n", 5);
+
+	return(written);
+}
+
+tsize_t t2p_write_pdf_transfer_dict(T2P* t2p, TIFF* output, uint16 i){
+
+	tsize_t written=0;
+	char buffer[32];
+	int buflen=0;
+	(void)i; // XXX
+
+	written += t2pWriteFile(output, (tdata_t) "/FunctionType 0 \n", 17);
+	written += t2pWriteFile(output, (tdata_t) "/Domain [0.0 1.0] \n", 19);
+	written += t2pWriteFile(output, (tdata_t) "/Range [0.0 1.0] \n", 18);
+	buflen=sprintf(buffer, "/Size [%u] \n", (1<<t2p->tiff_bitspersample));
+	written += t2pWriteFile(output, (tdata_t) buffer, buflen);
+	written += t2pWriteFile(output, (tdata_t) "/BitsPerSample 16 \n", 19);
+	written += t2p_write_pdf_stream_dict(1<<(t2p->tiff_bitspersample+1), 0, output);
+
+	return(written);
+}
+
+tsize_t t2p_write_pdf_transfer_stream(T2P* t2p, TIFF* output, uint16 i){
+
+	tsize_t written=0;
+
+	written += t2p_write_pdf_stream(
+		t2p->tiff_transferfunction[i], 
+		(1<<(t2p->tiff_bitspersample+1)), 
+		output);
+
+	return(written);
+}
+
+/*
+	This function writes a PDF Image XObject Colorspace array to output.
+*/
+
+tsize_t t2p_write_pdf_xobject_calcs(T2P* t2p, TIFF* output){
+
+	tsize_t written=0;
+	char buffer[128];
+	int buflen=0;
+	
+	float X_W=0.0;
+	float Y_W=0.0;
+	float Z_W=0.0;
+	float X_R=0.0;
+	float Y_R=0.0;
+	float Z_R=0.0;
+	float X_G=0.0;
+	float Y_G=0.0;
+	float Z_G=0.0;
+	float X_B=0.0;
+	float Y_B=0.0;
+	float Z_B=0.0;
+	float x_w=0.0;
+	float y_w=0.0;
+	float z_w=0.0;
+	float x_r=0.0;
+	float y_r=0.0;
+	float x_g=0.0;
+	float y_g=0.0;
+	float x_b=0.0;
+	float y_b=0.0;
+	float R=1.0;
+	float G=1.0;
+	float B=1.0;
+	
+	written += t2pWriteFile(output, (tdata_t) "[", 1);
+	if(t2p->pdf_colorspace & T2P_CS_CALGRAY){
+		written += t2pWriteFile(output, (tdata_t) "/CalGray ", 9);
+		X_W = t2p->tiff_whitechromaticities[0];
+		Y_W = t2p->tiff_whitechromaticities[1];
+		Z_W = 1.0F - (X_W + Y_W);
+		X_W /= Y_W;
+		Z_W /= Y_W;
+		Y_W = 1.0F;
+	}
+	if(t2p->pdf_colorspace & T2P_CS_CALRGB){
+		written += t2pWriteFile(output, (tdata_t) "/CalRGB ", 8);
+		x_w = t2p->tiff_whitechromaticities[0];
+		y_w = t2p->tiff_whitechromaticities[1];
+		x_r = t2p->tiff_primarychromaticities[0];
+		y_r = t2p->tiff_primarychromaticities[1];
+		x_g = t2p->tiff_primarychromaticities[2];
+		y_g = t2p->tiff_primarychromaticities[3];
+		x_b = t2p->tiff_primarychromaticities[4];
+		y_b = t2p->tiff_primarychromaticities[5];
+		z_w = y_w * ((x_g - x_b)*y_r - (x_r-x_b)*y_g + (x_r-x_g)*y_b);
+		Y_R = (y_r/R) * ((x_g-x_b)*y_w - (x_w-x_b)*y_g + (x_w-x_g)*y_b) / z_w;
+		X_R = Y_R * x_r / y_r;
+		Z_R = Y_R * (((1-x_r)/y_r)-1);
+		Y_G = ((0.0F-(y_g))/G) * ((x_r-x_b)*y_w - (x_w-x_b)*y_r + (x_w-x_r)*y_b) / z_w;
+		X_G = Y_G * x_g / y_g;
+		Z_G = Y_G * (((1-x_g)/y_g)-1);
+		Y_B = (y_b/B) * ((x_r-x_g)*y_w - (x_w-x_g)*y_r + (x_w-x_r)*y_g) / z_w;
+		X_B = Y_B * x_b / y_b;
+		Z_B = Y_B * (((1-x_b)/y_b)-1);
+		X_W = (X_R * R) + (X_G * G) + (X_B * B);
+		Y_W = (Y_R * R) + (Y_G * G) + (Y_B * B);
+		Z_W = (Z_R * R) + (Z_G * G) + (Z_B * B);
+		X_W /= Y_W;
+		Z_W /= Y_W;
+		Y_W = 1.0;
+	}
+	written += t2pWriteFile(output, (tdata_t) "<< \n", 4);
+	if(t2p->pdf_colorspace & T2P_CS_CALGRAY){
+		written += t2pWriteFile(output, (tdata_t) "/WhitePoint ", 12);
+		buflen=sprintf(buffer, "[%.4f %.4f %.4f] \n", X_W, Y_W, Z_W);
+		written += t2pWriteFile(output, (tdata_t) buffer, buflen);
+		written += t2pWriteFile(output, (tdata_t) "/Gamma 2.2 \n", 12);
+	}
+	if(t2p->pdf_colorspace & T2P_CS_CALRGB){
+		written += t2pWriteFile(output, (tdata_t) "/WhitePoint ", 12);
+		buflen=sprintf(buffer, "[%.4f %.4f %.4f] \n", X_W, Y_W, Z_W);
+		written += t2pWriteFile(output, (tdata_t) buffer, buflen);
+		written += t2pWriteFile(output, (tdata_t) "/Matrix ", 8);
+		buflen=sprintf(buffer, "[%.4f %.4f %.4f %.4f %.4f %.4f %.4f %.4f %.4f] \n", 
+			X_R, Y_R, Z_R, 
+			X_G, Y_G, Z_G, 
+			X_B, Y_B, Z_B); 
+		written += t2pWriteFile(output, (tdata_t) buffer, buflen);
+		written += t2pWriteFile(output, (tdata_t) "/Gamma [2.2 2.2 2.2] \n", 22);
+	}
+	written += t2pWriteFile(output, (tdata_t) ">>] \n", 5);
+
+	return(written);
+}
+
+/*
+	This function writes a PDF Image XObject Colorspace array to output.
+*/
+
+tsize_t t2p_write_pdf_xobject_icccs(T2P* t2p, TIFF* output){
+
+	tsize_t written=0;
+	char buffer[16];
+	int buflen=0;
+	
+	written += t2pWriteFile(output, (tdata_t) "[/ICCBased ", 11);
+	buflen=sprintf(buffer, "%lu", (unsigned long)t2p->pdf_icccs);
+	written += t2pWriteFile(output, (tdata_t) buffer, buflen);
+	written += t2pWriteFile(output, (tdata_t) " 0 R] \n", 7);
+
+	return(written);
+}
+
+tsize_t t2p_write_pdf_xobject_icccs_dict(T2P* t2p, TIFF* output){
+
+	tsize_t written=0;
+	char buffer[16];
+	int buflen=0;
+	
+	written += t2pWriteFile(output, (tdata_t) "/N ", 3);
+	buflen=sprintf(buffer, "%u \n", t2p->tiff_samplesperpixel);
+	written += t2pWriteFile(output, (tdata_t) buffer, buflen);
+	written += t2pWriteFile(output, (tdata_t) "/Alternate ", 11);
+	t2p->pdf_colorspace ^= T2P_CS_ICCBASED;
+	written += t2p_write_pdf_xobject_cs(t2p, output);
+	t2p->pdf_colorspace |= T2P_CS_ICCBASED;
+	written += t2p_write_pdf_stream_dict(t2p->tiff_iccprofilelength, 0, output);
+	
+	return(written);
+}
+
+tsize_t t2p_write_pdf_xobject_icccs_stream(T2P* t2p, TIFF* output){
+
+	tsize_t written=0;
+
+	written += t2p_write_pdf_stream(
+				(tdata_t) t2p->tiff_iccprofile, 
+				(tsize_t) t2p->tiff_iccprofilelength, 
+				output);
+	
+	return(written);
+}
+
+/*
+	This function writes a palette stream for an indexed color space to output.
+*/
+
+tsize_t t2p_write_pdf_xobject_palettecs_stream(T2P* t2p, TIFF* output){
+
+	tsize_t written=0;
+
+	written += t2p_write_pdf_stream(
+				(tdata_t) t2p->pdf_palette, 
+				(tsize_t) t2p->pdf_palettesize, 
+				output);
+	
+	return(written);
+}
+
+/*
+	This function writes a PDF Image XObject Decode array to output.
+*/
+
+tsize_t t2p_write_pdf_xobject_decode(T2P* t2p, TIFF* output){
+
+	tsize_t written=0;
+	int i=0;
+
+	written += t2pWriteFile(output, (tdata_t) "/Decode [ ", 10);
+	for (i=0;i<t2p->tiff_samplesperpixel;i++){
+		written += t2pWriteFile(output, (tdata_t) "1 0 ", 4);
+	}
+	written += t2pWriteFile(output, (tdata_t) "]\n", 2);
+
+	return(written);
+}
+
+/*
+	This function writes a PDF Image XObject stream filter name and parameters to 
+	output.
+*/
+
+tsize_t t2p_write_pdf_xobject_stream_filter(ttile_t tile, T2P* t2p, TIFF* output){
+
+	tsize_t written=0;
+	char buffer[16];
+	int buflen=0;
+
+	if(t2p->pdf_compression==T2P_COMPRESS_NONE){
+		return(written);
+	}
+	written += t2pWriteFile(output, (tdata_t) "/Filter ", 8);
+	switch(t2p->pdf_compression){
+#ifdef CCITT_SUPPORT
+		case T2P_COMPRESS_G4:
+			written += t2pWriteFile(output, (tdata_t) "/CCITTFaxDecode ", 16);
